/*
 * COPYRIGHT NOTICE
 * 
 * The information contained herein and which follows is proprietary information
 * and is the property of PrismTech Corporation. This information is not to be
 * divulged, released, copied, reproduced, or conveyed to unauthorized
 * personnel, companies, or other institutions without the direct and expressed
 * approval in writing of PrismTech Corporation.
 * 
 * DISCLAIMER
 * 
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */
package com.prismtech.idt.idlmm.constraints;

import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IdlmmFactory;
import com.prismtech.idt.idlmm.PrimitiveDef;
import com.prismtech.idt.idlmm.PrimitiveKind;


/**
 * Common abstract class for check bounded model object.
 */
public abstract class BoundedConstraint extends IdlmmConstraint
{

   protected IDLType getContextType ()
   {
      PrimitiveDef result = IdlmmFactory.eINSTANCE.createPrimitiveDef ();
      result.setKind (PrimitiveKind.PK_ULONG);
      return result;
   }
}
