package com.prismtech.idt.idlmm.constraints;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.emf.validation.IValidationContext;

import com.prismtech.idt.idlmm.Repository;


public class CheckEmptyRepository extends IdlmmConstraint
{
   @Override
   public IStatus validate (IValidationContext ctx)
   {
      Repository repository = (Repository) ctx.getTarget ();

      if (repository.getContents ().isEmpty ())
      {
         return ctx.createFailureStatus (null);
      }

      return ctx.createSuccessStatus ();
   }
}
