/*
 * COPYRIGHT NOTICE 
 *
 * The information contained herein and which follows is proprietary
 * information and is the property of PrismTech Corporation.  This
 * information is not to be divulged, released, copied, reproduced, or
 * conveyed to unauthorized personnel, companies, or other institutions
 * without the direct and expressed approval in writing of PrismTech
 * Corporation.
 *
 * DISCLAIMER
 * 
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech")
 * are under any obligation to support the use of this code which is
 * provided without warranty of any kind. PrismTech shall (except as
 * otherwise prohibited by law) have no liability whatsoever in relation
 * to its use.
 */
package com.prismtech.idt.idlmm.constraints;

import org.eclipse.emf.validation.AbstractModelConstraint;

import com.prismtech.idt.idlmm.util.IdlmmDescriber;


/**
 * Base class for idlmm model constraints.
 */
public abstract class IdlmmConstraint extends AbstractModelConstraint
{
   protected String describe (Object object)
   {
      return IdlmmDescriber.describe (object);
   }

   protected String[] describe (Object[] objects)
   {
      return IdlmmDescriber.describe (objects);
   }
}
