/**
 * <copyright>
 * </copyright>
 *
 * $Id: ComponentDef.java,v 1.1 2008/08/22 11:55:33 je Exp $
 */
package com.prismtech.idt.idlmm;

import org.eclipse.emf.common.util.EList;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component Def</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getBaseComponent <em>Base Component</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getSupportedInterfaces <em>Supported Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getAllBaseComponents <em>All Base Components</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getAllSupportedInterfaces <em>All Supported Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getComponentContents <em>Component Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getAllContents <em>All Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getPorts <em>Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getAllPorts <em>All Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getAllUsesPorts <em>All Uses Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getUsesPorts <em>Uses Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getAllProvidesPorts <em>All Provides Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getProvidesPorts <em>Provides Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getConsumesPorts <em>Consumes Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getAllConsumesPorts <em>All Consumes Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getPublishesPorts <em>Publishes Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getAllPublishesPorts <em>All Publishes Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getEmitsPorts <em>Emits Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.ComponentDef#getAllEmitsPorts <em>All Emits Ports</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef()
 * @model
 * @generated
 */
public interface ComponentDef extends Component, Container, AttributeContainer
{
   /**
    * Returns the value of the '<em><b>Component Contents</b></em>' containment reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.ComponentContained}.
    * It is bidirectional and its opposite is '{@link com.prismtech.idt.idlmm.ComponentContained#getContainingComponent <em>Containing Component</em>}'.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Component Contents</em>' containment reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>Component Contents</em>' containment reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_ComponentContents()
    * @see com.prismtech.idt.idlmm.ComponentContained#getContainingComponent
    * @model opposite="containingComponent" containment="true" ordered="false"
    * @generated
    */
   EList<ComponentContained> getComponentContents ();

   /**
    * Returns the value of the '<em><b>All Contents</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.Contained}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>All Contents</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>All Contents</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_AllContents()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<Contained> getAllContents ();

   /**
    * Returns the value of the '<em><b>Ports</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.ComponentPortDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Ports</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>Ports</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_Ports()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<ComponentPortDef> getPorts ();

   /**
    * Returns the value of the '<em><b>All Ports</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.ComponentPortDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>All Ports</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>All Ports</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_AllPorts()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<ComponentPortDef> getAllPorts ();

   /**
    * Returns the value of the '<em><b>All Uses Ports</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.UsesDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>All Uses Ports</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>All Uses Ports</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_AllUsesPorts()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<UsesDef> getAllUsesPorts ();

   /**
    * Returns the value of the '<em><b>Uses Ports</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.UsesDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Uses Ports</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>Uses Ports</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_UsesPorts()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<UsesDef> getUsesPorts ();

   /**
    * Returns the value of the '<em><b>All Provides Ports</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.ProvidesDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>All Provides Ports</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>All Provides Ports</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_AllProvidesPorts()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<ProvidesDef> getAllProvidesPorts ();

   /**
    * Returns the value of the '<em><b>Provides Ports</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.ProvidesDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Provides Ports</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>Provides Ports</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_ProvidesPorts()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<ProvidesDef> getProvidesPorts ();

   /**
    * Returns the value of the '<em><b>Consumes Ports</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.ConsumesDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Consumes Ports</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>Consumes Ports</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_ConsumesPorts()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<ConsumesDef> getConsumesPorts ();

   /**
    * Returns the value of the '<em><b>All Consumes Ports</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.ConsumesDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>All Consumes Ports</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>All Consumes Ports</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_AllConsumesPorts()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<ConsumesDef> getAllConsumesPorts ();

   /**
    * Returns the value of the '<em><b>Publishes Ports</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.PublishesDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Publishes Ports</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>Publishes Ports</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_PublishesPorts()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<PublishesDef> getPublishesPorts ();

   /**
    * Returns the value of the '<em><b>All Publishes Ports</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.PublishesDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>All Publishes Ports</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>All Publishes Ports</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_AllPublishesPorts()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<PublishesDef> getAllPublishesPorts ();

   /**
    * Returns the value of the '<em><b>Emits Ports</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.EmitsDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Emits Ports</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>Emits Ports</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_EmitsPorts()
    * @model transient="true" changeable="false" volatile="true"
    * @generated
    */
   EList<EmitsDef> getEmitsPorts ();

   /**
    * Returns the value of the '<em><b>All Emits Ports</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.EmitsDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>All Emits Ports</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>All Emits Ports</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_AllEmitsPorts()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<EmitsDef> getAllEmitsPorts ();

   /**
    * Returns the value of the '<em><b>Base Component</b></em>' reference.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Base Component</em>' reference isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>Base Component</em>' reference.
    * @see #setBaseComponent(ComponentDef)
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_BaseComponent()
    * @model ordered="false"
    * @generated
    */
   ComponentDef getBaseComponent ();

   /**
    * Sets the value of the '{@link com.prismtech.idt.idlmm.ComponentDef#getBaseComponent <em>Base Component</em>}' reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @param value the new value of the '<em>Base Component</em>' reference.
    * @see #getBaseComponent()
    * @generated
    */
   void setBaseComponent (ComponentDef value);

   /**
    * Returns the value of the '<em><b>Supported Interfaces</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.InterfaceDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Supported Interfaces</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>Supported Interfaces</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_SupportedInterfaces()
    * @model
    * @generated
    */
   EList<InterfaceDef> getSupportedInterfaces ();

   /**
    * Returns the value of the '<em><b>All Base Components</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.ComponentDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>All Base Components</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>All Base Components</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_AllBaseComponents()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<ComponentDef> getAllBaseComponents ();

   /**
    * Returns the value of the '<em><b>All Supported Interfaces</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.InterfaceDef}.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>All Supported Interfaces</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>All Supported Interfaces</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getComponentDef_AllSupportedInterfaces()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<InterfaceDef> getAllSupportedInterfaces ();

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @model kind="operation"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return ComponentDefExt.getPrerequisites (this);'"
    * @generated
    */
   EList<IRObject> getPrerequisites ();

} // ComponentDef
