/**
 * <copyright>
 * </copyright>
 *
 * $Id: ComponentDefImpl.java,v 1.1 2008/08/22 11:55:34 je Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.AttributeContainer;
import com.prismtech.idt.idlmm.AttributeDef;
import com.prismtech.idt.idlmm.ComponentContained;
import com.prismtech.idt.idlmm.ComponentDef;
import com.prismtech.idt.idlmm.ComponentPortDef;
import com.prismtech.idt.idlmm.ConsumesDef;
import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.EmitsDef;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.InterfaceDef;

import com.prismtech.idt.idlmm.ProvidesDef;
import com.prismtech.idt.idlmm.PublishesDef;
import com.prismtech.idt.idlmm.UsesDef;
import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.uml2.common.util.DerivedUnionEObjectEList;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Component Def</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getContents <em>Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getAllAttributes <em>All Attributes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getBaseComponent <em>Base Component</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getSupportedInterfaces <em>Supported Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getAllBaseComponents <em>All Base Components</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getAllSupportedInterfaces <em>All Supported Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getComponentContents <em>Component Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getAllContents <em>All Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getPorts <em>Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getAllPorts <em>All Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getAllUsesPorts <em>All Uses Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getUsesPorts <em>Uses Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getAllProvidesPorts <em>All Provides Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getProvidesPorts <em>Provides Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getConsumesPorts <em>Consumes Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getAllConsumesPorts <em>All Consumes Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getPublishesPorts <em>Publishes Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getAllPublishesPorts <em>All Publishes Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getEmitsPorts <em>Emits Ports</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ComponentDefImpl#getAllEmitsPorts <em>All Emits Ports</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ComponentDefImpl extends ComponentImpl implements ComponentDef
{
   /**
    * The cached value of the '{@link #getBaseComponent() <em>Base Component</em>}' reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getBaseComponent()
    * @generated
    * @ordered
    */
   protected ComponentDef baseComponent;

   /**
    * The cached value of the '{@link #getSupportedInterfaces() <em>Supported Interfaces</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getSupportedInterfaces()
    * @generated
    * @ordered
    */
   protected EList<InterfaceDef> supportedInterfaces;

   /**
    * The cached value of the '{@link #getComponentContents() <em>Component Contents</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getComponentContents()
    * @generated
    * @ordered
    */
   protected EList<ComponentContained> componentContents;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ComponentDefImpl ()
   {
      super ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.COMPONENT_DEF;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<Contained> getContents ()
   {
      return new DerivedUnionEObjectEList<Contained> (Contained.class, this, IdlmmPackage.COMPONENT_DEF__CONTENTS,
            CONTENTS_ESUBSETS);
   }

   /**
    * The array of subset feature identifiers for the '{@link #getContents() <em>Contents</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getContents()
    * @generated
    * @ordered
    */
   protected static final int[] CONTENTS_ESUBSETS = new int[]
   {
      IdlmmPackage.COMPONENT_DEF__COMPONENT_CONTENTS
   };

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<ComponentContained> getComponentContents ()
   {
      if (componentContents == null)
      {
         componentContents = new EObjectContainmentWithInverseEList<ComponentContained> (ComponentContained.class, this,
               IdlmmPackage.COMPONENT_DEF__COMPONENT_CONTENTS, IdlmmPackage.COMPONENT_CONTAINED__CONTAINING_COMPONENT);
      }
      return componentContents;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<Contained> getAllContents ()
   {
      return ComponentDefExt.getAllContents (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ComponentPortDef> getPorts ()
   {
      return ComponentDefExt.getPorts (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ComponentPortDef> getAllPorts ()
   {
      return ComponentDefExt.getAllPorts (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UsesDef> getAllUsesPorts ()
   {
      return ComponentDefExt.getAllUsesPorts (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UsesDef> getUsesPorts ()
   {
      return ComponentDefExt.getUsesPorts (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ProvidesDef> getAllProvidesPorts ()
   {
      return ComponentDefExt.getAllProvidesPorts (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ProvidesDef> getProvidesPorts ()
   {
      return ComponentDefExt.getProvidesPorts (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ConsumesDef> getConsumesPorts ()
   {
      return ComponentDefExt.getConsumesPorts (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ConsumesDef> getAllConsumesPorts ()
   {
      return ComponentDefExt.getAllConsumesPorts (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<PublishesDef> getPublishesPorts ()
   {
      return ComponentDefExt.getPublishesPorts (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<PublishesDef> getAllPublishesPorts ()
   {
      return ComponentDefExt.getAllPublishesPorts (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EmitsDef> getEmitsPorts ()
   {
      return ComponentDefExt.getEmitsPorts (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EmitsDef> getAllEmitsPorts ()
   {
      return ComponentDefExt.getAllEmitsPorts (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ComponentDef getBaseComponent ()
   {
      if (baseComponent != null && baseComponent.eIsProxy ())
      {
         InternalEObject oldBaseComponent = (InternalEObject) baseComponent;
         baseComponent = (ComponentDef) eResolveProxy (oldBaseComponent);
         if (baseComponent != oldBaseComponent)
         {
            if (eNotificationRequired ())
               eNotify (new ENotificationImpl (this, Notification.RESOLVE, IdlmmPackage.COMPONENT_DEF__BASE_COMPONENT,
                     oldBaseComponent, baseComponent));
         }
      }
      return baseComponent;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ComponentDef basicGetBaseComponent ()
   {
      return baseComponent;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setBaseComponent (ComponentDef newBaseComponent)
   {
      ComponentDef oldBaseComponent = baseComponent;
      baseComponent = newBaseComponent;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.COMPONENT_DEF__BASE_COMPONENT, oldBaseComponent,
               baseComponent));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<InterfaceDef> getSupportedInterfaces ()
   {
      if (supportedInterfaces == null)
      {
         supportedInterfaces = new EObjectResolvingEList<InterfaceDef> (InterfaceDef.class, this,
               IdlmmPackage.COMPONENT_DEF__SUPPORTED_INTERFACES);
      }
      return supportedInterfaces;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ComponentDef> getAllBaseComponents ()
   {
      return ComponentDefExt.getAllBaseComponents (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<InterfaceDef> getAllSupportedInterfaces ()
   {
      return ComponentDefExt.getAllSupportedInterfaces (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AttributeDef> getAttributes ()
   {
      return ComponentDefExt.getAttributes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AttributeDef> getAllAttributes ()
   {
      return ComponentDefExt.getAllAttributes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Contained lookup (String name)
   {
      return ContainerExt.lookup (this, name);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<IRObject> getPrerequisites ()
   {
      return ComponentDefExt.getPrerequisites (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Contained lookup (String name, boolean inherited, boolean global)
   {
      return ContainerExt.lookup (this, name, inherited, global);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.COMPONENT_DEF__COMPONENT_CONTENTS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getComponentContents ()).basicAdd (otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.COMPONENT_DEF__COMPONENT_CONTENTS:
            return ((InternalEList<?>) getComponentContents ()).basicRemove (otherEnd, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.COMPONENT_DEF__CONTENTS:
            return getContents ();
         case IdlmmPackage.COMPONENT_DEF__ATTRIBUTES:
            return getAttributes ();
         case IdlmmPackage.COMPONENT_DEF__ALL_ATTRIBUTES:
            return getAllAttributes ();
         case IdlmmPackage.COMPONENT_DEF__BASE_COMPONENT:
            if (resolve)
               return getBaseComponent ();
            return basicGetBaseComponent ();
         case IdlmmPackage.COMPONENT_DEF__SUPPORTED_INTERFACES:
            return getSupportedInterfaces ();
         case IdlmmPackage.COMPONENT_DEF__ALL_BASE_COMPONENTS:
            return getAllBaseComponents ();
         case IdlmmPackage.COMPONENT_DEF__ALL_SUPPORTED_INTERFACES:
            return getAllSupportedInterfaces ();
         case IdlmmPackage.COMPONENT_DEF__COMPONENT_CONTENTS:
            return getComponentContents ();
         case IdlmmPackage.COMPONENT_DEF__ALL_CONTENTS:
            return getAllContents ();
         case IdlmmPackage.COMPONENT_DEF__PORTS:
            return getPorts ();
         case IdlmmPackage.COMPONENT_DEF__ALL_PORTS:
            return getAllPorts ();
         case IdlmmPackage.COMPONENT_DEF__ALL_USES_PORTS:
            return getAllUsesPorts ();
         case IdlmmPackage.COMPONENT_DEF__USES_PORTS:
            return getUsesPorts ();
         case IdlmmPackage.COMPONENT_DEF__ALL_PROVIDES_PORTS:
            return getAllProvidesPorts ();
         case IdlmmPackage.COMPONENT_DEF__PROVIDES_PORTS:
            return getProvidesPorts ();
         case IdlmmPackage.COMPONENT_DEF__CONSUMES_PORTS:
            return getConsumesPorts ();
         case IdlmmPackage.COMPONENT_DEF__ALL_CONSUMES_PORTS:
            return getAllConsumesPorts ();
         case IdlmmPackage.COMPONENT_DEF__PUBLISHES_PORTS:
            return getPublishesPorts ();
         case IdlmmPackage.COMPONENT_DEF__ALL_PUBLISHES_PORTS:
            return getAllPublishesPorts ();
         case IdlmmPackage.COMPONENT_DEF__EMITS_PORTS:
            return getEmitsPorts ();
         case IdlmmPackage.COMPONENT_DEF__ALL_EMITS_PORTS:
            return getAllEmitsPorts ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.COMPONENT_DEF__BASE_COMPONENT:
            setBaseComponent ((ComponentDef) newValue);
            return;
         case IdlmmPackage.COMPONENT_DEF__SUPPORTED_INTERFACES:
            getSupportedInterfaces ().clear ();
            getSupportedInterfaces ().addAll ((Collection<? extends InterfaceDef>) newValue);
            return;
         case IdlmmPackage.COMPONENT_DEF__COMPONENT_CONTENTS:
            getComponentContents ().clear ();
            getComponentContents ().addAll ((Collection<? extends ComponentContained>) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.COMPONENT_DEF__BASE_COMPONENT:
            setBaseComponent ((ComponentDef) null);
            return;
         case IdlmmPackage.COMPONENT_DEF__SUPPORTED_INTERFACES:
            getSupportedInterfaces ().clear ();
            return;
         case IdlmmPackage.COMPONENT_DEF__COMPONENT_CONTENTS:
            getComponentContents ().clear ();
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.COMPONENT_DEF__CONTENTS:
            return isSetContents ();
         case IdlmmPackage.COMPONENT_DEF__ATTRIBUTES:
            return !getAttributes ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__ALL_ATTRIBUTES:
            return !getAllAttributes ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__BASE_COMPONENT:
            return baseComponent != null;
         case IdlmmPackage.COMPONENT_DEF__SUPPORTED_INTERFACES:
            return supportedInterfaces != null && !supportedInterfaces.isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__ALL_BASE_COMPONENTS:
            return !getAllBaseComponents ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__ALL_SUPPORTED_INTERFACES:
            return !getAllSupportedInterfaces ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__COMPONENT_CONTENTS:
            return componentContents != null && !componentContents.isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__ALL_CONTENTS:
            return !getAllContents ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__PORTS:
            return !getPorts ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__ALL_PORTS:
            return !getAllPorts ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__ALL_USES_PORTS:
            return !getAllUsesPorts ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__USES_PORTS:
            return !getUsesPorts ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__ALL_PROVIDES_PORTS:
            return !getAllProvidesPorts ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__PROVIDES_PORTS:
            return !getProvidesPorts ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__CONSUMES_PORTS:
            return !getConsumesPorts ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__ALL_CONSUMES_PORTS:
            return !getAllConsumesPorts ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__PUBLISHES_PORTS:
            return !getPublishesPorts ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__ALL_PUBLISHES_PORTS:
            return !getAllPublishesPorts ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__EMITS_PORTS:
            return !getEmitsPorts ().isEmpty ();
         case IdlmmPackage.COMPONENT_DEF__ALL_EMITS_PORTS:
            return !getAllEmitsPorts ().isEmpty ();
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == Container.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.COMPONENT_DEF__CONTENTS:
               return IdlmmPackage.CONTAINER__CONTENTS;
            default:
               return -1;
         }
      }
      if (baseClass == AttributeContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.COMPONENT_DEF__ATTRIBUTES:
               return IdlmmPackage.ATTRIBUTE_CONTAINER__ATTRIBUTES;
            case IdlmmPackage.COMPONENT_DEF__ALL_ATTRIBUTES:
               return IdlmmPackage.ATTRIBUTE_CONTAINER__ALL_ATTRIBUTES;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == Container.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINER__CONTENTS:
               return IdlmmPackage.COMPONENT_DEF__CONTENTS;
            default:
               return -1;
         }
      }
      if (baseClass == AttributeContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ATTRIBUTE_CONTAINER__ATTRIBUTES:
               return IdlmmPackage.COMPONENT_DEF__ATTRIBUTES;
            case IdlmmPackage.ATTRIBUTE_CONTAINER__ALL_ATTRIBUTES:
               return IdlmmPackage.COMPONENT_DEF__ALL_ATTRIBUTES;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContents ()
   {
      return eIsSet (IdlmmPackage.COMPONENT_DEF__COMPONENT_CONTENTS);
   }

} //ComponentDefImpl
