/**
 * <copyright>
 * </copyright>
 *
 * $Id: ConstantDefImpl.java,v 1.39 2009/09/04 09:24:29 je Exp $
 */
package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import com.prismtech.idt.idlmm.ConstantDef;
import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.ExpressionContext;
import com.prismtech.idt.idlmm.HomeContained;
import com.prismtech.idt.idlmm.HomeDef;
import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.InterfaceContained;
import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.ModuleContained;
import com.prismtech.idt.idlmm.ModuleDef;
import com.prismtech.idt.idlmm.Named;
import com.prismtech.idt.idlmm.OwnedExpression;
import com.prismtech.idt.idlmm.Repository;
import com.prismtech.idt.idlmm.RepositoryContained;
import com.prismtech.idt.idlmm.SharedExpression;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Constant Def</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getKey <em>Key</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getContainer <em>Container</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getAbsoluteName <em>Absolute Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getPrefix <em>Prefix</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getID <em>ID</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getVersion <em>Version</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getContainingRepository <em>Containing Repository</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getContainingModule <em>Containing Module</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getContainingInterface <em>Containing Interface</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getContainingHome <em>Containing Home</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getValue <em>Value</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ConstantDefImpl#getOwnedValue <em>Owned Value</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ConstantDefImpl extends TypedImpl implements ConstantDef
{
   /**
    * The default value of the '{@link #getName() <em>Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getName()
    * @generated
    * @ordered
    */
   protected static final String NAME_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getName()
    * @generated
    * @ordered
    */
   protected String name = NAME_EDEFAULT;

   /**
    * The default value of the '{@link #getKey() <em>Key</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getKey()
    * @generated
    * @ordered
    */
   protected static final String KEY_EDEFAULT = null;

   /**
    * The default value of the '{@link #getAbsoluteName() <em>Absolute Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getAbsoluteName()
    * @generated
    * @ordered
    */
   protected static final String ABSOLUTE_NAME_EDEFAULT = null;

   /**
    * The default value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected static final String PREFIX_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected String prefix = PREFIX_EDEFAULT;

   /**
    * The default value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected static final String ID_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected String id = ID_EDEFAULT;

   /**
    * The default value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected static final String VERSION_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected String version = VERSION_EDEFAULT;

   /**
    * The cached value of the '{@link #getValue() <em>Value</em>}' reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getValue()
    * @generated
    * @ordered
    */
   protected Expression value;

   /**
    * The cached value of the '{@link #getOwnedValue() <em>Owned Value</em>}' containment reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getOwnedValue()
    * @generated
    * @ordered
    */
   protected OwnedExpression ownedValue;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   protected ConstantDefImpl ()
   {
      super ();
      eAdapters ().add (new ConstantDefOwnedValueAdapter ());
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.CONSTANT_DEF;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getName ()
   {
      return name;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setName (String newName)
   {
      String oldName = name;
      name = newName;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.CONSTANT_DEF__NAME, oldName, name));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getKey ()
   {
      return NamedExt.getKey (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Expression getValue ()
   {
      if (value != null && value.eIsProxy ())
      {
         InternalEObject oldValue = (InternalEObject) value;
         value = (Expression) eResolveProxy (oldValue);
         if (value != oldValue)
         {
            if (eNotificationRequired ())
               eNotify (new ENotificationImpl (this, Notification.RESOLVE, IdlmmPackage.CONSTANT_DEF__VALUE, oldValue, value));
         }
      }
      return value;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Expression basicGetValue ()
   {
      return value;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setValue (Expression newValue)
   {
      Expression oldValue = value;
      value = newValue;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.CONSTANT_DEF__VALUE, oldValue, value));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public OwnedExpression getOwnedValue ()
   {
      return ownedValue;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetOwnedValue (OwnedExpression newOwnedValue, NotificationChain msgs)
   {
      OwnedExpression oldOwnedValue = ownedValue;
      ownedValue = newOwnedValue;
      if (eNotificationRequired ())
      {
         ENotificationImpl notification = new ENotificationImpl (this, Notification.SET, IdlmmPackage.CONSTANT_DEF__OWNED_VALUE,
               oldOwnedValue, newOwnedValue);
         if (msgs == null)
            msgs = notification;
         else
            msgs.add (notification);
      }
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setOwnedValue (OwnedExpression newOwnedValue)
   {
      if (newOwnedValue != ownedValue)
      {
         NotificationChain msgs = null;
         if (ownedValue != null)
            msgs = ((InternalEObject) ownedValue).eInverseRemove (this, EOPPOSITE_FEATURE_BASE
                  - IdlmmPackage.CONSTANT_DEF__OWNED_VALUE, null, msgs);
         if (newOwnedValue != null)
            msgs = ((InternalEObject) newOwnedValue).eInverseAdd (this, EOPPOSITE_FEATURE_BASE
                  - IdlmmPackage.CONSTANT_DEF__OWNED_VALUE, null, msgs);
         msgs = basicSetOwnedValue (newOwnedValue, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.CONSTANT_DEF__OWNED_VALUE, newOwnedValue,
               newOwnedValue));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public void setContainer (Container newContainer)
   {
      ContainedExt.setContainer (this, newContainer);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Container getContainer ()
   {
      Container container = basicGetContainer ();
      return container != null && container.eIsProxy () ? (Container) eResolveProxy ((InternalEObject) container) : container;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Container basicGetContainer ()
   {
      Repository containingRepository = getContainingRepository ();
      if (containingRepository != null)
      {
         return containingRepository;
      }
      ModuleDef containingModule = getContainingModule ();
      if (containingModule != null)
      {
         return containingModule;
      }
      InterfaceDef containingInterface = getContainingInterface ();
      if (containingInterface != null)
      {
         return containingInterface;
      }
      HomeDef containingHome = getContainingHome ();
      if (containingHome != null)
      {
         return containingHome;
      }
      return null;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getAbsoluteName ()
   {
      return ContainedExt.getAbsoluteName (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getPrefix ()
   {
      return prefix;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setPrefix (String newPrefix)
   {
      String oldPrefix = prefix;
      prefix = newPrefix;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.CONSTANT_DEF__PREFIX, oldPrefix, prefix));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getID ()
   {
      return ContainedExt.getID (this, id);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setID (String newID)
   {
      String oldID = id;
      id = newID;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.CONSTANT_DEF__ID, oldID, id));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getVersion ()
   {
      return version;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setVersion (String newVersion)
   {
      String oldVersion = version;
      version = newVersion;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.CONSTANT_DEF__VERSION, oldVersion, version));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Repository getContainingRepository ()
   {
      if (eContainerFeatureID != IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY)
         return null;
      return (Repository) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingRepository (Repository newContainingRepository, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingRepository, IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingRepository (Repository newContainingRepository)
   {
      if (newContainingRepository != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY && newContainingRepository != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingRepository))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingRepository != null)
            msgs = ((InternalEObject) newContainingRepository).eInverseAdd (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS,
                  Repository.class, msgs);
         msgs = basicSetContainingRepository (newContainingRepository, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY,
               newContainingRepository, newContainingRepository));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ModuleDef getContainingModule ()
   {
      if (eContainerFeatureID != IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE)
         return null;
      return (ModuleDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingModule (ModuleDef newContainingModule, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingModule, IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingModule (ModuleDef newContainingModule)
   {
      if (newContainingModule != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE && newContainingModule != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingModule))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingModule != null)
            msgs = ((InternalEObject) newContainingModule).eInverseAdd (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS,
                  ModuleDef.class, msgs);
         msgs = basicSetContainingModule (newContainingModule, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE, newContainingModule,
               newContainingModule));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public InterfaceDef getContainingInterface ()
   {
      if (eContainerFeatureID != IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE)
         return null;
      return (InterfaceDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingInterface (InterfaceDef newContainingInterface, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingInterface, IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingInterface (InterfaceDef newContainingInterface)
   {
      if (newContainingInterface != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE && newContainingInterface != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingInterface))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingInterface != null)
            msgs = ((InternalEObject) newContainingInterface).eInverseAdd (this, IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS,
                  InterfaceDef.class, msgs);
         msgs = basicSetContainingInterface (newContainingInterface, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE,
               newContainingInterface, newContainingInterface));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public HomeDef getContainingHome ()
   {
      if (eContainerFeatureID != IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME)
         return null;
      return (HomeDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingHome (HomeDef newContainingHome, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingHome, IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingHome (HomeDef newContainingHome)
   {
      if (newContainingHome != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME && newContainingHome != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingHome))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingHome != null)
            msgs = ((InternalEObject) newContainingHome).eInverseAdd (this, IdlmmPackage.HOME_DEF__HOME_CONTENTS, HomeDef.class,
                  msgs);
         msgs = basicSetContainingHome (newContainingHome, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME, newContainingHome,
               newContainingHome));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Object getExpressionValue ()
   {
      return ConstantDefExt.getExpressionValue (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public IDLType getExpressionType ()
   {
      return ConstantDefExt.getExpressionType (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<IRObject> getPrerequisites ()
   {
      return ConstantDefExt.getPrerequisites (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingRepository ((Repository) otherEnd, msgs);
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingModule ((ModuleDef) otherEnd, msgs);
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingInterface ((InterfaceDef) otherEnd, msgs);
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingHome ((HomeDef) otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY:
            return basicSetContainingRepository (null, msgs);
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE:
            return basicSetContainingModule (null, msgs);
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE:
            return basicSetContainingInterface (null, msgs);
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME:
            return basicSetContainingHome (null, msgs);
         case IdlmmPackage.CONSTANT_DEF__OWNED_VALUE:
            return basicSetOwnedValue (null, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature (NotificationChain msgs)
   {
      switch (eContainerFeatureID)
      {
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY:
            return eInternalContainer ()
                  .eInverseRemove (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS, Repository.class, msgs);
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS, ModuleDef.class, msgs);
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS, InterfaceDef.class,
                  msgs);
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.HOME_DEF__HOME_CONTENTS, HomeDef.class, msgs);
      }
      return super.eBasicRemoveFromContainerFeature (msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.CONSTANT_DEF__NAME:
            return getName ();
         case IdlmmPackage.CONSTANT_DEF__KEY:
            return getKey ();
         case IdlmmPackage.CONSTANT_DEF__CONTAINER:
            if (resolve)
               return getContainer ();
            return basicGetContainer ();
         case IdlmmPackage.CONSTANT_DEF__ABSOLUTE_NAME:
            return getAbsoluteName ();
         case IdlmmPackage.CONSTANT_DEF__PREFIX:
            return getPrefix ();
         case IdlmmPackage.CONSTANT_DEF__ID:
            return getID ();
         case IdlmmPackage.CONSTANT_DEF__VERSION:
            return getVersion ();
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY:
            return getContainingRepository ();
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE:
            return getContainingModule ();
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE:
            return getContainingInterface ();
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME:
            return getContainingHome ();
         case IdlmmPackage.CONSTANT_DEF__VALUE:
            if (resolve)
               return getValue ();
            return basicGetValue ();
         case IdlmmPackage.CONSTANT_DEF__OWNED_VALUE:
            return getOwnedValue ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.CONSTANT_DEF__NAME:
            setName ((String) newValue);
            return;
         case IdlmmPackage.CONSTANT_DEF__CONTAINER:
            setContainer ((Container) newValue);
            return;
         case IdlmmPackage.CONSTANT_DEF__PREFIX:
            setPrefix ((String) newValue);
            return;
         case IdlmmPackage.CONSTANT_DEF__ID:
            setID ((String) newValue);
            return;
         case IdlmmPackage.CONSTANT_DEF__VERSION:
            setVersion ((String) newValue);
            return;
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) newValue);
            return;
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) newValue);
            return;
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE:
            setContainingInterface ((InterfaceDef) newValue);
            return;
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME:
            setContainingHome ((HomeDef) newValue);
            return;
         case IdlmmPackage.CONSTANT_DEF__VALUE:
            setValue ((Expression) newValue);
            return;
         case IdlmmPackage.CONSTANT_DEF__OWNED_VALUE:
            setOwnedValue ((OwnedExpression) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.CONSTANT_DEF__NAME:
            setName (NAME_EDEFAULT);
            return;
         case IdlmmPackage.CONSTANT_DEF__CONTAINER:
            setContainer ((Container) null);
            return;
         case IdlmmPackage.CONSTANT_DEF__PREFIX:
            setPrefix (PREFIX_EDEFAULT);
            return;
         case IdlmmPackage.CONSTANT_DEF__ID:
            setID (ID_EDEFAULT);
            return;
         case IdlmmPackage.CONSTANT_DEF__VERSION:
            setVersion (VERSION_EDEFAULT);
            return;
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) null);
            return;
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) null);
            return;
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE:
            setContainingInterface ((InterfaceDef) null);
            return;
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME:
            setContainingHome ((HomeDef) null);
            return;
         case IdlmmPackage.CONSTANT_DEF__VALUE:
            setValue ((Expression) null);
            return;
         case IdlmmPackage.CONSTANT_DEF__OWNED_VALUE:
            setOwnedValue ((OwnedExpression) null);
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.CONSTANT_DEF__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals (name);
         case IdlmmPackage.CONSTANT_DEF__KEY:
            return KEY_EDEFAULT == null ? getKey () != null : !KEY_EDEFAULT.equals (getKey ());
         case IdlmmPackage.CONSTANT_DEF__CONTAINER:
            return isSetContainer ();
         case IdlmmPackage.CONSTANT_DEF__ABSOLUTE_NAME:
            return ABSOLUTE_NAME_EDEFAULT == null ? getAbsoluteName () != null : !ABSOLUTE_NAME_EDEFAULT
                  .equals (getAbsoluteName ());
         case IdlmmPackage.CONSTANT_DEF__PREFIX:
            return PREFIX_EDEFAULT == null ? prefix != null : !PREFIX_EDEFAULT.equals (prefix);
         case IdlmmPackage.CONSTANT_DEF__ID:
            return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals (id);
         case IdlmmPackage.CONSTANT_DEF__VERSION:
            return VERSION_EDEFAULT == null ? version != null : !VERSION_EDEFAULT.equals (version);
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY:
            return getContainingRepository () != null;
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE:
            return getContainingModule () != null;
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE:
            return getContainingInterface () != null;
         case IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME:
            return getContainingHome () != null;
         case IdlmmPackage.CONSTANT_DEF__VALUE:
            return value != null;
         case IdlmmPackage.CONSTANT_DEF__OWNED_VALUE:
            return ownedValue != null;
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == Named.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.CONSTANT_DEF__NAME:
               return IdlmmPackage.NAMED__NAME;
            case IdlmmPackage.CONSTANT_DEF__KEY:
               return IdlmmPackage.NAMED__KEY;
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.CONSTANT_DEF__ABSOLUTE_NAME:
               return IdlmmPackage.CONTAINED__ABSOLUTE_NAME;
            case IdlmmPackage.CONSTANT_DEF__PREFIX:
               return IdlmmPackage.CONTAINED__PREFIX;
            case IdlmmPackage.CONSTANT_DEF__ID:
               return IdlmmPackage.CONTAINED__ID;
            case IdlmmPackage.CONSTANT_DEF__VERSION:
               return IdlmmPackage.CONTAINED__VERSION;
            case IdlmmPackage.CONSTANT_DEF__CONTAINER:
               return IdlmmPackage.CONTAINED__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == RepositoryContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY:
               return IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE:
               return IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == InterfaceContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE:
               return IdlmmPackage.INTERFACE_CONTAINED__CONTAINING_INTERFACE;
            default:
               return -1;
         }
      }
      if (baseClass == Expression.class)
      {
         switch (derivedFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == SharedExpression.class)
      {
         switch (derivedFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == ExpressionContext.class)
      {
         switch (derivedFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == HomeContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME:
               return IdlmmPackage.HOME_CONTAINED__CONTAINING_HOME;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == Named.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.NAMED__NAME:
               return IdlmmPackage.CONSTANT_DEF__NAME;
            case IdlmmPackage.NAMED__KEY:
               return IdlmmPackage.CONSTANT_DEF__KEY;
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINED__ABSOLUTE_NAME:
               return IdlmmPackage.CONSTANT_DEF__ABSOLUTE_NAME;
            case IdlmmPackage.CONTAINED__PREFIX:
               return IdlmmPackage.CONSTANT_DEF__PREFIX;
            case IdlmmPackage.CONTAINED__ID:
               return IdlmmPackage.CONSTANT_DEF__ID;
            case IdlmmPackage.CONTAINED__VERSION:
               return IdlmmPackage.CONSTANT_DEF__VERSION;
            case IdlmmPackage.CONTAINED__CONTAINER:
               return IdlmmPackage.CONSTANT_DEF__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == RepositoryContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY:
               return IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE:
               return IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == InterfaceContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.INTERFACE_CONTAINED__CONTAINING_INTERFACE:
               return IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE;
            default:
               return -1;
         }
      }
      if (baseClass == Expression.class)
      {
         switch (baseFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == SharedExpression.class)
      {
         switch (baseFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == ExpressionContext.class)
      {
         switch (baseFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == HomeContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.HOME_CONTAINED__CONTAINING_HOME:
               return IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String toString ()
   {
      if (eIsProxy ())
         return super.toString ();

      StringBuffer result = new StringBuffer (super.toString ());
      result.append (" (name: ");
      result.append (name);
      result.append (", prefix: ");
      result.append (prefix);
      result.append (", ID: ");
      result.append (id);
      result.append (", version: ");
      result.append (version);
      result.append (')');
      return result.toString ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContainer ()
   {
      return eIsSet (IdlmmPackage.CONSTANT_DEF__CONTAINING_REPOSITORY) || eIsSet (IdlmmPackage.CONSTANT_DEF__CONTAINING_MODULE)
            || eIsSet (IdlmmPackage.CONSTANT_DEF__CONTAINING_INTERFACE) || eIsSet (IdlmmPackage.CONSTANT_DEF__CONTAINING_HOME);
   }

} //ConstantDefImpl
