/**
 * <copyright>
 * </copyright>
 *
 * $Id: EnumDefImpl.java,v 1.27 2009/09/04 09:24:29 je Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.EnumContained;
import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.EnumMember;
import com.prismtech.idt.idlmm.ExceptionContained;
import com.prismtech.idt.idlmm.ExceptionDef;
import com.prismtech.idt.idlmm.HomeContained;
import com.prismtech.idt.idlmm.HomeDef;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;

import com.prismtech.idt.idlmm.InterfaceContained;
import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.ModuleContained;
import com.prismtech.idt.idlmm.ModuleDef;
import com.prismtech.idt.idlmm.Repository;
import com.prismtech.idt.idlmm.RepositoryContained;
import com.prismtech.idt.idlmm.StructContained;
import com.prismtech.idt.idlmm.StructDef;
import com.prismtech.idt.idlmm.UnionContained;
import com.prismtech.idt.idlmm.UnionDef;
import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.uml2.common.util.DerivedUnionEObjectEList;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Enum Def</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumDefImpl#getContainer <em>Container</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumDefImpl#getContainingRepository <em>Containing Repository</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumDefImpl#getContainingModule <em>Containing Module</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumDefImpl#getContainingException <em>Containing Exception</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumDefImpl#getContainingStruct <em>Containing Struct</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumDefImpl#getContainingUnion <em>Containing Union</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumDefImpl#getContainingInterface <em>Containing Interface</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumDefImpl#getContents <em>Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumDefImpl#getContainingHome <em>Containing Home</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumDefImpl#getEnumContents <em>Enum Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumDefImpl#getMembers <em>Members</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class EnumDefImpl extends TypedefDefImpl implements EnumDef
{
   /**
    * The cached value of the '{@link #getEnumContents() <em>Enum Contents</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getEnumContents()
    * @generated
    * @ordered
    */
   protected EList<EnumContained> enumContents;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected EnumDefImpl ()
   {
      super ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.ENUM_DEF;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Container getContainer ()
   {
      Container container = basicGetContainer ();
      return container != null && container.eIsProxy () ? (Container) eResolveProxy ((InternalEObject) container) : container;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Container basicGetContainer ()
   {
      Repository containingRepository = getContainingRepository ();
      if (containingRepository != null)
      {
         return containingRepository;
      }
      ModuleDef containingModule = getContainingModule ();
      if (containingModule != null)
      {
         return containingModule;
      }
      ExceptionDef containingException = getContainingException ();
      if (containingException != null)
      {
         return containingException;
      }
      StructDef containingStruct = getContainingStruct ();
      if (containingStruct != null)
      {
         return containingStruct;
      }
      UnionDef containingUnion = getContainingUnion ();
      if (containingUnion != null)
      {
         return containingUnion;
      }
      InterfaceDef containingInterface = getContainingInterface ();
      if (containingInterface != null)
      {
         return containingInterface;
      }
      HomeDef containingHome = getContainingHome ();
      if (containingHome != null)
      {
         return containingHome;
      }
      return super.basicGetContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<EnumContained> getEnumContents ()
   {
      if (enumContents == null)
      {
         enumContents = new EObjectContainmentWithInverseEList<EnumContained> (EnumContained.class, this,
               IdlmmPackage.ENUM_DEF__ENUM_CONTENTS, IdlmmPackage.ENUM_CONTAINED__CONTAINING_ENUM);
      }
      return enumContents;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<Contained> getContents ()
   {
      return new DerivedUnionEObjectEList<Contained> (Contained.class, this, IdlmmPackage.ENUM_DEF__CONTENTS, CONTENTS_ESUBSETS);
   }

   /**
    * The array of subset feature identifiers for the '{@link #getContents() <em>Contents</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getContents()
    * @generated
    * @ordered
    */
   protected static final int[] CONTENTS_ESUBSETS = new int[]
   {
      IdlmmPackage.ENUM_DEF__ENUM_CONTENTS
   };

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public HomeDef getContainingHome ()
   {
      if (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_HOME)
         return null;
      return (HomeDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingHome (HomeDef newContainingHome, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingHome, IdlmmPackage.ENUM_DEF__CONTAINING_HOME, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingHome (HomeDef newContainingHome)
   {
      if (newContainingHome != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_HOME && newContainingHome != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingHome))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingHome != null)
            msgs = ((InternalEObject) newContainingHome).eInverseAdd (this, IdlmmPackage.HOME_DEF__HOME_CONTENTS, HomeDef.class,
                  msgs);
         msgs = basicSetContainingHome (newContainingHome, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ENUM_DEF__CONTAINING_HOME, newContainingHome,
               newContainingHome));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Contained lookup (String name)
   {
      return ContainerExt.lookup (this, name);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<IRObject> getPrerequisites ()
   {
      return ContainerExt.getPrerequisites (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Contained lookup (String name, boolean inherited, boolean global)
   {
      return ContainerExt.lookup (this, name, inherited, global);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   @Override
   public void setContainer (Container newContainer)
   {
      ContainedExt.setContainer (this, newContainer);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Repository getContainingRepository ()
   {
      if (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY)
         return null;
      return (Repository) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingRepository (Repository newContainingRepository, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingRepository, IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingRepository (Repository newContainingRepository)
   {
      if (newContainingRepository != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY && newContainingRepository != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingRepository))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingRepository != null)
            msgs = ((InternalEObject) newContainingRepository).eInverseAdd (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS,
                  Repository.class, msgs);
         msgs = basicSetContainingRepository (newContainingRepository, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY,
               newContainingRepository, newContainingRepository));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ModuleDef getContainingModule ()
   {
      if (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_MODULE)
         return null;
      return (ModuleDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingModule (ModuleDef newContainingModule, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingModule, IdlmmPackage.ENUM_DEF__CONTAINING_MODULE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingModule (ModuleDef newContainingModule)
   {
      if (newContainingModule != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_MODULE && newContainingModule != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingModule))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingModule != null)
            msgs = ((InternalEObject) newContainingModule).eInverseAdd (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS,
                  ModuleDef.class, msgs);
         msgs = basicSetContainingModule (newContainingModule, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ENUM_DEF__CONTAINING_MODULE, newContainingModule,
               newContainingModule));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ExceptionDef getContainingException ()
   {
      if (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION)
         return null;
      return (ExceptionDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingException (ExceptionDef newContainingException, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingException, IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingException (ExceptionDef newContainingException)
   {
      if (newContainingException != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION && newContainingException != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingException))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingException != null)
            msgs = ((InternalEObject) newContainingException).eInverseAdd (this, IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS,
                  ExceptionDef.class, msgs);
         msgs = basicSetContainingException (newContainingException, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION,
               newContainingException, newContainingException));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public StructDef getContainingStruct ()
   {
      if (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT)
         return null;
      return (StructDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingStruct (StructDef newContainingStruct, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingStruct, IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingStruct (StructDef newContainingStruct)
   {
      if (newContainingStruct != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT && newContainingStruct != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingStruct))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingStruct != null)
            msgs = ((InternalEObject) newContainingStruct).eInverseAdd (this, IdlmmPackage.STRUCT_DEF__STRUCT_CONTENTS,
                  StructDef.class, msgs);
         msgs = basicSetContainingStruct (newContainingStruct, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT, newContainingStruct,
               newContainingStruct));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public UnionDef getContainingUnion ()
   {
      if (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_UNION)
         return null;
      return (UnionDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingUnion (UnionDef newContainingUnion, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingUnion, IdlmmPackage.ENUM_DEF__CONTAINING_UNION, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingUnion (UnionDef newContainingUnion)
   {
      if (newContainingUnion != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_UNION && newContainingUnion != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingUnion))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingUnion != null)
            msgs = ((InternalEObject) newContainingUnion).eInverseAdd (this, IdlmmPackage.UNION_DEF__UNION_CONTENTS,
                  UnionDef.class, msgs);
         msgs = basicSetContainingUnion (newContainingUnion, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ENUM_DEF__CONTAINING_UNION, newContainingUnion,
               newContainingUnion));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public InterfaceDef getContainingInterface ()
   {
      if (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE)
         return null;
      return (InterfaceDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingInterface (InterfaceDef newContainingInterface, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingInterface, IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingInterface (InterfaceDef newContainingInterface)
   {
      if (newContainingInterface != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE && newContainingInterface != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingInterface))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingInterface != null)
            msgs = ((InternalEObject) newContainingInterface).eInverseAdd (this, IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS,
                  InterfaceDef.class, msgs);
         msgs = basicSetContainingInterface (newContainingInterface, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE,
               newContainingInterface, newContainingInterface));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EnumMember> getMembers ()
   {
      return EnumDefExt.getMembers (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingRepository ((Repository) otherEnd, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_MODULE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingModule ((ModuleDef) otherEnd, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingException ((ExceptionDef) otherEnd, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingStruct ((StructDef) otherEnd, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_UNION:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingUnion ((UnionDef) otherEnd, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingInterface ((InterfaceDef) otherEnd, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_HOME:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingHome ((HomeDef) otherEnd, msgs);
         case IdlmmPackage.ENUM_DEF__ENUM_CONTENTS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getEnumContents ()).basicAdd (otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY:
            return basicSetContainingRepository (null, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_MODULE:
            return basicSetContainingModule (null, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION:
            return basicSetContainingException (null, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT:
            return basicSetContainingStruct (null, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_UNION:
            return basicSetContainingUnion (null, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE:
            return basicSetContainingInterface (null, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_HOME:
            return basicSetContainingHome (null, msgs);
         case IdlmmPackage.ENUM_DEF__ENUM_CONTENTS:
            return ((InternalEList<?>) getEnumContents ()).basicRemove (otherEnd, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature (NotificationChain msgs)
   {
      switch (eContainerFeatureID)
      {
         case IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY:
            return eInternalContainer ()
                  .eInverseRemove (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS, Repository.class, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_MODULE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS, ModuleDef.class, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS, ExceptionDef.class,
                  msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.STRUCT_DEF__STRUCT_CONTENTS, StructDef.class, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_UNION:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.UNION_DEF__UNION_CONTENTS, UnionDef.class, msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS, InterfaceDef.class,
                  msgs);
         case IdlmmPackage.ENUM_DEF__CONTAINING_HOME:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.HOME_DEF__HOME_CONTENTS, HomeDef.class, msgs);
      }
      return super.eBasicRemoveFromContainerFeature (msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY:
            return getContainingRepository ();
         case IdlmmPackage.ENUM_DEF__CONTAINING_MODULE:
            return getContainingModule ();
         case IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION:
            return getContainingException ();
         case IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT:
            return getContainingStruct ();
         case IdlmmPackage.ENUM_DEF__CONTAINING_UNION:
            return getContainingUnion ();
         case IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE:
            return getContainingInterface ();
         case IdlmmPackage.ENUM_DEF__CONTENTS:
            return getContents ();
         case IdlmmPackage.ENUM_DEF__CONTAINING_HOME:
            return getContainingHome ();
         case IdlmmPackage.ENUM_DEF__ENUM_CONTENTS:
            return getEnumContents ();
         case IdlmmPackage.ENUM_DEF__MEMBERS:
            return getMembers ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) newValue);
            return;
         case IdlmmPackage.ENUM_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) newValue);
            return;
         case IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION:
            setContainingException ((ExceptionDef) newValue);
            return;
         case IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT:
            setContainingStruct ((StructDef) newValue);
            return;
         case IdlmmPackage.ENUM_DEF__CONTAINING_UNION:
            setContainingUnion ((UnionDef) newValue);
            return;
         case IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE:
            setContainingInterface ((InterfaceDef) newValue);
            return;
         case IdlmmPackage.ENUM_DEF__CONTAINING_HOME:
            setContainingHome ((HomeDef) newValue);
            return;
         case IdlmmPackage.ENUM_DEF__ENUM_CONTENTS:
            getEnumContents ().clear ();
            getEnumContents ().addAll ((Collection<? extends EnumContained>) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) null);
            return;
         case IdlmmPackage.ENUM_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) null);
            return;
         case IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION:
            setContainingException ((ExceptionDef) null);
            return;
         case IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT:
            setContainingStruct ((StructDef) null);
            return;
         case IdlmmPackage.ENUM_DEF__CONTAINING_UNION:
            setContainingUnion ((UnionDef) null);
            return;
         case IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE:
            setContainingInterface ((InterfaceDef) null);
            return;
         case IdlmmPackage.ENUM_DEF__CONTAINING_HOME:
            setContainingHome ((HomeDef) null);
            return;
         case IdlmmPackage.ENUM_DEF__ENUM_CONTENTS:
            getEnumContents ().clear ();
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY:
            return getContainingRepository () != null;
         case IdlmmPackage.ENUM_DEF__CONTAINING_MODULE:
            return getContainingModule () != null;
         case IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION:
            return getContainingException () != null;
         case IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT:
            return getContainingStruct () != null;
         case IdlmmPackage.ENUM_DEF__CONTAINING_UNION:
            return getContainingUnion () != null;
         case IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE:
            return getContainingInterface () != null;
         case IdlmmPackage.ENUM_DEF__CONTENTS:
            return isSetContents ();
         case IdlmmPackage.ENUM_DEF__CONTAINING_HOME:
            return getContainingHome () != null;
         case IdlmmPackage.ENUM_DEF__ENUM_CONTENTS:
            return enumContents != null && !enumContents.isEmpty ();
         case IdlmmPackage.ENUM_DEF__MEMBERS:
            return !getMembers ().isEmpty ();
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == RepositoryContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY:
               return IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ENUM_DEF__CONTAINING_MODULE:
               return IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == ExceptionContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION:
               return IdlmmPackage.EXCEPTION_CONTAINED__CONTAINING_EXCEPTION;
            default:
               return -1;
         }
      }
      if (baseClass == StructContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT:
               return IdlmmPackage.STRUCT_CONTAINED__CONTAINING_STRUCT;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ENUM_DEF__CONTAINING_UNION:
               return IdlmmPackage.UNION_CONTAINED__CONTAINING_UNION;
            default:
               return -1;
         }
      }
      if (baseClass == InterfaceContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE:
               return IdlmmPackage.INTERFACE_CONTAINED__CONTAINING_INTERFACE;
            default:
               return -1;
         }
      }
      if (baseClass == Container.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ENUM_DEF__CONTENTS:
               return IdlmmPackage.CONTAINER__CONTENTS;
            default:
               return -1;
         }
      }
      if (baseClass == HomeContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ENUM_DEF__CONTAINING_HOME:
               return IdlmmPackage.HOME_CONTAINED__CONTAINING_HOME;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == RepositoryContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY:
               return IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE:
               return IdlmmPackage.ENUM_DEF__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == ExceptionContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.EXCEPTION_CONTAINED__CONTAINING_EXCEPTION:
               return IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION;
            default:
               return -1;
         }
      }
      if (baseClass == StructContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.STRUCT_CONTAINED__CONTAINING_STRUCT:
               return IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.UNION_CONTAINED__CONTAINING_UNION:
               return IdlmmPackage.ENUM_DEF__CONTAINING_UNION;
            default:
               return -1;
         }
      }
      if (baseClass == InterfaceContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.INTERFACE_CONTAINED__CONTAINING_INTERFACE:
               return IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE;
            default:
               return -1;
         }
      }
      if (baseClass == Container.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINER__CONTENTS:
               return IdlmmPackage.ENUM_DEF__CONTENTS;
            default:
               return -1;
         }
      }
      if (baseClass == HomeContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.HOME_CONTAINED__CONTAINING_HOME:
               return IdlmmPackage.ENUM_DEF__CONTAINING_HOME;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean isSetContainer ()
   {
      return super.isSetContainer () || eIsSet (IdlmmPackage.ENUM_DEF__CONTAINING_REPOSITORY)
            || eIsSet (IdlmmPackage.ENUM_DEF__CONTAINING_MODULE) || eIsSet (IdlmmPackage.ENUM_DEF__CONTAINING_EXCEPTION)
            || eIsSet (IdlmmPackage.ENUM_DEF__CONTAINING_STRUCT) || eIsSet (IdlmmPackage.ENUM_DEF__CONTAINING_UNION)
            || eIsSet (IdlmmPackage.ENUM_DEF__CONTAINING_INTERFACE) || eIsSet (IdlmmPackage.ENUM_DEF__CONTAINING_HOME);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContents ()
   {
      return eIsSet (IdlmmPackage.ENUM_DEF__ENUM_CONTENTS);
   }

} //EnumDefImpl
