/**
 * <copyright>
 * </copyright>
 *
 * $Id: EnumMemberImpl.java,v 1.32 2008/07/02 14:58:57 gm Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.EnumContained;
import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.EnumMember;
import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.Pragma;
import com.prismtech.idt.idlmm.Repository;
import com.prismtech.idt.idlmm.SharedExpression;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Enum Member</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumMemberImpl#getSource <em>Source</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumMemberImpl#getPragmas <em>Pragmas</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumMemberImpl#getRepository <em>Repository</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumMemberImpl#getContainer <em>Container</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumMemberImpl#getAbsoluteName <em>Absolute Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumMemberImpl#getPrefix <em>Prefix</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumMemberImpl#getID <em>ID</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumMemberImpl#getVersion <em>Version</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EnumMemberImpl#getContainingEnum <em>Containing Enum</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class EnumMemberImpl extends NamedImpl implements EnumMember
{
   /**
    * The default value of the '{@link #getSource() <em>Source</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getSource()
    * @generated
    * @ordered
    */
   protected static final String SOURCE_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getSource() <em>Source</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getSource()
    * @generated
    * @ordered
    */
   protected String source = SOURCE_EDEFAULT;

   /**
    * The cached value of the '{@link #getPragmas() <em>Pragmas</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPragmas()
    * @generated
    * @ordered
    */
   protected EList<Pragma> pragmas;

   /**
    * The default value of the '{@link #getAbsoluteName() <em>Absolute Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getAbsoluteName()
    * @generated
    * @ordered
    */
   protected static final String ABSOLUTE_NAME_EDEFAULT = null;

   /**
    * The default value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected static final String PREFIX_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected String prefix = PREFIX_EDEFAULT;

   /**
    * The default value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected static final String ID_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected String id = ID_EDEFAULT;

   /**
    * The default value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected static final String VERSION_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected String version = VERSION_EDEFAULT;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected EnumMemberImpl ()
   {
      super ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.ENUM_MEMBER;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<Pragma> getPragmas ()
   {
      if (pragmas == null)
      {
         pragmas = new EObjectContainmentWithInverseEList<Pragma> (Pragma.class, this, IdlmmPackage.ENUM_MEMBER__PRAGMAS,
               IdlmmPackage.PRAGMA__OWNER);
      }
      return pragmas;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getSource ()
   {
      return source;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setSource (String newSource)
   {
      String oldSource = source;
      source = newSource;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ENUM_MEMBER__SOURCE, oldSource, source));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getPrefix ()
   {
      return prefix;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setPrefix (String newPrefix)
   {
      String oldPrefix = prefix;
      prefix = newPrefix;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ENUM_MEMBER__PREFIX, oldPrefix, prefix));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getVersion ()
   {
      return version;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setVersion (String newVersion)
   {
      String oldVersion = version;
      version = newVersion;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ENUM_MEMBER__VERSION, oldVersion, version));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getID ()
   {
      return ContainedExt.getID (this, id);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setID (String newID)
   {
      String oldID = id;
      id = newID;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ENUM_MEMBER__ID, oldID, id));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Repository getRepository ()
   {
      Repository repository = basicGetRepository ();
      return repository != null && repository.eIsProxy () ? (Repository) eResolveProxy ((InternalEObject) repository) : repository;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public Repository basicGetRepository ()
   {
      return IRObjectExt.getRepository (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<IRObject> getPrerequisites ()
   {
      return IRObjectExt.getPrerequisites (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Object getExpressionValue ()
   {
      return EnumMemberExt.getExpressionValue (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public void setContainer (Container newContainer)
   {
      ContainedExt.setContainer (this, newContainer);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Container getContainer ()
   {
      Container container = basicGetContainer ();
      return container != null && container.eIsProxy () ? (Container) eResolveProxy ((InternalEObject) container) : container;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Container basicGetContainer ()
   {
      EnumDef containingEnum = getContainingEnum ();
      if (containingEnum != null)
      {
         return containingEnum;
      }
      return null;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getAbsoluteName ()
   {
      return ContainedExt.getAbsoluteName (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EnumDef getContainingEnum ()
   {
      if (eContainerFeatureID != IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM)
         return null;
      return (EnumDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingEnum (EnumDef newContainingEnum, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingEnum, IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingEnum (EnumDef newContainingEnum)
   {
      if (newContainingEnum != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM && newContainingEnum != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingEnum))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingEnum != null)
            msgs = ((InternalEObject) newContainingEnum).eInverseAdd (this, IdlmmPackage.ENUM_DEF__ENUM_CONTENTS, EnumDef.class,
                  msgs);
         msgs = basicSetContainingEnum (newContainingEnum, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM, newContainingEnum,
               newContainingEnum));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.ENUM_MEMBER__PRAGMAS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getPragmas ()).basicAdd (otherEnd, msgs);
         case IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingEnum ((EnumDef) otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.ENUM_MEMBER__PRAGMAS:
            return ((InternalEList<?>) getPragmas ()).basicRemove (otherEnd, msgs);
         case IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM:
            return basicSetContainingEnum (null, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature (NotificationChain msgs)
   {
      switch (eContainerFeatureID)
      {
         case IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.ENUM_DEF__ENUM_CONTENTS, EnumDef.class, msgs);
      }
      return super.eBasicRemoveFromContainerFeature (msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.ENUM_MEMBER__SOURCE:
            return getSource ();
         case IdlmmPackage.ENUM_MEMBER__PRAGMAS:
            return getPragmas ();
         case IdlmmPackage.ENUM_MEMBER__REPOSITORY:
            if (resolve)
               return getRepository ();
            return basicGetRepository ();
         case IdlmmPackage.ENUM_MEMBER__CONTAINER:
            if (resolve)
               return getContainer ();
            return basicGetContainer ();
         case IdlmmPackage.ENUM_MEMBER__ABSOLUTE_NAME:
            return getAbsoluteName ();
         case IdlmmPackage.ENUM_MEMBER__PREFIX:
            return getPrefix ();
         case IdlmmPackage.ENUM_MEMBER__ID:
            return getID ();
         case IdlmmPackage.ENUM_MEMBER__VERSION:
            return getVersion ();
         case IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM:
            return getContainingEnum ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.ENUM_MEMBER__SOURCE:
            setSource ((String) newValue);
            return;
         case IdlmmPackage.ENUM_MEMBER__PRAGMAS:
            getPragmas ().clear ();
            getPragmas ().addAll ((Collection<? extends Pragma>) newValue);
            return;
         case IdlmmPackage.ENUM_MEMBER__CONTAINER:
            setContainer ((Container) newValue);
            return;
         case IdlmmPackage.ENUM_MEMBER__PREFIX:
            setPrefix ((String) newValue);
            return;
         case IdlmmPackage.ENUM_MEMBER__ID:
            setID ((String) newValue);
            return;
         case IdlmmPackage.ENUM_MEMBER__VERSION:
            setVersion ((String) newValue);
            return;
         case IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM:
            setContainingEnum ((EnumDef) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.ENUM_MEMBER__SOURCE:
            setSource (SOURCE_EDEFAULT);
            return;
         case IdlmmPackage.ENUM_MEMBER__PRAGMAS:
            getPragmas ().clear ();
            return;
         case IdlmmPackage.ENUM_MEMBER__CONTAINER:
            setContainer ((Container) null);
            return;
         case IdlmmPackage.ENUM_MEMBER__PREFIX:
            setPrefix (PREFIX_EDEFAULT);
            return;
         case IdlmmPackage.ENUM_MEMBER__ID:
            setID (ID_EDEFAULT);
            return;
         case IdlmmPackage.ENUM_MEMBER__VERSION:
            setVersion (VERSION_EDEFAULT);
            return;
         case IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM:
            setContainingEnum ((EnumDef) null);
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.ENUM_MEMBER__SOURCE:
            return SOURCE_EDEFAULT == null ? source != null : !SOURCE_EDEFAULT.equals (source);
         case IdlmmPackage.ENUM_MEMBER__PRAGMAS:
            return pragmas != null && !pragmas.isEmpty ();
         case IdlmmPackage.ENUM_MEMBER__REPOSITORY:
            return basicGetRepository () != null;
         case IdlmmPackage.ENUM_MEMBER__CONTAINER:
            return isSetContainer ();
         case IdlmmPackage.ENUM_MEMBER__ABSOLUTE_NAME:
            return ABSOLUTE_NAME_EDEFAULT == null ? getAbsoluteName () != null : !ABSOLUTE_NAME_EDEFAULT
                  .equals (getAbsoluteName ());
         case IdlmmPackage.ENUM_MEMBER__PREFIX:
            return PREFIX_EDEFAULT == null ? prefix != null : !PREFIX_EDEFAULT.equals (prefix);
         case IdlmmPackage.ENUM_MEMBER__ID:
            return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals (id);
         case IdlmmPackage.ENUM_MEMBER__VERSION:
            return VERSION_EDEFAULT == null ? version != null : !VERSION_EDEFAULT.equals (version);
         case IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM:
            return getContainingEnum () != null;
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == IRObject.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ENUM_MEMBER__SOURCE:
               return IdlmmPackage.IR_OBJECT__SOURCE;
            case IdlmmPackage.ENUM_MEMBER__PRAGMAS:
               return IdlmmPackage.IR_OBJECT__PRAGMAS;
            case IdlmmPackage.ENUM_MEMBER__REPOSITORY:
               return IdlmmPackage.IR_OBJECT__REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == Expression.class)
      {
         switch (derivedFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == SharedExpression.class)
      {
         switch (derivedFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ENUM_MEMBER__ABSOLUTE_NAME:
               return IdlmmPackage.CONTAINED__ABSOLUTE_NAME;
            case IdlmmPackage.ENUM_MEMBER__PREFIX:
               return IdlmmPackage.CONTAINED__PREFIX;
            case IdlmmPackage.ENUM_MEMBER__ID:
               return IdlmmPackage.CONTAINED__ID;
            case IdlmmPackage.ENUM_MEMBER__VERSION:
               return IdlmmPackage.CONTAINED__VERSION;
            case IdlmmPackage.ENUM_MEMBER__CONTAINER:
               return IdlmmPackage.CONTAINED__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == EnumContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM:
               return IdlmmPackage.ENUM_CONTAINED__CONTAINING_ENUM;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == IRObject.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.IR_OBJECT__SOURCE:
               return IdlmmPackage.ENUM_MEMBER__SOURCE;
            case IdlmmPackage.IR_OBJECT__PRAGMAS:
               return IdlmmPackage.ENUM_MEMBER__PRAGMAS;
            case IdlmmPackage.IR_OBJECT__REPOSITORY:
               return IdlmmPackage.ENUM_MEMBER__REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == Expression.class)
      {
         switch (baseFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == SharedExpression.class)
      {
         switch (baseFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINED__ABSOLUTE_NAME:
               return IdlmmPackage.ENUM_MEMBER__ABSOLUTE_NAME;
            case IdlmmPackage.CONTAINED__PREFIX:
               return IdlmmPackage.ENUM_MEMBER__PREFIX;
            case IdlmmPackage.CONTAINED__ID:
               return IdlmmPackage.ENUM_MEMBER__ID;
            case IdlmmPackage.CONTAINED__VERSION:
               return IdlmmPackage.ENUM_MEMBER__VERSION;
            case IdlmmPackage.CONTAINED__CONTAINER:
               return IdlmmPackage.ENUM_MEMBER__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == EnumContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ENUM_CONTAINED__CONTAINING_ENUM:
               return IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String toString ()
   {
      if (eIsProxy ())
         return super.toString ();

      StringBuffer result = new StringBuffer (super.toString ());
      result.append (" (source: ");
      result.append (source);
      result.append (", prefix: ");
      result.append (prefix);
      result.append (", ID: ");
      result.append (id);
      result.append (", version: ");
      result.append (version);
      result.append (')');
      return result.toString ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContainer ()
   {
      return eIsSet (IdlmmPackage.ENUM_MEMBER__CONTAINING_ENUM);
   }

} //EnumMemberImpl
