/**
 * <copyright>
 * </copyright>
 *
 * $Id: ExceptionDefImpl.java,v 1.35 2009/09/04 09:24:29 je Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.EnumContainer;
import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.ExceptionContained;
import com.prismtech.idt.idlmm.ExceptionDef;
import com.prismtech.idt.idlmm.ExceptionMember;
import com.prismtech.idt.idlmm.HomeContained;
import com.prismtech.idt.idlmm.HomeDef;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.InterfaceContained;
import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.ModuleContained;
import com.prismtech.idt.idlmm.ModuleDef;
import com.prismtech.idt.idlmm.Named;
import com.prismtech.idt.idlmm.Repository;
import com.prismtech.idt.idlmm.RepositoryContained;
import com.prismtech.idt.idlmm.StructContainer;
import com.prismtech.idt.idlmm.StructDef;
import com.prismtech.idt.idlmm.UnionContainer;
import com.prismtech.idt.idlmm.UnionDef;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.uml2.common.util.DerivedUnionEObjectEList;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Exception Def</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getKey <em>Key</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getContainer <em>Container</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getAbsoluteName <em>Absolute Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getPrefix <em>Prefix</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getID <em>ID</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getVersion <em>Version</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getContainingModule <em>Containing Module</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getContainingInterface <em>Containing Interface</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getContainingRepository <em>Containing Repository</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getStructs <em>Structs</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getAllStructs <em>All Structs</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getEnums <em>Enums</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getAllEnums <em>All Enums</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getUnions <em>Unions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getAllUnions <em>All Unions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getContainingHome <em>Containing Home</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getContents <em>Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getExceptionContents <em>Exception Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ExceptionDefImpl#getMembers <em>Members</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ExceptionDefImpl extends ContainerImpl implements ExceptionDef
{
   /**
    * The default value of the '{@link #getName() <em>Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getName()
    * @generated
    * @ordered
    */
   protected static final String NAME_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getName()
    * @generated
    * @ordered
    */
   protected String name = NAME_EDEFAULT;

   /**
    * The default value of the '{@link #getKey() <em>Key</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getKey()
    * @generated
    * @ordered
    */
   protected static final String KEY_EDEFAULT = null;

   /**
    * The default value of the '{@link #getAbsoluteName() <em>Absolute Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getAbsoluteName()
    * @generated
    * @ordered
    */
   protected static final String ABSOLUTE_NAME_EDEFAULT = null;

   /**
    * The default value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected static final String PREFIX_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected String prefix = PREFIX_EDEFAULT;

   /**
    * The default value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected static final String ID_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected String id = ID_EDEFAULT;

   /**
    * The default value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected static final String VERSION_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected String version = VERSION_EDEFAULT;

   /**
    * The cached value of the '{@link #getExceptionContents() <em>Exception Contents</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getExceptionContents()
    * @generated
    * @ordered
    */
   protected EList<ExceptionContained> exceptionContents;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ExceptionDefImpl ()
   {
      super ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.EXCEPTION_DEF;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getName ()
   {
      return name;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setName (String newName)
   {
      String oldName = name;
      name = newName;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.EXCEPTION_DEF__NAME, oldName, name));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getKey ()
   {
      return NamedExt.getKey (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<ExceptionContained> getExceptionContents ()
   {
      if (exceptionContents == null)
      {
         exceptionContents = new EObjectContainmentWithInverseEList<ExceptionContained> (ExceptionContained.class, this,
               IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS, IdlmmPackage.EXCEPTION_CONTAINED__CONTAINING_EXCEPTION);
      }
      return exceptionContents;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public void setContainer (Container newContainer)
   {
      ContainedExt.setContainer (this, newContainer);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Container getContainer ()
   {
      Container container = basicGetContainer ();
      return container != null && container.eIsProxy () ? (Container) eResolveProxy ((InternalEObject) container) : container;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Container basicGetContainer ()
   {
      ModuleDef containingModule = getContainingModule ();
      if (containingModule != null)
      {
         return containingModule;
      }
      InterfaceDef containingInterface = getContainingInterface ();
      if (containingInterface != null)
      {
         return containingInterface;
      }
      Repository containingRepository = getContainingRepository ();
      if (containingRepository != null)
      {
         return containingRepository;
      }
      HomeDef containingHome = getContainingHome ();
      if (containingHome != null)
      {
         return containingHome;
      }
      return null;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getAbsoluteName ()
   {
      return ContainedExt.getAbsoluteName (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getPrefix ()
   {
      return prefix;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setPrefix (String newPrefix)
   {
      String oldPrefix = prefix;
      prefix = newPrefix;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.EXCEPTION_DEF__PREFIX, oldPrefix, prefix));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getID ()
   {
      return ContainedExt.getID (this, id);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setID (String newID)
   {
      String oldID = id;
      id = newID;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.EXCEPTION_DEF__ID, oldID, id));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getVersion ()
   {
      return version;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setVersion (String newVersion)
   {
      String oldVersion = version;
      version = newVersion;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.EXCEPTION_DEF__VERSION, oldVersion, version));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ModuleDef getContainingModule ()
   {
      if (eContainerFeatureID != IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE)
         return null;
      return (ModuleDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingModule (ModuleDef newContainingModule, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingModule, IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingModule (ModuleDef newContainingModule)
   {
      if (newContainingModule != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE && newContainingModule != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingModule))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingModule != null)
            msgs = ((InternalEObject) newContainingModule).eInverseAdd (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS,
                  ModuleDef.class, msgs);
         msgs = basicSetContainingModule (newContainingModule, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE,
               newContainingModule, newContainingModule));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public InterfaceDef getContainingInterface ()
   {
      if (eContainerFeatureID != IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE)
         return null;
      return (InterfaceDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingInterface (InterfaceDef newContainingInterface, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingInterface, IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingInterface (InterfaceDef newContainingInterface)
   {
      if (newContainingInterface != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE && newContainingInterface != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingInterface))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingInterface != null)
            msgs = ((InternalEObject) newContainingInterface).eInverseAdd (this, IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS,
                  InterfaceDef.class, msgs);
         msgs = basicSetContainingInterface (newContainingInterface, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE,
               newContainingInterface, newContainingInterface));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Repository getContainingRepository ()
   {
      if (eContainerFeatureID != IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY)
         return null;
      return (Repository) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingRepository (Repository newContainingRepository, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingRepository, IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingRepository (Repository newContainingRepository)
   {
      if (newContainingRepository != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY && newContainingRepository != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingRepository))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingRepository != null)
            msgs = ((InternalEObject) newContainingRepository).eInverseAdd (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS,
                  Repository.class, msgs);
         msgs = basicSetContainingRepository (newContainingRepository, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY,
               newContainingRepository, newContainingRepository));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<Contained> getContents ()
   {
      return new DerivedUnionEObjectEList<Contained> (Contained.class, this, IdlmmPackage.EXCEPTION_DEF__CONTENTS,
            CONTENTS_ESUBSETS);
   }

   /**
    * The array of subset feature identifiers for the '{@link #getContents() <em>Contents</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getContents()
    * @generated
    * @ordered
    */
   protected static final int[] CONTENTS_ESUBSETS = new int[]
   {
      IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS
   };

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ExceptionMember getMember (String name)
   {
      return ExceptionDefExt.getMember (this, name);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ExceptionMember> getMembers ()
   {
      return ExceptionDefExt.getMembers (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EnumDef> getEnums ()
   {
      return ExceptionDefExt.getEnums (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EnumDef> getAllEnums ()
   {
      return ExceptionDefExt.getAllEnums (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<StructDef> getStructs ()
   {
      return ExceptionDefExt.getStructs (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<StructDef> getAllStructs ()
   {
      return ExceptionDefExt.getAllStructs (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UnionDef> getUnions ()
   {
      return ExceptionDefExt.getUnions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UnionDef> getAllUnions ()
   {
      return ExceptionDefExt.getAllUnions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public HomeDef getContainingHome ()
   {
      if (eContainerFeatureID != IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME)
         return null;
      return (HomeDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingHome (HomeDef newContainingHome, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingHome, IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingHome (HomeDef newContainingHome)
   {
      if (newContainingHome != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME && newContainingHome != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingHome))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingHome != null)
            msgs = ((InternalEObject) newContainingHome).eInverseAdd (this, IdlmmPackage.HOME_DEF__HOME_CONTENTS, HomeDef.class,
                  msgs);
         msgs = basicSetContainingHome (newContainingHome, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME, newContainingHome,
               newContainingHome));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingModule ((ModuleDef) otherEnd, msgs);
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingInterface ((InterfaceDef) otherEnd, msgs);
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingRepository ((Repository) otherEnd, msgs);
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingHome ((HomeDef) otherEnd, msgs);
         case IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getExceptionContents ()).basicAdd (otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE:
            return basicSetContainingModule (null, msgs);
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE:
            return basicSetContainingInterface (null, msgs);
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY:
            return basicSetContainingRepository (null, msgs);
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME:
            return basicSetContainingHome (null, msgs);
         case IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS:
            return ((InternalEList<?>) getExceptionContents ()).basicRemove (otherEnd, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature (NotificationChain msgs)
   {
      switch (eContainerFeatureID)
      {
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS, ModuleDef.class, msgs);
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS, InterfaceDef.class,
                  msgs);
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY:
            return eInternalContainer ()
                  .eInverseRemove (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS, Repository.class, msgs);
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.HOME_DEF__HOME_CONTENTS, HomeDef.class, msgs);
      }
      return super.eBasicRemoveFromContainerFeature (msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.EXCEPTION_DEF__NAME:
            return getName ();
         case IdlmmPackage.EXCEPTION_DEF__KEY:
            return getKey ();
         case IdlmmPackage.EXCEPTION_DEF__CONTAINER:
            if (resolve)
               return getContainer ();
            return basicGetContainer ();
         case IdlmmPackage.EXCEPTION_DEF__ABSOLUTE_NAME:
            return getAbsoluteName ();
         case IdlmmPackage.EXCEPTION_DEF__PREFIX:
            return getPrefix ();
         case IdlmmPackage.EXCEPTION_DEF__ID:
            return getID ();
         case IdlmmPackage.EXCEPTION_DEF__VERSION:
            return getVersion ();
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE:
            return getContainingModule ();
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE:
            return getContainingInterface ();
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY:
            return getContainingRepository ();
         case IdlmmPackage.EXCEPTION_DEF__STRUCTS:
            return getStructs ();
         case IdlmmPackage.EXCEPTION_DEF__ALL_STRUCTS:
            return getAllStructs ();
         case IdlmmPackage.EXCEPTION_DEF__ENUMS:
            return getEnums ();
         case IdlmmPackage.EXCEPTION_DEF__ALL_ENUMS:
            return getAllEnums ();
         case IdlmmPackage.EXCEPTION_DEF__UNIONS:
            return getUnions ();
         case IdlmmPackage.EXCEPTION_DEF__ALL_UNIONS:
            return getAllUnions ();
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME:
            return getContainingHome ();
         case IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS:
            return getExceptionContents ();
         case IdlmmPackage.EXCEPTION_DEF__MEMBERS:
            return getMembers ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.EXCEPTION_DEF__NAME:
            setName ((String) newValue);
            return;
         case IdlmmPackage.EXCEPTION_DEF__CONTAINER:
            setContainer ((Container) newValue);
            return;
         case IdlmmPackage.EXCEPTION_DEF__PREFIX:
            setPrefix ((String) newValue);
            return;
         case IdlmmPackage.EXCEPTION_DEF__ID:
            setID ((String) newValue);
            return;
         case IdlmmPackage.EXCEPTION_DEF__VERSION:
            setVersion ((String) newValue);
            return;
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) newValue);
            return;
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE:
            setContainingInterface ((InterfaceDef) newValue);
            return;
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) newValue);
            return;
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME:
            setContainingHome ((HomeDef) newValue);
            return;
         case IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS:
            getExceptionContents ().clear ();
            getExceptionContents ().addAll ((Collection<? extends ExceptionContained>) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.EXCEPTION_DEF__NAME:
            setName (NAME_EDEFAULT);
            return;
         case IdlmmPackage.EXCEPTION_DEF__CONTAINER:
            setContainer ((Container) null);
            return;
         case IdlmmPackage.EXCEPTION_DEF__PREFIX:
            setPrefix (PREFIX_EDEFAULT);
            return;
         case IdlmmPackage.EXCEPTION_DEF__ID:
            setID (ID_EDEFAULT);
            return;
         case IdlmmPackage.EXCEPTION_DEF__VERSION:
            setVersion (VERSION_EDEFAULT);
            return;
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) null);
            return;
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE:
            setContainingInterface ((InterfaceDef) null);
            return;
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) null);
            return;
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME:
            setContainingHome ((HomeDef) null);
            return;
         case IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS:
            getExceptionContents ().clear ();
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.EXCEPTION_DEF__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals (name);
         case IdlmmPackage.EXCEPTION_DEF__KEY:
            return KEY_EDEFAULT == null ? getKey () != null : !KEY_EDEFAULT.equals (getKey ());
         case IdlmmPackage.EXCEPTION_DEF__CONTAINER:
            return isSetContainer ();
         case IdlmmPackage.EXCEPTION_DEF__ABSOLUTE_NAME:
            return ABSOLUTE_NAME_EDEFAULT == null ? getAbsoluteName () != null : !ABSOLUTE_NAME_EDEFAULT
                  .equals (getAbsoluteName ());
         case IdlmmPackage.EXCEPTION_DEF__PREFIX:
            return PREFIX_EDEFAULT == null ? prefix != null : !PREFIX_EDEFAULT.equals (prefix);
         case IdlmmPackage.EXCEPTION_DEF__ID:
            return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals (id);
         case IdlmmPackage.EXCEPTION_DEF__VERSION:
            return VERSION_EDEFAULT == null ? version != null : !VERSION_EDEFAULT.equals (version);
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE:
            return getContainingModule () != null;
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE:
            return getContainingInterface () != null;
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY:
            return getContainingRepository () != null;
         case IdlmmPackage.EXCEPTION_DEF__STRUCTS:
            return !getStructs ().isEmpty ();
         case IdlmmPackage.EXCEPTION_DEF__ALL_STRUCTS:
            return !getAllStructs ().isEmpty ();
         case IdlmmPackage.EXCEPTION_DEF__ENUMS:
            return !getEnums ().isEmpty ();
         case IdlmmPackage.EXCEPTION_DEF__ALL_ENUMS:
            return !getAllEnums ().isEmpty ();
         case IdlmmPackage.EXCEPTION_DEF__UNIONS:
            return !getUnions ().isEmpty ();
         case IdlmmPackage.EXCEPTION_DEF__ALL_UNIONS:
            return !getAllUnions ().isEmpty ();
         case IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME:
            return getContainingHome () != null;
         case IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS:
            return exceptionContents != null && !exceptionContents.isEmpty ();
         case IdlmmPackage.EXCEPTION_DEF__MEMBERS:
            return !getMembers ().isEmpty ();
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == Named.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EXCEPTION_DEF__NAME:
               return IdlmmPackage.NAMED__NAME;
            case IdlmmPackage.EXCEPTION_DEF__KEY:
               return IdlmmPackage.NAMED__KEY;
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EXCEPTION_DEF__ABSOLUTE_NAME:
               return IdlmmPackage.CONTAINED__ABSOLUTE_NAME;
            case IdlmmPackage.EXCEPTION_DEF__PREFIX:
               return IdlmmPackage.CONTAINED__PREFIX;
            case IdlmmPackage.EXCEPTION_DEF__ID:
               return IdlmmPackage.CONTAINED__ID;
            case IdlmmPackage.EXCEPTION_DEF__VERSION:
               return IdlmmPackage.CONTAINED__VERSION;
            case IdlmmPackage.EXCEPTION_DEF__CONTAINER:
               return IdlmmPackage.CONTAINED__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE:
               return IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == InterfaceContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE:
               return IdlmmPackage.INTERFACE_CONTAINED__CONTAINING_INTERFACE;
            default:
               return -1;
         }
      }
      if (baseClass == RepositoryContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY:
               return IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == StructContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EXCEPTION_DEF__STRUCTS:
               return IdlmmPackage.STRUCT_CONTAINER__STRUCTS;
            case IdlmmPackage.EXCEPTION_DEF__ALL_STRUCTS:
               return IdlmmPackage.STRUCT_CONTAINER__ALL_STRUCTS;
            default:
               return -1;
         }
      }
      if (baseClass == EnumContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EXCEPTION_DEF__ENUMS:
               return IdlmmPackage.ENUM_CONTAINER__ENUMS;
            case IdlmmPackage.EXCEPTION_DEF__ALL_ENUMS:
               return IdlmmPackage.ENUM_CONTAINER__ALL_ENUMS;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EXCEPTION_DEF__UNIONS:
               return IdlmmPackage.UNION_CONTAINER__UNIONS;
            case IdlmmPackage.EXCEPTION_DEF__ALL_UNIONS:
               return IdlmmPackage.UNION_CONTAINER__ALL_UNIONS;
            default:
               return -1;
         }
      }
      if (baseClass == HomeContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME:
               return IdlmmPackage.HOME_CONTAINED__CONTAINING_HOME;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == Named.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.NAMED__NAME:
               return IdlmmPackage.EXCEPTION_DEF__NAME;
            case IdlmmPackage.NAMED__KEY:
               return IdlmmPackage.EXCEPTION_DEF__KEY;
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINED__ABSOLUTE_NAME:
               return IdlmmPackage.EXCEPTION_DEF__ABSOLUTE_NAME;
            case IdlmmPackage.CONTAINED__PREFIX:
               return IdlmmPackage.EXCEPTION_DEF__PREFIX;
            case IdlmmPackage.CONTAINED__ID:
               return IdlmmPackage.EXCEPTION_DEF__ID;
            case IdlmmPackage.CONTAINED__VERSION:
               return IdlmmPackage.EXCEPTION_DEF__VERSION;
            case IdlmmPackage.CONTAINED__CONTAINER:
               return IdlmmPackage.EXCEPTION_DEF__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE:
               return IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == InterfaceContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.INTERFACE_CONTAINED__CONTAINING_INTERFACE:
               return IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE;
            default:
               return -1;
         }
      }
      if (baseClass == RepositoryContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY:
               return IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == StructContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.STRUCT_CONTAINER__STRUCTS:
               return IdlmmPackage.EXCEPTION_DEF__STRUCTS;
            case IdlmmPackage.STRUCT_CONTAINER__ALL_STRUCTS:
               return IdlmmPackage.EXCEPTION_DEF__ALL_STRUCTS;
            default:
               return -1;
         }
      }
      if (baseClass == EnumContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ENUM_CONTAINER__ENUMS:
               return IdlmmPackage.EXCEPTION_DEF__ENUMS;
            case IdlmmPackage.ENUM_CONTAINER__ALL_ENUMS:
               return IdlmmPackage.EXCEPTION_DEF__ALL_ENUMS;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.UNION_CONTAINER__UNIONS:
               return IdlmmPackage.EXCEPTION_DEF__UNIONS;
            case IdlmmPackage.UNION_CONTAINER__ALL_UNIONS:
               return IdlmmPackage.EXCEPTION_DEF__ALL_UNIONS;
            default:
               return -1;
         }
      }
      if (baseClass == HomeContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.HOME_CONTAINED__CONTAINING_HOME:
               return IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String toString ()
   {
      if (eIsProxy ())
         return super.toString ();

      StringBuffer result = new StringBuffer (super.toString ());
      result.append (" (name: ");
      result.append (name);
      result.append (", prefix: ");
      result.append (prefix);
      result.append (", ID: ");
      result.append (id);
      result.append (", version: ");
      result.append (version);
      result.append (')');
      return result.toString ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContainer ()
   {
      return eIsSet (IdlmmPackage.EXCEPTION_DEF__CONTAINING_MODULE) || eIsSet (IdlmmPackage.EXCEPTION_DEF__CONTAINING_INTERFACE)
            || eIsSet (IdlmmPackage.EXCEPTION_DEF__CONTAINING_REPOSITORY) || eIsSet (IdlmmPackage.EXCEPTION_DEF__CONTAINING_HOME);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean isSetContents ()
   {
      return super.isSetContents () || eIsSet (IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS);
   }

} //ExceptionDefImpl
