/**
 * <copyright>
 * </copyright>
 *
 * $Id: HomeDefImpl.java,v 1.2 2009/09/04 09:24:29 je Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.AliasContainer;
import com.prismtech.idt.idlmm.AliasDef;
import com.prismtech.idt.idlmm.AttributeContainer;
import com.prismtech.idt.idlmm.AttributeDef;
import com.prismtech.idt.idlmm.ComponentDef;
import com.prismtech.idt.idlmm.ConstantContainer;
import com.prismtech.idt.idlmm.ConstantDef;
import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.EnumContainer;
import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.ExceptionContainer;
import com.prismtech.idt.idlmm.ExceptionDef;
import com.prismtech.idt.idlmm.FactoryOperation;
import com.prismtech.idt.idlmm.FinderOperation;
import com.prismtech.idt.idlmm.HomeContained;
import com.prismtech.idt.idlmm.HomeDef;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.NativeContainer;
import com.prismtech.idt.idlmm.NativeDef;
import com.prismtech.idt.idlmm.OperationContainer;
import com.prismtech.idt.idlmm.OperationDef;
import com.prismtech.idt.idlmm.StructContainer;
import com.prismtech.idt.idlmm.StructDef;
import com.prismtech.idt.idlmm.UnionContainer;
import com.prismtech.idt.idlmm.UnionDef;
import com.prismtech.idt.idlmm.ValueDef;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.uml2.common.util.DerivedUnionEObjectEList;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Home Def</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getContents <em>Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllAttributes <em>All Attributes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getOperations <em>Operations</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllOperations <em>All Operations</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getConstants <em>Constants</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllConstants <em>All Constants</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getExceptions <em>Exceptions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllExceptions <em>All Exceptions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAliases <em>Aliases</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllAliases <em>All Aliases</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getStructs <em>Structs</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllStructs <em>All Structs</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getUnions <em>Unions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllUnions <em>All Unions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getEnums <em>Enums</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllEnums <em>All Enums</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getNatives <em>Natives</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllNatives <em>All Natives</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getManagedComponent <em>Managed Component</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getBaseHome <em>Base Home</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllBaseHomes <em>All Base Homes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getSupportedInterfaces <em>Supported Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllSupportedInterfaces <em>All Supported Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getPrimarykey <em>Primarykey</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getHomeContents <em>Home Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getFactoryOperations <em>Factory Operations</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllFactoryOperations <em>All Factory Operations</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getFinderOperations <em>Finder Operations</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.HomeDefImpl#getAllFinderOperations <em>All Finder Operations</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HomeDefImpl extends HomeImpl implements HomeDef
{
   /**
    * The cached value of the '{@link #getManagedComponent() <em>Managed Component</em>}' reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getManagedComponent()
    * @generated
    * @ordered
    */
   protected ComponentDef managedComponent;

   /**
    * The cached value of the '{@link #getBaseHome() <em>Base Home</em>}' reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getBaseHome()
    * @generated
    * @ordered
    */
   protected HomeDef baseHome;

   /**
    * The cached value of the '{@link #getSupportedInterfaces() <em>Supported Interfaces</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getSupportedInterfaces()
    * @generated
    * @ordered
    */
   protected EList<InterfaceDef> supportedInterfaces;

   /**
    * The cached value of the '{@link #getPrimarykey() <em>Primarykey</em>}' reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrimarykey()
    * @generated
    * @ordered
    */
   protected ValueDef primarykey;

   /**
    * The cached value of the '{@link #getHomeContents() <em>Home Contents</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getHomeContents()
    * @generated
    * @ordered
    */
   protected EList<HomeContained> homeContents;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected HomeDefImpl ()
   {
      super ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.HOME_DEF;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<Contained> getContents ()
   {
      return new DerivedUnionEObjectEList<Contained> (Contained.class, this, IdlmmPackage.HOME_DEF__CONTENTS, CONTENTS_ESUBSETS);
   }

   /**
    * The array of subset feature identifiers for the '{@link #getContents() <em>Contents</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getContents()
    * @generated
    * @ordered
    */
   protected static final int[] CONTENTS_ESUBSETS = new int[]
   {
      IdlmmPackage.HOME_DEF__HOME_CONTENTS
   };

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AttributeDef> getAttributes ()
   {
      return HomeDefExt.getAttributes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AttributeDef> getAllAttributes ()
   {
      return HomeDefExt.getAllAttributes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<OperationDef> getOperations ()
   {
      return HomeDefExt.getOperations (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<OperationDef> getAllOperations ()
   {
      return HomeDefExt.getAllOperations (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ConstantDef> getConstants ()
   {
      return HomeDefExt.getConstants (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ConstantDef> getAllConstants ()
   {
      return HomeDefExt.getAllConstants (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ExceptionDef> getExceptions ()
   {
      return HomeDefExt.getExceptions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ExceptionDef> getAllExceptions ()
   {
      return HomeDefExt.getAllExceptions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AliasDef> getAliases ()
   {
      return HomeDefExt.getAliases (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AliasDef> getAllAliases ()
   {
      return HomeDefExt.getAllAliases (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<StructDef> getStructs ()
   {
      return HomeDefExt.getStructs (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<StructDef> getAllStructs ()
   {
      return HomeDefExt.getAllStructs (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UnionDef> getUnions ()
   {
      return HomeDefExt.getUnions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UnionDef> getAllUnions ()
   {
      return HomeDefExt.getAllUnions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EnumDef> getEnums ()
   {
      return HomeDefExt.getEnums (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EnumDef> getAllEnums ()
   {
      return HomeDefExt.getAllEnums (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<NativeDef> getNatives ()
   {
      return HomeDefExt.getNatives (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<NativeDef> getAllNatives ()
   {
      return HomeDefExt.getAllNatives (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ComponentDef getManagedComponent ()
   {
      if (managedComponent != null && managedComponent.eIsProxy ())
      {
         InternalEObject oldManagedComponent = (InternalEObject) managedComponent;
         managedComponent = (ComponentDef) eResolveProxy (oldManagedComponent);
         if (managedComponent != oldManagedComponent)
         {
            if (eNotificationRequired ())
               eNotify (new ENotificationImpl (this, Notification.RESOLVE, IdlmmPackage.HOME_DEF__MANAGED_COMPONENT,
                     oldManagedComponent, managedComponent));
         }
      }
      return managedComponent;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ComponentDef basicGetManagedComponent ()
   {
      return managedComponent;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setManagedComponent (ComponentDef newManagedComponent)
   {
      ComponentDef oldManagedComponent = managedComponent;
      managedComponent = newManagedComponent;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.HOME_DEF__MANAGED_COMPONENT, oldManagedComponent,
               managedComponent));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public HomeDef getBaseHome ()
   {
      if (baseHome != null && baseHome.eIsProxy ())
      {
         InternalEObject oldBaseHome = (InternalEObject) baseHome;
         baseHome = (HomeDef) eResolveProxy (oldBaseHome);
         if (baseHome != oldBaseHome)
         {
            if (eNotificationRequired ())
               eNotify (new ENotificationImpl (this, Notification.RESOLVE, IdlmmPackage.HOME_DEF__BASE_HOME, oldBaseHome, baseHome));
         }
      }
      return baseHome;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public HomeDef basicGetBaseHome ()
   {
      return baseHome;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setBaseHome (HomeDef newBaseHome)
   {
      HomeDef oldBaseHome = baseHome;
      baseHome = newBaseHome;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.HOME_DEF__BASE_HOME, oldBaseHome, baseHome));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<HomeDef> getAllBaseHomes ()
   {
      return HomeDefExt.getAllBaseHomes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<InterfaceDef> getSupportedInterfaces ()
   {
      if (supportedInterfaces == null)
      {
         supportedInterfaces = new EObjectResolvingEList<InterfaceDef> (InterfaceDef.class, this,
               IdlmmPackage.HOME_DEF__SUPPORTED_INTERFACES);
      }
      return supportedInterfaces;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<InterfaceDef> getAllSupportedInterfaces ()
   {
      return HomeDefExt.getAllSupportedInterfaces (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ValueDef getPrimarykey ()
   {
      if (primarykey != null && primarykey.eIsProxy ())
      {
         InternalEObject oldPrimarykey = (InternalEObject) primarykey;
         primarykey = (ValueDef) eResolveProxy (oldPrimarykey);
         if (primarykey != oldPrimarykey)
         {
            if (eNotificationRequired ())
               eNotify (new ENotificationImpl (this, Notification.RESOLVE, IdlmmPackage.HOME_DEF__PRIMARYKEY, oldPrimarykey,
                     primarykey));
         }
      }
      return primarykey;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ValueDef basicGetPrimarykey ()
   {
      return primarykey;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setPrimarykey (ValueDef newPrimarykey)
   {
      ValueDef oldPrimarykey = primarykey;
      primarykey = newPrimarykey;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.HOME_DEF__PRIMARYKEY, oldPrimarykey, primarykey));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<HomeContained> getHomeContents ()
   {
      if (homeContents == null)
      {
         homeContents = new EObjectContainmentWithInverseEList<HomeContained> (HomeContained.class, this,
               IdlmmPackage.HOME_DEF__HOME_CONTENTS, IdlmmPackage.HOME_CONTAINED__CONTAINING_HOME);
      }
      return homeContents;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<FactoryOperation> getFactoryOperations ()
   {
      return HomeDefExt.getFactoryOperations (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<FactoryOperation> getAllFactoryOperations ()
   {
      return HomeDefExt.getAllFactoryOperations (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<FinderOperation> getFinderOperations ()
   {
      return HomeDefExt.getFinderOperations (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<FinderOperation> getAllFinderOperations ()
   {
      return HomeDefExt.getAllFinderOperations (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Contained lookup (String name)
   {
      return ContainerExt.lookup (this, name);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<IRObject> getPrerequisites ()
   {
      return HomeDefExt.getPrerequisites (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Contained lookup (String name, boolean inherited, boolean global)
   {
      return ContainerExt.lookup (this, name, inherited, global);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.HOME_DEF__HOME_CONTENTS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getHomeContents ()).basicAdd (otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.HOME_DEF__HOME_CONTENTS:
            return ((InternalEList<?>) getHomeContents ()).basicRemove (otherEnd, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.HOME_DEF__CONTENTS:
            return getContents ();
         case IdlmmPackage.HOME_DEF__ATTRIBUTES:
            return getAttributes ();
         case IdlmmPackage.HOME_DEF__ALL_ATTRIBUTES:
            return getAllAttributes ();
         case IdlmmPackage.HOME_DEF__OPERATIONS:
            return getOperations ();
         case IdlmmPackage.HOME_DEF__ALL_OPERATIONS:
            return getAllOperations ();
         case IdlmmPackage.HOME_DEF__CONSTANTS:
            return getConstants ();
         case IdlmmPackage.HOME_DEF__ALL_CONSTANTS:
            return getAllConstants ();
         case IdlmmPackage.HOME_DEF__EXCEPTIONS:
            return getExceptions ();
         case IdlmmPackage.HOME_DEF__ALL_EXCEPTIONS:
            return getAllExceptions ();
         case IdlmmPackage.HOME_DEF__ALIASES:
            return getAliases ();
         case IdlmmPackage.HOME_DEF__ALL_ALIASES:
            return getAllAliases ();
         case IdlmmPackage.HOME_DEF__STRUCTS:
            return getStructs ();
         case IdlmmPackage.HOME_DEF__ALL_STRUCTS:
            return getAllStructs ();
         case IdlmmPackage.HOME_DEF__UNIONS:
            return getUnions ();
         case IdlmmPackage.HOME_DEF__ALL_UNIONS:
            return getAllUnions ();
         case IdlmmPackage.HOME_DEF__ENUMS:
            return getEnums ();
         case IdlmmPackage.HOME_DEF__ALL_ENUMS:
            return getAllEnums ();
         case IdlmmPackage.HOME_DEF__NATIVES:
            return getNatives ();
         case IdlmmPackage.HOME_DEF__ALL_NATIVES:
            return getAllNatives ();
         case IdlmmPackage.HOME_DEF__MANAGED_COMPONENT:
            if (resolve)
               return getManagedComponent ();
            return basicGetManagedComponent ();
         case IdlmmPackage.HOME_DEF__BASE_HOME:
            if (resolve)
               return getBaseHome ();
            return basicGetBaseHome ();
         case IdlmmPackage.HOME_DEF__ALL_BASE_HOMES:
            return getAllBaseHomes ();
         case IdlmmPackage.HOME_DEF__SUPPORTED_INTERFACES:
            return getSupportedInterfaces ();
         case IdlmmPackage.HOME_DEF__ALL_SUPPORTED_INTERFACES:
            return getAllSupportedInterfaces ();
         case IdlmmPackage.HOME_DEF__PRIMARYKEY:
            if (resolve)
               return getPrimarykey ();
            return basicGetPrimarykey ();
         case IdlmmPackage.HOME_DEF__HOME_CONTENTS:
            return getHomeContents ();
         case IdlmmPackage.HOME_DEF__FACTORY_OPERATIONS:
            return getFactoryOperations ();
         case IdlmmPackage.HOME_DEF__ALL_FACTORY_OPERATIONS:
            return getAllFactoryOperations ();
         case IdlmmPackage.HOME_DEF__FINDER_OPERATIONS:
            return getFinderOperations ();
         case IdlmmPackage.HOME_DEF__ALL_FINDER_OPERATIONS:
            return getAllFinderOperations ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.HOME_DEF__MANAGED_COMPONENT:
            setManagedComponent ((ComponentDef) newValue);
            return;
         case IdlmmPackage.HOME_DEF__BASE_HOME:
            setBaseHome ((HomeDef) newValue);
            return;
         case IdlmmPackage.HOME_DEF__SUPPORTED_INTERFACES:
            getSupportedInterfaces ().clear ();
            getSupportedInterfaces ().addAll ((Collection<? extends InterfaceDef>) newValue);
            return;
         case IdlmmPackage.HOME_DEF__PRIMARYKEY:
            setPrimarykey ((ValueDef) newValue);
            return;
         case IdlmmPackage.HOME_DEF__HOME_CONTENTS:
            getHomeContents ().clear ();
            getHomeContents ().addAll ((Collection<? extends HomeContained>) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.HOME_DEF__MANAGED_COMPONENT:
            setManagedComponent ((ComponentDef) null);
            return;
         case IdlmmPackage.HOME_DEF__BASE_HOME:
            setBaseHome ((HomeDef) null);
            return;
         case IdlmmPackage.HOME_DEF__SUPPORTED_INTERFACES:
            getSupportedInterfaces ().clear ();
            return;
         case IdlmmPackage.HOME_DEF__PRIMARYKEY:
            setPrimarykey ((ValueDef) null);
            return;
         case IdlmmPackage.HOME_DEF__HOME_CONTENTS:
            getHomeContents ().clear ();
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.HOME_DEF__CONTENTS:
            return isSetContents ();
         case IdlmmPackage.HOME_DEF__ATTRIBUTES:
            return !getAttributes ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ALL_ATTRIBUTES:
            return !getAllAttributes ().isEmpty ();
         case IdlmmPackage.HOME_DEF__OPERATIONS:
            return !getOperations ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ALL_OPERATIONS:
            return !getAllOperations ().isEmpty ();
         case IdlmmPackage.HOME_DEF__CONSTANTS:
            return !getConstants ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ALL_CONSTANTS:
            return !getAllConstants ().isEmpty ();
         case IdlmmPackage.HOME_DEF__EXCEPTIONS:
            return !getExceptions ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ALL_EXCEPTIONS:
            return !getAllExceptions ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ALIASES:
            return !getAliases ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ALL_ALIASES:
            return !getAllAliases ().isEmpty ();
         case IdlmmPackage.HOME_DEF__STRUCTS:
            return !getStructs ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ALL_STRUCTS:
            return !getAllStructs ().isEmpty ();
         case IdlmmPackage.HOME_DEF__UNIONS:
            return !getUnions ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ALL_UNIONS:
            return !getAllUnions ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ENUMS:
            return !getEnums ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ALL_ENUMS:
            return !getAllEnums ().isEmpty ();
         case IdlmmPackage.HOME_DEF__NATIVES:
            return !getNatives ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ALL_NATIVES:
            return !getAllNatives ().isEmpty ();
         case IdlmmPackage.HOME_DEF__MANAGED_COMPONENT:
            return managedComponent != null;
         case IdlmmPackage.HOME_DEF__BASE_HOME:
            return baseHome != null;
         case IdlmmPackage.HOME_DEF__ALL_BASE_HOMES:
            return !getAllBaseHomes ().isEmpty ();
         case IdlmmPackage.HOME_DEF__SUPPORTED_INTERFACES:
            return supportedInterfaces != null && !supportedInterfaces.isEmpty ();
         case IdlmmPackage.HOME_DEF__ALL_SUPPORTED_INTERFACES:
            return !getAllSupportedInterfaces ().isEmpty ();
         case IdlmmPackage.HOME_DEF__PRIMARYKEY:
            return primarykey != null;
         case IdlmmPackage.HOME_DEF__HOME_CONTENTS:
            return homeContents != null && !homeContents.isEmpty ();
         case IdlmmPackage.HOME_DEF__FACTORY_OPERATIONS:
            return !getFactoryOperations ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ALL_FACTORY_OPERATIONS:
            return !getAllFactoryOperations ().isEmpty ();
         case IdlmmPackage.HOME_DEF__FINDER_OPERATIONS:
            return !getFinderOperations ().isEmpty ();
         case IdlmmPackage.HOME_DEF__ALL_FINDER_OPERATIONS:
            return !getAllFinderOperations ().isEmpty ();
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == Container.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.HOME_DEF__CONTENTS:
               return IdlmmPackage.CONTAINER__CONTENTS;
            default:
               return -1;
         }
      }
      if (baseClass == AttributeContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.HOME_DEF__ATTRIBUTES:
               return IdlmmPackage.ATTRIBUTE_CONTAINER__ATTRIBUTES;
            case IdlmmPackage.HOME_DEF__ALL_ATTRIBUTES:
               return IdlmmPackage.ATTRIBUTE_CONTAINER__ALL_ATTRIBUTES;
            default:
               return -1;
         }
      }
      if (baseClass == OperationContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.HOME_DEF__OPERATIONS:
               return IdlmmPackage.OPERATION_CONTAINER__OPERATIONS;
            case IdlmmPackage.HOME_DEF__ALL_OPERATIONS:
               return IdlmmPackage.OPERATION_CONTAINER__ALL_OPERATIONS;
            default:
               return -1;
         }
      }
      if (baseClass == ConstantContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.HOME_DEF__CONSTANTS:
               return IdlmmPackage.CONSTANT_CONTAINER__CONSTANTS;
            case IdlmmPackage.HOME_DEF__ALL_CONSTANTS:
               return IdlmmPackage.CONSTANT_CONTAINER__ALL_CONSTANTS;
            default:
               return -1;
         }
      }
      if (baseClass == ExceptionContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.HOME_DEF__EXCEPTIONS:
               return IdlmmPackage.EXCEPTION_CONTAINER__EXCEPTIONS;
            case IdlmmPackage.HOME_DEF__ALL_EXCEPTIONS:
               return IdlmmPackage.EXCEPTION_CONTAINER__ALL_EXCEPTIONS;
            default:
               return -1;
         }
      }
      if (baseClass == AliasContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.HOME_DEF__ALIASES:
               return IdlmmPackage.ALIAS_CONTAINER__ALIASES;
            case IdlmmPackage.HOME_DEF__ALL_ALIASES:
               return IdlmmPackage.ALIAS_CONTAINER__ALL_ALIASES;
            default:
               return -1;
         }
      }
      if (baseClass == StructContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.HOME_DEF__STRUCTS:
               return IdlmmPackage.STRUCT_CONTAINER__STRUCTS;
            case IdlmmPackage.HOME_DEF__ALL_STRUCTS:
               return IdlmmPackage.STRUCT_CONTAINER__ALL_STRUCTS;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.HOME_DEF__UNIONS:
               return IdlmmPackage.UNION_CONTAINER__UNIONS;
            case IdlmmPackage.HOME_DEF__ALL_UNIONS:
               return IdlmmPackage.UNION_CONTAINER__ALL_UNIONS;
            default:
               return -1;
         }
      }
      if (baseClass == EnumContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.HOME_DEF__ENUMS:
               return IdlmmPackage.ENUM_CONTAINER__ENUMS;
            case IdlmmPackage.HOME_DEF__ALL_ENUMS:
               return IdlmmPackage.ENUM_CONTAINER__ALL_ENUMS;
            default:
               return -1;
         }
      }
      if (baseClass == NativeContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.HOME_DEF__NATIVES:
               return IdlmmPackage.NATIVE_CONTAINER__NATIVES;
            case IdlmmPackage.HOME_DEF__ALL_NATIVES:
               return IdlmmPackage.NATIVE_CONTAINER__ALL_NATIVES;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == Container.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINER__CONTENTS:
               return IdlmmPackage.HOME_DEF__CONTENTS;
            default:
               return -1;
         }
      }
      if (baseClass == AttributeContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ATTRIBUTE_CONTAINER__ATTRIBUTES:
               return IdlmmPackage.HOME_DEF__ATTRIBUTES;
            case IdlmmPackage.ATTRIBUTE_CONTAINER__ALL_ATTRIBUTES:
               return IdlmmPackage.HOME_DEF__ALL_ATTRIBUTES;
            default:
               return -1;
         }
      }
      if (baseClass == OperationContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.OPERATION_CONTAINER__OPERATIONS:
               return IdlmmPackage.HOME_DEF__OPERATIONS;
            case IdlmmPackage.OPERATION_CONTAINER__ALL_OPERATIONS:
               return IdlmmPackage.HOME_DEF__ALL_OPERATIONS;
            default:
               return -1;
         }
      }
      if (baseClass == ConstantContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONSTANT_CONTAINER__CONSTANTS:
               return IdlmmPackage.HOME_DEF__CONSTANTS;
            case IdlmmPackage.CONSTANT_CONTAINER__ALL_CONSTANTS:
               return IdlmmPackage.HOME_DEF__ALL_CONSTANTS;
            default:
               return -1;
         }
      }
      if (baseClass == ExceptionContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.EXCEPTION_CONTAINER__EXCEPTIONS:
               return IdlmmPackage.HOME_DEF__EXCEPTIONS;
            case IdlmmPackage.EXCEPTION_CONTAINER__ALL_EXCEPTIONS:
               return IdlmmPackage.HOME_DEF__ALL_EXCEPTIONS;
            default:
               return -1;
         }
      }
      if (baseClass == AliasContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ALIAS_CONTAINER__ALIASES:
               return IdlmmPackage.HOME_DEF__ALIASES;
            case IdlmmPackage.ALIAS_CONTAINER__ALL_ALIASES:
               return IdlmmPackage.HOME_DEF__ALL_ALIASES;
            default:
               return -1;
         }
      }
      if (baseClass == StructContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.STRUCT_CONTAINER__STRUCTS:
               return IdlmmPackage.HOME_DEF__STRUCTS;
            case IdlmmPackage.STRUCT_CONTAINER__ALL_STRUCTS:
               return IdlmmPackage.HOME_DEF__ALL_STRUCTS;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.UNION_CONTAINER__UNIONS:
               return IdlmmPackage.HOME_DEF__UNIONS;
            case IdlmmPackage.UNION_CONTAINER__ALL_UNIONS:
               return IdlmmPackage.HOME_DEF__ALL_UNIONS;
            default:
               return -1;
         }
      }
      if (baseClass == EnumContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ENUM_CONTAINER__ENUMS:
               return IdlmmPackage.HOME_DEF__ENUMS;
            case IdlmmPackage.ENUM_CONTAINER__ALL_ENUMS:
               return IdlmmPackage.HOME_DEF__ALL_ENUMS;
            default:
               return -1;
         }
      }
      if (baseClass == NativeContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.NATIVE_CONTAINER__NATIVES:
               return IdlmmPackage.HOME_DEF__NATIVES;
            case IdlmmPackage.NATIVE_CONTAINER__ALL_NATIVES:
               return IdlmmPackage.HOME_DEF__ALL_NATIVES;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContents ()
   {
      return eIsSet (IdlmmPackage.HOME_DEF__HOME_CONTENTS);
   }

} //HomeDefImpl
