/**
 * <copyright>
 * </copyright>
 *
 * $Id: InterfaceImpl.java,v 1.13 2008/07/02 14:58:57 gm Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.Interface;
import com.prismtech.idt.idlmm.InterfaceModifier;
import com.prismtech.idt.idlmm.ModuleContained;
import com.prismtech.idt.idlmm.ModuleDef;
import com.prismtech.idt.idlmm.Named;
import com.prismtech.idt.idlmm.Repository;
import com.prismtech.idt.idlmm.RepositoryContained;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Interface</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceImpl#getKey <em>Key</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceImpl#getContainer <em>Container</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceImpl#getAbsoluteName <em>Absolute Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceImpl#getPrefix <em>Prefix</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceImpl#getID <em>ID</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceImpl#getVersion <em>Version</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceImpl#getContainingModule <em>Containing Module</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceImpl#getContainingRepository <em>Containing Repository</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceImpl#getModifier <em>Modifier</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class InterfaceImpl extends SharedIDLTypeImpl implements Interface
{
   /**
    * The default value of the '{@link #getName() <em>Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getName()
    * @generated
    * @ordered
    */
   protected static final String NAME_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getName()
    * @generated
    * @ordered
    */
   protected String name = NAME_EDEFAULT;

   /**
    * The default value of the '{@link #getKey() <em>Key</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getKey()
    * @generated
    * @ordered
    */
   protected static final String KEY_EDEFAULT = null;

   /**
    * The default value of the '{@link #getAbsoluteName() <em>Absolute Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getAbsoluteName()
    * @generated
    * @ordered
    */
   protected static final String ABSOLUTE_NAME_EDEFAULT = null;

   /**
    * The default value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected static final String PREFIX_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected String prefix = PREFIX_EDEFAULT;

   /**
    * The default value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected static final String ID_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected String id = ID_EDEFAULT;

   /**
    * The default value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected static final String VERSION_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected String version = VERSION_EDEFAULT;

   /**
    * The default value of the '{@link #getModifier() <em>Modifier</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getModifier()
    * @generated
    * @ordered
    */
   protected static final InterfaceModifier MODIFIER_EDEFAULT = InterfaceModifier.IF_REGULAR;

   /**
    * The cached value of the '{@link #getModifier() <em>Modifier</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getModifier()
    * @generated
    * @ordered
    */
   protected InterfaceModifier modifier = MODIFIER_EDEFAULT;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected InterfaceImpl ()
   {
      super ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.INTERFACE;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getName ()
   {
      return name;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setName (String newName)
   {
      String oldName = name;
      name = newName;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE__NAME, oldName, name));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getKey ()
   {
      return NamedExt.getKey (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public InterfaceModifier getModifier ()
   {
      return modifier;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setModifier (InterfaceModifier newModifier)
   {
      InterfaceModifier oldModifier = modifier;
      modifier = newModifier == null ? MODIFIER_EDEFAULT : newModifier;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE__MODIFIER, oldModifier, modifier));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public void setContainer (Container newContainer)
   {
      ContainedExt.setContainer (this, newContainer);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Container getContainer ()
   {
      Container container = basicGetContainer ();
      return container != null && container.eIsProxy () ? (Container) eResolveProxy ((InternalEObject) container) : container;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Container basicGetContainer ()
   {
      ModuleDef containingModule = getContainingModule ();
      if (containingModule != null)
      {
         return containingModule;
      }
      Repository containingRepository = getContainingRepository ();
      if (containingRepository != null)
      {
         return containingRepository;
      }
      return null;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getAbsoluteName ()
   {
      return ContainedExt.getAbsoluteName (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getPrefix ()
   {
      return prefix;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setPrefix (String newPrefix)
   {
      String oldPrefix = prefix;
      prefix = newPrefix;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE__PREFIX, oldPrefix, prefix));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getID ()
   {
      return ContainedExt.getID (this, id);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setID (String newID)
   {
      String oldID = id;
      id = newID;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE__ID, oldID, id));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getVersion ()
   {
      return version;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setVersion (String newVersion)
   {
      String oldVersion = version;
      version = newVersion;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE__VERSION, oldVersion, version));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ModuleDef getContainingModule ()
   {
      if (eContainerFeatureID != IdlmmPackage.INTERFACE__CONTAINING_MODULE)
         return null;
      return (ModuleDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingModule (ModuleDef newContainingModule, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingModule, IdlmmPackage.INTERFACE__CONTAINING_MODULE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingModule (ModuleDef newContainingModule)
   {
      if (newContainingModule != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.INTERFACE__CONTAINING_MODULE && newContainingModule != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingModule))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingModule != null)
            msgs = ((InternalEObject) newContainingModule).eInverseAdd (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS,
                  ModuleDef.class, msgs);
         msgs = basicSetContainingModule (newContainingModule, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE__CONTAINING_MODULE, newContainingModule,
               newContainingModule));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Repository getContainingRepository ()
   {
      if (eContainerFeatureID != IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY)
         return null;
      return (Repository) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingRepository (Repository newContainingRepository, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingRepository, IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingRepository (Repository newContainingRepository)
   {
      if (newContainingRepository != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY && newContainingRepository != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingRepository))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingRepository != null)
            msgs = ((InternalEObject) newContainingRepository).eInverseAdd (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS,
                  Repository.class, msgs);
         msgs = basicSetContainingRepository (newContainingRepository, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY,
               newContainingRepository, newContainingRepository));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<IRObject> getPrerequisites ()
   {
      return InterfaceExt.getPrerequisites (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.INTERFACE__CONTAINING_MODULE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingModule ((ModuleDef) otherEnd, msgs);
         case IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingRepository ((Repository) otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.INTERFACE__CONTAINING_MODULE:
            return basicSetContainingModule (null, msgs);
         case IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY:
            return basicSetContainingRepository (null, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature (NotificationChain msgs)
   {
      switch (eContainerFeatureID)
      {
         case IdlmmPackage.INTERFACE__CONTAINING_MODULE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS, ModuleDef.class, msgs);
         case IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY:
            return eInternalContainer ()
                  .eInverseRemove (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS, Repository.class, msgs);
      }
      return super.eBasicRemoveFromContainerFeature (msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.INTERFACE__NAME:
            return getName ();
         case IdlmmPackage.INTERFACE__KEY:
            return getKey ();
         case IdlmmPackage.INTERFACE__CONTAINER:
            if (resolve)
               return getContainer ();
            return basicGetContainer ();
         case IdlmmPackage.INTERFACE__ABSOLUTE_NAME:
            return getAbsoluteName ();
         case IdlmmPackage.INTERFACE__PREFIX:
            return getPrefix ();
         case IdlmmPackage.INTERFACE__ID:
            return getID ();
         case IdlmmPackage.INTERFACE__VERSION:
            return getVersion ();
         case IdlmmPackage.INTERFACE__CONTAINING_MODULE:
            return getContainingModule ();
         case IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY:
            return getContainingRepository ();
         case IdlmmPackage.INTERFACE__MODIFIER:
            return getModifier ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.INTERFACE__NAME:
            setName ((String) newValue);
            return;
         case IdlmmPackage.INTERFACE__CONTAINER:
            setContainer ((Container) newValue);
            return;
         case IdlmmPackage.INTERFACE__PREFIX:
            setPrefix ((String) newValue);
            return;
         case IdlmmPackage.INTERFACE__ID:
            setID ((String) newValue);
            return;
         case IdlmmPackage.INTERFACE__VERSION:
            setVersion ((String) newValue);
            return;
         case IdlmmPackage.INTERFACE__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) newValue);
            return;
         case IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) newValue);
            return;
         case IdlmmPackage.INTERFACE__MODIFIER:
            setModifier ((InterfaceModifier) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.INTERFACE__NAME:
            setName (NAME_EDEFAULT);
            return;
         case IdlmmPackage.INTERFACE__CONTAINER:
            setContainer ((Container) null);
            return;
         case IdlmmPackage.INTERFACE__PREFIX:
            setPrefix (PREFIX_EDEFAULT);
            return;
         case IdlmmPackage.INTERFACE__ID:
            setID (ID_EDEFAULT);
            return;
         case IdlmmPackage.INTERFACE__VERSION:
            setVersion (VERSION_EDEFAULT);
            return;
         case IdlmmPackage.INTERFACE__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) null);
            return;
         case IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) null);
            return;
         case IdlmmPackage.INTERFACE__MODIFIER:
            setModifier (MODIFIER_EDEFAULT);
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.INTERFACE__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals (name);
         case IdlmmPackage.INTERFACE__KEY:
            return KEY_EDEFAULT == null ? getKey () != null : !KEY_EDEFAULT.equals (getKey ());
         case IdlmmPackage.INTERFACE__CONTAINER:
            return isSetContainer ();
         case IdlmmPackage.INTERFACE__ABSOLUTE_NAME:
            return ABSOLUTE_NAME_EDEFAULT == null ? getAbsoluteName () != null : !ABSOLUTE_NAME_EDEFAULT
                  .equals (getAbsoluteName ());
         case IdlmmPackage.INTERFACE__PREFIX:
            return PREFIX_EDEFAULT == null ? prefix != null : !PREFIX_EDEFAULT.equals (prefix);
         case IdlmmPackage.INTERFACE__ID:
            return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals (id);
         case IdlmmPackage.INTERFACE__VERSION:
            return VERSION_EDEFAULT == null ? version != null : !VERSION_EDEFAULT.equals (version);
         case IdlmmPackage.INTERFACE__CONTAINING_MODULE:
            return getContainingModule () != null;
         case IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY:
            return getContainingRepository () != null;
         case IdlmmPackage.INTERFACE__MODIFIER:
            return modifier != MODIFIER_EDEFAULT;
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == Named.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE__NAME:
               return IdlmmPackage.NAMED__NAME;
            case IdlmmPackage.INTERFACE__KEY:
               return IdlmmPackage.NAMED__KEY;
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE__ABSOLUTE_NAME:
               return IdlmmPackage.CONTAINED__ABSOLUTE_NAME;
            case IdlmmPackage.INTERFACE__PREFIX:
               return IdlmmPackage.CONTAINED__PREFIX;
            case IdlmmPackage.INTERFACE__ID:
               return IdlmmPackage.CONTAINED__ID;
            case IdlmmPackage.INTERFACE__VERSION:
               return IdlmmPackage.CONTAINED__VERSION;
            case IdlmmPackage.INTERFACE__CONTAINER:
               return IdlmmPackage.CONTAINED__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE__CONTAINING_MODULE:
               return IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == RepositoryContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY:
               return IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == Named.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.NAMED__NAME:
               return IdlmmPackage.INTERFACE__NAME;
            case IdlmmPackage.NAMED__KEY:
               return IdlmmPackage.INTERFACE__KEY;
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINED__ABSOLUTE_NAME:
               return IdlmmPackage.INTERFACE__ABSOLUTE_NAME;
            case IdlmmPackage.CONTAINED__PREFIX:
               return IdlmmPackage.INTERFACE__PREFIX;
            case IdlmmPackage.CONTAINED__ID:
               return IdlmmPackage.INTERFACE__ID;
            case IdlmmPackage.CONTAINED__VERSION:
               return IdlmmPackage.INTERFACE__VERSION;
            case IdlmmPackage.CONTAINED__CONTAINER:
               return IdlmmPackage.INTERFACE__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE:
               return IdlmmPackage.INTERFACE__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == RepositoryContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY:
               return IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String toString ()
   {
      if (eIsProxy ())
         return super.toString ();

      StringBuffer result = new StringBuffer (super.toString ());
      result.append (" (name: ");
      result.append (name);
      result.append (", prefix: ");
      result.append (prefix);
      result.append (", ID: ");
      result.append (id);
      result.append (", version: ");
      result.append (version);
      result.append (", modifier: ");
      result.append (modifier);
      result.append (')');
      return result.toString ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContainer ()
   {
      return eIsSet (IdlmmPackage.INTERFACE__CONTAINING_MODULE) || eIsSet (IdlmmPackage.INTERFACE__CONTAINING_REPOSITORY);
   }

} //InterfaceImpl
