/**
 * <copyright>
 * </copyright>
 *
 * $Id: ModuleDefImpl.java,v 1.39 2008/08/22 11:55:33 je Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.AliasContainer;
import com.prismtech.idt.idlmm.AliasDef;
import com.prismtech.idt.idlmm.ConstantContainer;
import com.prismtech.idt.idlmm.ConstantDef;
import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.EnumContainer;
import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.ExceptionContainer;
import com.prismtech.idt.idlmm.ExceptionDef;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.ModuleContained;
import com.prismtech.idt.idlmm.ModuleDef;
import com.prismtech.idt.idlmm.NativeContainer;
import com.prismtech.idt.idlmm.NativeDef;
import com.prismtech.idt.idlmm.StructContainer;
import com.prismtech.idt.idlmm.StructDef;
import com.prismtech.idt.idlmm.UnionContainer;
import com.prismtech.idt.idlmm.UnionDef;
import com.prismtech.idt.idlmm.ValueBoxDef;
import com.prismtech.idt.idlmm.ValueDef;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.uml2.common.util.DerivedUnionEObjectEList;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Module Def</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getContainer <em>Container</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getContainingModule <em>Containing Module</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getContents <em>Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getExceptions <em>Exceptions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getAllExceptions <em>All Exceptions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getStructs <em>Structs</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getAllStructs <em>All Structs</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getEnums <em>Enums</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getAllEnums <em>All Enums</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getUnions <em>Unions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getAllUnions <em>All Unions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getNatives <em>Natives</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getAllNatives <em>All Natives</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getAliases <em>Aliases</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getAllAliases <em>All Aliases</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getConstants <em>Constants</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getAllConstants <em>All Constants</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getModuleContents <em>Module Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getInterfaces <em>Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getModules <em>Modules</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ModuleDefImpl#getValueTypes <em>Value Types</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ModuleDefImpl extends RepositoryContainedImpl implements ModuleDef
{
   /**
    * The cached value of the '{@link #getModuleContents() <em>Module Contents</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getModuleContents()
    * @generated
    * @ordered
    */
   protected EList<ModuleContained> moduleContents;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ModuleDefImpl ()
   {
      super ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.MODULE_DEF;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Container getContainer ()
   {
      Container container = basicGetContainer ();
      return container != null && container.eIsProxy () ? (Container) eResolveProxy ((InternalEObject) container) : container;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Container basicGetContainer ()
   {
      ModuleDef containingModule = getContainingModule ();
      if (containingModule != null)
      {
         return containingModule;
      }
      return super.basicGetContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<ModuleContained> getModuleContents ()
   {
      if (moduleContents == null)
      {
         moduleContents = new EObjectContainmentWithInverseEList<ModuleContained> (ModuleContained.class, this,
               IdlmmPackage.MODULE_DEF__MODULE_CONTENTS, IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE);
      }
      return moduleContents;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<Contained> getContents ()
   {
      return new DerivedUnionEObjectEList<Contained> (Contained.class, this, IdlmmPackage.MODULE_DEF__CONTENTS, CONTENTS_ESUBSETS);
   }

   /**
    * The array of subset feature identifiers for the '{@link #getContents() <em>Contents</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getContents()
    * @generated
    * @ordered
    */
   protected static final int[] CONTENTS_ESUBSETS = new int[]
   {
      IdlmmPackage.MODULE_DEF__MODULE_CONTENTS
   };

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Contained lookup (String name)
   {
      return ContainerExt.lookup (this, name);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<IRObject> getPrerequisites ()
   {
      return ContainerExt.getPrerequisites (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Contained lookup (String name, boolean inherited, boolean global)
   {
      return ContainerExt.lookup (this, name, inherited, global);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   @Override
   public void setContainer (Container newContainer)
   {
      ContainedExt.setContainer (this, newContainer);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ModuleDef getContainingModule ()
   {
      if (eContainerFeatureID != IdlmmPackage.MODULE_DEF__CONTAINING_MODULE)
         return null;
      return (ModuleDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingModule (ModuleDef newContainingModule, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingModule, IdlmmPackage.MODULE_DEF__CONTAINING_MODULE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingModule (ModuleDef newContainingModule)
   {
      if (newContainingModule != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.MODULE_DEF__CONTAINING_MODULE && newContainingModule != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingModule))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingModule != null)
            msgs = ((InternalEObject) newContainingModule).eInverseAdd (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS,
                  ModuleDef.class, msgs);
         msgs = basicSetContainingModule (newContainingModule, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.MODULE_DEF__CONTAINING_MODULE, newContainingModule,
               newContainingModule));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AliasDef> getAliases ()
   {
      return ModuleDefExt.getAliases (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AliasDef> getAllAliases ()
   {
      return ModuleDefExt.getAliases (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ConstantDef> getConstants ()
   {
      return ModuleDefExt.getConstants (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ConstantDef> getAllConstants ()
   {
      return ModuleDefExt.getConstants (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EnumDef> getEnums ()
   {
      return ModuleDefExt.getEnums (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EnumDef> getAllEnums ()
   {
      return ModuleDefExt.getEnums (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ExceptionDef> getExceptions ()
   {
      return ModuleDefExt.getExceptions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ExceptionDef> getAllExceptions ()
   {
      return ModuleDefExt.getAllExceptions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<InterfaceDef> getInterfaces ()
   {
      return ModuleDefExt.getInterfaces (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ModuleDef> getModules ()
   {
      return ModuleDefExt.getModules (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<NativeDef> getNatives ()
   {
      return ModuleDefExt.getNatives (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<NativeDef> getAllNatives ()
   {
      return ModuleDefExt.getAllNatives (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<StructDef> getStructs ()
   {
      return ModuleDefExt.getStructs (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<StructDef> getAllStructs ()
   {
      return ModuleDefExt.getAllStructs (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UnionDef> getUnions ()
   {
      return ModuleDefExt.getUnions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UnionDef> getAllUnions ()
   {
      return ModuleDefExt.getAllUnions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<ValueBoxDef> getValueBoxes ()
   {
      return ModuleDefExt.getValueBoxes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ValueDef> getValueTypes ()
   {
      return ModuleDefExt.getValueTypes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<ModuleDef> getAllModules (boolean inclusive)
   {
      return ModuleDefExt.getAllModules (this, inclusive);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.MODULE_DEF__CONTAINING_MODULE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingModule ((ModuleDef) otherEnd, msgs);
         case IdlmmPackage.MODULE_DEF__MODULE_CONTENTS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getModuleContents ()).basicAdd (otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.MODULE_DEF__CONTAINING_MODULE:
            return basicSetContainingModule (null, msgs);
         case IdlmmPackage.MODULE_DEF__MODULE_CONTENTS:
            return ((InternalEList<?>) getModuleContents ()).basicRemove (otherEnd, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature (NotificationChain msgs)
   {
      switch (eContainerFeatureID)
      {
         case IdlmmPackage.MODULE_DEF__CONTAINING_MODULE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS, ModuleDef.class, msgs);
      }
      return super.eBasicRemoveFromContainerFeature (msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.MODULE_DEF__CONTAINING_MODULE:
            return getContainingModule ();
         case IdlmmPackage.MODULE_DEF__CONTENTS:
            return getContents ();
         case IdlmmPackage.MODULE_DEF__EXCEPTIONS:
            return getExceptions ();
         case IdlmmPackage.MODULE_DEF__ALL_EXCEPTIONS:
            return getAllExceptions ();
         case IdlmmPackage.MODULE_DEF__STRUCTS:
            return getStructs ();
         case IdlmmPackage.MODULE_DEF__ALL_STRUCTS:
            return getAllStructs ();
         case IdlmmPackage.MODULE_DEF__ENUMS:
            return getEnums ();
         case IdlmmPackage.MODULE_DEF__ALL_ENUMS:
            return getAllEnums ();
         case IdlmmPackage.MODULE_DEF__UNIONS:
            return getUnions ();
         case IdlmmPackage.MODULE_DEF__ALL_UNIONS:
            return getAllUnions ();
         case IdlmmPackage.MODULE_DEF__NATIVES:
            return getNatives ();
         case IdlmmPackage.MODULE_DEF__ALL_NATIVES:
            return getAllNatives ();
         case IdlmmPackage.MODULE_DEF__ALIASES:
            return getAliases ();
         case IdlmmPackage.MODULE_DEF__ALL_ALIASES:
            return getAllAliases ();
         case IdlmmPackage.MODULE_DEF__CONSTANTS:
            return getConstants ();
         case IdlmmPackage.MODULE_DEF__ALL_CONSTANTS:
            return getAllConstants ();
         case IdlmmPackage.MODULE_DEF__MODULE_CONTENTS:
            return getModuleContents ();
         case IdlmmPackage.MODULE_DEF__INTERFACES:
            return getInterfaces ();
         case IdlmmPackage.MODULE_DEF__MODULES:
            return getModules ();
         case IdlmmPackage.MODULE_DEF__VALUE_TYPES:
            return getValueTypes ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.MODULE_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) newValue);
            return;
         case IdlmmPackage.MODULE_DEF__MODULE_CONTENTS:
            getModuleContents ().clear ();
            getModuleContents ().addAll ((Collection<? extends ModuleContained>) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.MODULE_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) null);
            return;
         case IdlmmPackage.MODULE_DEF__MODULE_CONTENTS:
            getModuleContents ().clear ();
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.MODULE_DEF__CONTAINING_MODULE:
            return getContainingModule () != null;
         case IdlmmPackage.MODULE_DEF__CONTENTS:
            return isSetContents ();
         case IdlmmPackage.MODULE_DEF__EXCEPTIONS:
            return !getExceptions ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__ALL_EXCEPTIONS:
            return !getAllExceptions ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__STRUCTS:
            return !getStructs ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__ALL_STRUCTS:
            return !getAllStructs ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__ENUMS:
            return !getEnums ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__ALL_ENUMS:
            return !getAllEnums ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__UNIONS:
            return !getUnions ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__ALL_UNIONS:
            return !getAllUnions ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__NATIVES:
            return !getNatives ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__ALL_NATIVES:
            return !getAllNatives ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__ALIASES:
            return !getAliases ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__ALL_ALIASES:
            return !getAllAliases ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__CONSTANTS:
            return !getConstants ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__ALL_CONSTANTS:
            return !getAllConstants ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__MODULE_CONTENTS:
            return moduleContents != null && !moduleContents.isEmpty ();
         case IdlmmPackage.MODULE_DEF__INTERFACES:
            return !getInterfaces ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__MODULES:
            return !getModules ().isEmpty ();
         case IdlmmPackage.MODULE_DEF__VALUE_TYPES:
            return !getValueTypes ().isEmpty ();
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == ModuleContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.MODULE_DEF__CONTAINING_MODULE:
               return IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == Container.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.MODULE_DEF__CONTENTS:
               return IdlmmPackage.CONTAINER__CONTENTS;
            default:
               return -1;
         }
      }
      if (baseClass == ExceptionContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.MODULE_DEF__EXCEPTIONS:
               return IdlmmPackage.EXCEPTION_CONTAINER__EXCEPTIONS;
            case IdlmmPackage.MODULE_DEF__ALL_EXCEPTIONS:
               return IdlmmPackage.EXCEPTION_CONTAINER__ALL_EXCEPTIONS;
            default:
               return -1;
         }
      }
      if (baseClass == StructContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.MODULE_DEF__STRUCTS:
               return IdlmmPackage.STRUCT_CONTAINER__STRUCTS;
            case IdlmmPackage.MODULE_DEF__ALL_STRUCTS:
               return IdlmmPackage.STRUCT_CONTAINER__ALL_STRUCTS;
            default:
               return -1;
         }
      }
      if (baseClass == EnumContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.MODULE_DEF__ENUMS:
               return IdlmmPackage.ENUM_CONTAINER__ENUMS;
            case IdlmmPackage.MODULE_DEF__ALL_ENUMS:
               return IdlmmPackage.ENUM_CONTAINER__ALL_ENUMS;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.MODULE_DEF__UNIONS:
               return IdlmmPackage.UNION_CONTAINER__UNIONS;
            case IdlmmPackage.MODULE_DEF__ALL_UNIONS:
               return IdlmmPackage.UNION_CONTAINER__ALL_UNIONS;
            default:
               return -1;
         }
      }
      if (baseClass == NativeContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.MODULE_DEF__NATIVES:
               return IdlmmPackage.NATIVE_CONTAINER__NATIVES;
            case IdlmmPackage.MODULE_DEF__ALL_NATIVES:
               return IdlmmPackage.NATIVE_CONTAINER__ALL_NATIVES;
            default:
               return -1;
         }
      }
      if (baseClass == AliasContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.MODULE_DEF__ALIASES:
               return IdlmmPackage.ALIAS_CONTAINER__ALIASES;
            case IdlmmPackage.MODULE_DEF__ALL_ALIASES:
               return IdlmmPackage.ALIAS_CONTAINER__ALL_ALIASES;
            default:
               return -1;
         }
      }
      if (baseClass == ConstantContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.MODULE_DEF__CONSTANTS:
               return IdlmmPackage.CONSTANT_CONTAINER__CONSTANTS;
            case IdlmmPackage.MODULE_DEF__ALL_CONSTANTS:
               return IdlmmPackage.CONSTANT_CONTAINER__ALL_CONSTANTS;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == ModuleContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE:
               return IdlmmPackage.MODULE_DEF__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == Container.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINER__CONTENTS:
               return IdlmmPackage.MODULE_DEF__CONTENTS;
            default:
               return -1;
         }
      }
      if (baseClass == ExceptionContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.EXCEPTION_CONTAINER__EXCEPTIONS:
               return IdlmmPackage.MODULE_DEF__EXCEPTIONS;
            case IdlmmPackage.EXCEPTION_CONTAINER__ALL_EXCEPTIONS:
               return IdlmmPackage.MODULE_DEF__ALL_EXCEPTIONS;
            default:
               return -1;
         }
      }
      if (baseClass == StructContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.STRUCT_CONTAINER__STRUCTS:
               return IdlmmPackage.MODULE_DEF__STRUCTS;
            case IdlmmPackage.STRUCT_CONTAINER__ALL_STRUCTS:
               return IdlmmPackage.MODULE_DEF__ALL_STRUCTS;
            default:
               return -1;
         }
      }
      if (baseClass == EnumContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ENUM_CONTAINER__ENUMS:
               return IdlmmPackage.MODULE_DEF__ENUMS;
            case IdlmmPackage.ENUM_CONTAINER__ALL_ENUMS:
               return IdlmmPackage.MODULE_DEF__ALL_ENUMS;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.UNION_CONTAINER__UNIONS:
               return IdlmmPackage.MODULE_DEF__UNIONS;
            case IdlmmPackage.UNION_CONTAINER__ALL_UNIONS:
               return IdlmmPackage.MODULE_DEF__ALL_UNIONS;
            default:
               return -1;
         }
      }
      if (baseClass == NativeContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.NATIVE_CONTAINER__NATIVES:
               return IdlmmPackage.MODULE_DEF__NATIVES;
            case IdlmmPackage.NATIVE_CONTAINER__ALL_NATIVES:
               return IdlmmPackage.MODULE_DEF__ALL_NATIVES;
            default:
               return -1;
         }
      }
      if (baseClass == AliasContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ALIAS_CONTAINER__ALIASES:
               return IdlmmPackage.MODULE_DEF__ALIASES;
            case IdlmmPackage.ALIAS_CONTAINER__ALL_ALIASES:
               return IdlmmPackage.MODULE_DEF__ALL_ALIASES;
            default:
               return -1;
         }
      }
      if (baseClass == ConstantContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONSTANT_CONTAINER__CONSTANTS:
               return IdlmmPackage.MODULE_DEF__CONSTANTS;
            case IdlmmPackage.CONSTANT_CONTAINER__ALL_CONSTANTS:
               return IdlmmPackage.MODULE_DEF__ALL_CONSTANTS;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean isSetContainer ()
   {
      return super.isSetContainer () || eIsSet (IdlmmPackage.MODULE_DEF__CONTAINING_MODULE);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContents ()
   {
      return eIsSet (IdlmmPackage.MODULE_DEF__MODULE_CONTENTS);
   }

} //ModuleDefImpl
