/**
 * <copyright>
 * </copyright>
 *
 * $Id: UnionDefImpl.java,v 1.44 2009/09/04 09:24:29 je Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.EnumContainer;
import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.ExceptionContained;
import com.prismtech.idt.idlmm.ExceptionDef;
import com.prismtech.idt.idlmm.HomeContained;
import com.prismtech.idt.idlmm.HomeDef;
import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.InterfaceContained;
import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.ModuleContained;
import com.prismtech.idt.idlmm.ModuleDef;
import com.prismtech.idt.idlmm.OwnedIDLType;
import com.prismtech.idt.idlmm.PrimitiveKind;
import com.prismtech.idt.idlmm.Repository;
import com.prismtech.idt.idlmm.RepositoryContained;
import com.prismtech.idt.idlmm.SharedIDLType;
import com.prismtech.idt.idlmm.StructContained;
import com.prismtech.idt.idlmm.StructContainer;
import com.prismtech.idt.idlmm.StructDef;
import com.prismtech.idt.idlmm.Typed;
import com.prismtech.idt.idlmm.UnionContained;
import com.prismtech.idt.idlmm.UnionContainer;
import com.prismtech.idt.idlmm.UnionDef;
import com.prismtech.idt.idlmm.UnionMember;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.uml2.common.util.DerivedUnionEObjectEList;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Union Def</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getContents <em>Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getContainer <em>Container</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getContainingUnion <em>Containing Union</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getContainingRepository <em>Containing Repository</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getContainingException <em>Containing Exception</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getContainingModule <em>Containing Module</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getContainingStruct <em>Containing Struct</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getOwnedType <em>Owned Type</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getType <em>Type</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getSharedType <em>Shared Type</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getContainingInterface <em>Containing Interface</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getUnions <em>Unions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getAllUnions <em>All Unions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getStructs <em>Structs</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getAllStructs <em>All Structs</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getEnums <em>Enums</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getAllEnums <em>All Enums</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getContainingHome <em>Containing Home</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getUnionContents <em>Union Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.UnionDefImpl#getMembers <em>Members</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class UnionDefImpl extends TypedefDefImpl implements UnionDef
{
   /**
    * The cached value of the '{@link #getOwnedType() <em>Owned Type</em>}' containment reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getOwnedType()
    * @generated
    * @ordered
    */
   protected OwnedIDLType ownedType;

   /**
    * The cached value of the '{@link #getSharedType() <em>Shared Type</em>}' reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getSharedType()
    * @generated
    * @ordered
    */
   protected SharedIDLType sharedType;

   /**
    * The cached value of the '{@link #getUnionContents() <em>Union Contents</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getUnionContents()
    * @generated
    * @ordered
    */
   protected EList<UnionContained> unionContents;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   protected UnionDefImpl ()
   {
      super ();
      eAdapters ().add (new TypedTypeOwnedTypeAdapter ());
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.UNION_DEF;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public OwnedIDLType getOwnedType ()
   {
      return ownedType;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetOwnedType (OwnedIDLType newOwnedType, NotificationChain msgs)
   {
      OwnedIDLType oldOwnedType = ownedType;
      ownedType = newOwnedType;
      if (eNotificationRequired ())
      {
         ENotificationImpl notification = new ENotificationImpl (this, Notification.SET, IdlmmPackage.UNION_DEF__OWNED_TYPE,
               oldOwnedType, newOwnedType);
         if (msgs == null)
            msgs = notification;
         else
            msgs.add (notification);
      }
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setOwnedType (OwnedIDLType newOwnedType)
   {
      if (newOwnedType != ownedType)
      {
         NotificationChain msgs = null;
         if (ownedType != null)
            msgs = ((InternalEObject) ownedType).eInverseRemove (this, EOPPOSITE_FEATURE_BASE - IdlmmPackage.UNION_DEF__OWNED_TYPE,
                  null, msgs);
         if (newOwnedType != null)
            msgs = ((InternalEObject) newOwnedType).eInverseAdd (this, EOPPOSITE_FEATURE_BASE - IdlmmPackage.UNION_DEF__OWNED_TYPE,
                  null, msgs);
         msgs = basicSetOwnedType (newOwnedType, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.UNION_DEF__OWNED_TYPE, newOwnedType, newOwnedType));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public InterfaceDef getContainingInterface ()
   {
      if (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE)
         return null;
      return (InterfaceDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingInterface (InterfaceDef newContainingInterface, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingInterface, IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingInterface (InterfaceDef newContainingInterface)
   {
      if (newContainingInterface != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE && newContainingInterface != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingInterface))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingInterface != null)
            msgs = ((InternalEObject) newContainingInterface).eInverseAdd (this, IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS,
                  InterfaceDef.class, msgs);
         msgs = basicSetContainingInterface (newContainingInterface, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE,
               newContainingInterface, newContainingInterface));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<UnionContained> getUnionContents ()
   {
      if (unionContents == null)
      {
         unionContents = new EObjectContainmentWithInverseEList<UnionContained> (UnionContained.class, this,
               IdlmmPackage.UNION_DEF__UNION_CONTENTS, IdlmmPackage.UNION_CONTAINED__CONTAINING_UNION);
      }
      return unionContents;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<Contained> getContents ()
   {
      return new DerivedUnionEObjectEList<Contained> (Contained.class, this, IdlmmPackage.UNION_DEF__CONTENTS, CONTENTS_ESUBSETS);
   }

   /**
    * The array of subset feature identifiers for the '{@link #getContents() <em>Contents</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getContents()
    * @generated
    * @ordered
    */
   protected static final int[] CONTENTS_ESUBSETS = new int[]
   {
      IdlmmPackage.UNION_DEF__UNION_CONTENTS
   };

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Container getContainer ()
   {
      Container container = basicGetContainer ();
      return container != null && container.eIsProxy () ? (Container) eResolveProxy ((InternalEObject) container) : container;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Container basicGetContainer ()
   {
      UnionDef containingUnion = getContainingUnion ();
      if (containingUnion != null)
      {
         return containingUnion;
      }
      Repository containingRepository = getContainingRepository ();
      if (containingRepository != null)
      {
         return containingRepository;
      }
      ExceptionDef containingException = getContainingException ();
      if (containingException != null)
      {
         return containingException;
      }
      ModuleDef containingModule = getContainingModule ();
      if (containingModule != null)
      {
         return containingModule;
      }
      StructDef containingStruct = getContainingStruct ();
      if (containingStruct != null)
      {
         return containingStruct;
      }
      InterfaceDef containingInterface = getContainingInterface ();
      if (containingInterface != null)
      {
         return containingInterface;
      }
      HomeDef containingHome = getContainingHome ();
      if (containingHome != null)
      {
         return containingHome;
      }
      return super.basicGetContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Contained lookup (String name)
   {
      return ContainerExt.lookup (this, name);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<IRObject> getPrerequisites ()
   {
      return UnionDefExt.getPrerequisites (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Contained lookup (String name, boolean inherited, boolean global)
   {
      return ContainerExt.lookup (this, name, inherited, global);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public IDLType setType (PrimitiveKind kind)
   {
      return TypedExt.setType (this, kind);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public IDLType setType (String name)
   {
      return TypedExt.setType (this, name);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public void setType (IDLType newType)
   {
      TypedExt.setType (this, newType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public IDLType getType ()
   {
      IDLType type = basicGetType ();
      return type != null && type.eIsProxy () ? (IDLType) eResolveProxy ((InternalEObject) type) : type;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public IDLType basicGetType ()
   {
      return TypedExt.getType (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public SharedIDLType getSharedType ()
   {
      if (sharedType != null && sharedType.eIsProxy ())
      {
         InternalEObject oldSharedType = (InternalEObject) sharedType;
         sharedType = (SharedIDLType) eResolveProxy (oldSharedType);
         if (sharedType != oldSharedType)
         {
            if (eNotificationRequired ())
               eNotify (new ENotificationImpl (this, Notification.RESOLVE, IdlmmPackage.UNION_DEF__SHARED_TYPE, oldSharedType,
                     sharedType));
         }
      }
      return sharedType;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public SharedIDLType basicGetSharedType ()
   {
      return sharedType;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setSharedType (SharedIDLType newSharedType)
   {
      SharedIDLType oldSharedType = sharedType;
      sharedType = newSharedType;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.UNION_DEF__SHARED_TYPE, oldSharedType, sharedType));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   @Override
   public void setContainer (Container newContainer)
   {
      ContainedExt.setContainer (this, newContainer);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public UnionDef getContainingUnion ()
   {
      if (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_UNION)
         return null;
      return (UnionDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingUnion (UnionDef newContainingUnion, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingUnion, IdlmmPackage.UNION_DEF__CONTAINING_UNION, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingUnion (UnionDef newContainingUnion)
   {
      if (newContainingUnion != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_UNION && newContainingUnion != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingUnion))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingUnion != null)
            msgs = ((InternalEObject) newContainingUnion).eInverseAdd (this, IdlmmPackage.UNION_DEF__UNION_CONTENTS,
                  UnionDef.class, msgs);
         msgs = basicSetContainingUnion (newContainingUnion, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.UNION_DEF__CONTAINING_UNION, newContainingUnion,
               newContainingUnion));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Repository getContainingRepository ()
   {
      if (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY)
         return null;
      return (Repository) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingRepository (Repository newContainingRepository, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingRepository, IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingRepository (Repository newContainingRepository)
   {
      if (newContainingRepository != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY && newContainingRepository != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingRepository))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingRepository != null)
            msgs = ((InternalEObject) newContainingRepository).eInverseAdd (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS,
                  Repository.class, msgs);
         msgs = basicSetContainingRepository (newContainingRepository, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY,
               newContainingRepository, newContainingRepository));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ExceptionDef getContainingException ()
   {
      if (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION)
         return null;
      return (ExceptionDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingException (ExceptionDef newContainingException, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingException, IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingException (ExceptionDef newContainingException)
   {
      if (newContainingException != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION && newContainingException != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingException))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingException != null)
            msgs = ((InternalEObject) newContainingException).eInverseAdd (this, IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS,
                  ExceptionDef.class, msgs);
         msgs = basicSetContainingException (newContainingException, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION,
               newContainingException, newContainingException));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ModuleDef getContainingModule ()
   {
      if (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_MODULE)
         return null;
      return (ModuleDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingModule (ModuleDef newContainingModule, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingModule, IdlmmPackage.UNION_DEF__CONTAINING_MODULE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingModule (ModuleDef newContainingModule)
   {
      if (newContainingModule != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_MODULE && newContainingModule != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingModule))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingModule != null)
            msgs = ((InternalEObject) newContainingModule).eInverseAdd (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS,
                  ModuleDef.class, msgs);
         msgs = basicSetContainingModule (newContainingModule, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.UNION_DEF__CONTAINING_MODULE, newContainingModule,
               newContainingModule));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public StructDef getContainingStruct ()
   {
      if (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_STRUCT)
         return null;
      return (StructDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingStruct (StructDef newContainingStruct, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingStruct, IdlmmPackage.UNION_DEF__CONTAINING_STRUCT, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingStruct (StructDef newContainingStruct)
   {
      if (newContainingStruct != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_STRUCT && newContainingStruct != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingStruct))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingStruct != null)
            msgs = ((InternalEObject) newContainingStruct).eInverseAdd (this, IdlmmPackage.STRUCT_DEF__STRUCT_CONTENTS,
                  StructDef.class, msgs);
         msgs = basicSetContainingStruct (newContainingStruct, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.UNION_DEF__CONTAINING_STRUCT, newContainingStruct,
               newContainingStruct));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EnumDef> getEnums ()
   {
      return UnionDefExt.getEnums (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EnumDef> getAllEnums ()
   {
      return UnionDefExt.getAllEnums (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public HomeDef getContainingHome ()
   {
      if (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_HOME)
         return null;
      return (HomeDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingHome (HomeDef newContainingHome, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingHome, IdlmmPackage.UNION_DEF__CONTAINING_HOME, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingHome (HomeDef newContainingHome)
   {
      if (newContainingHome != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.UNION_DEF__CONTAINING_HOME && newContainingHome != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingHome))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingHome != null)
            msgs = ((InternalEObject) newContainingHome).eInverseAdd (this, IdlmmPackage.HOME_DEF__HOME_CONTENTS, HomeDef.class,
                  msgs);
         msgs = basicSetContainingHome (newContainingHome, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.UNION_DEF__CONTAINING_HOME, newContainingHome,
               newContainingHome));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<StructDef> getStructs ()
   {
      return UnionDefExt.getStructs (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<StructDef> getAllStructs ()
   {
      return UnionDefExt.getAllStructs (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UnionDef> getUnions ()
   {
      return UnionDefExt.getUnions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UnionDef> getAllUnions ()
   {
      return UnionDefExt.getAllUnions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UnionMember> getMembers ()
   {
      return UnionDefExt.getMembers (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.UNION_DEF__CONTAINING_UNION:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingUnion ((UnionDef) otherEnd, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingRepository ((Repository) otherEnd, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingException ((ExceptionDef) otherEnd, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_MODULE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingModule ((ModuleDef) otherEnd, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_STRUCT:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingStruct ((StructDef) otherEnd, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingInterface ((InterfaceDef) otherEnd, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_HOME:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingHome ((HomeDef) otherEnd, msgs);
         case IdlmmPackage.UNION_DEF__UNION_CONTENTS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getUnionContents ()).basicAdd (otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.UNION_DEF__CONTAINING_UNION:
            return basicSetContainingUnion (null, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY:
            return basicSetContainingRepository (null, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION:
            return basicSetContainingException (null, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_MODULE:
            return basicSetContainingModule (null, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_STRUCT:
            return basicSetContainingStruct (null, msgs);
         case IdlmmPackage.UNION_DEF__OWNED_TYPE:
            return basicSetOwnedType (null, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE:
            return basicSetContainingInterface (null, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_HOME:
            return basicSetContainingHome (null, msgs);
         case IdlmmPackage.UNION_DEF__UNION_CONTENTS:
            return ((InternalEList<?>) getUnionContents ()).basicRemove (otherEnd, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature (NotificationChain msgs)
   {
      switch (eContainerFeatureID)
      {
         case IdlmmPackage.UNION_DEF__CONTAINING_UNION:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.UNION_DEF__UNION_CONTENTS, UnionDef.class, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY:
            return eInternalContainer ()
                  .eInverseRemove (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS, Repository.class, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.EXCEPTION_DEF__EXCEPTION_CONTENTS, ExceptionDef.class,
                  msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_MODULE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS, ModuleDef.class, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_STRUCT:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.STRUCT_DEF__STRUCT_CONTENTS, StructDef.class, msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS, InterfaceDef.class,
                  msgs);
         case IdlmmPackage.UNION_DEF__CONTAINING_HOME:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.HOME_DEF__HOME_CONTENTS, HomeDef.class, msgs);
      }
      return super.eBasicRemoveFromContainerFeature (msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.UNION_DEF__CONTENTS:
            return getContents ();
         case IdlmmPackage.UNION_DEF__CONTAINING_UNION:
            return getContainingUnion ();
         case IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY:
            return getContainingRepository ();
         case IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION:
            return getContainingException ();
         case IdlmmPackage.UNION_DEF__CONTAINING_MODULE:
            return getContainingModule ();
         case IdlmmPackage.UNION_DEF__CONTAINING_STRUCT:
            return getContainingStruct ();
         case IdlmmPackage.UNION_DEF__OWNED_TYPE:
            return getOwnedType ();
         case IdlmmPackage.UNION_DEF__TYPE:
            if (resolve)
               return getType ();
            return basicGetType ();
         case IdlmmPackage.UNION_DEF__SHARED_TYPE:
            if (resolve)
               return getSharedType ();
            return basicGetSharedType ();
         case IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE:
            return getContainingInterface ();
         case IdlmmPackage.UNION_DEF__UNIONS:
            return getUnions ();
         case IdlmmPackage.UNION_DEF__ALL_UNIONS:
            return getAllUnions ();
         case IdlmmPackage.UNION_DEF__STRUCTS:
            return getStructs ();
         case IdlmmPackage.UNION_DEF__ALL_STRUCTS:
            return getAllStructs ();
         case IdlmmPackage.UNION_DEF__ENUMS:
            return getEnums ();
         case IdlmmPackage.UNION_DEF__ALL_ENUMS:
            return getAllEnums ();
         case IdlmmPackage.UNION_DEF__CONTAINING_HOME:
            return getContainingHome ();
         case IdlmmPackage.UNION_DEF__UNION_CONTENTS:
            return getUnionContents ();
         case IdlmmPackage.UNION_DEF__MEMBERS:
            return getMembers ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.UNION_DEF__CONTAINING_UNION:
            setContainingUnion ((UnionDef) newValue);
            return;
         case IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) newValue);
            return;
         case IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION:
            setContainingException ((ExceptionDef) newValue);
            return;
         case IdlmmPackage.UNION_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) newValue);
            return;
         case IdlmmPackage.UNION_DEF__CONTAINING_STRUCT:
            setContainingStruct ((StructDef) newValue);
            return;
         case IdlmmPackage.UNION_DEF__OWNED_TYPE:
            setOwnedType ((OwnedIDLType) newValue);
            return;
         case IdlmmPackage.UNION_DEF__TYPE:
            setType ((IDLType) newValue);
            return;
         case IdlmmPackage.UNION_DEF__SHARED_TYPE:
            setSharedType ((SharedIDLType) newValue);
            return;
         case IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE:
            setContainingInterface ((InterfaceDef) newValue);
            return;
         case IdlmmPackage.UNION_DEF__CONTAINING_HOME:
            setContainingHome ((HomeDef) newValue);
            return;
         case IdlmmPackage.UNION_DEF__UNION_CONTENTS:
            getUnionContents ().clear ();
            getUnionContents ().addAll ((Collection<? extends UnionContained>) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.UNION_DEF__CONTAINING_UNION:
            setContainingUnion ((UnionDef) null);
            return;
         case IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) null);
            return;
         case IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION:
            setContainingException ((ExceptionDef) null);
            return;
         case IdlmmPackage.UNION_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) null);
            return;
         case IdlmmPackage.UNION_DEF__CONTAINING_STRUCT:
            setContainingStruct ((StructDef) null);
            return;
         case IdlmmPackage.UNION_DEF__OWNED_TYPE:
            setOwnedType ((OwnedIDLType) null);
            return;
         case IdlmmPackage.UNION_DEF__TYPE:
            setType ((IDLType) null);
            return;
         case IdlmmPackage.UNION_DEF__SHARED_TYPE:
            setSharedType ((SharedIDLType) null);
            return;
         case IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE:
            setContainingInterface ((InterfaceDef) null);
            return;
         case IdlmmPackage.UNION_DEF__CONTAINING_HOME:
            setContainingHome ((HomeDef) null);
            return;
         case IdlmmPackage.UNION_DEF__UNION_CONTENTS:
            getUnionContents ().clear ();
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.UNION_DEF__CONTENTS:
            return isSetContents ();
         case IdlmmPackage.UNION_DEF__CONTAINING_UNION:
            return getContainingUnion () != null;
         case IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY:
            return getContainingRepository () != null;
         case IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION:
            return getContainingException () != null;
         case IdlmmPackage.UNION_DEF__CONTAINING_MODULE:
            return getContainingModule () != null;
         case IdlmmPackage.UNION_DEF__CONTAINING_STRUCT:
            return getContainingStruct () != null;
         case IdlmmPackage.UNION_DEF__OWNED_TYPE:
            return ownedType != null;
         case IdlmmPackage.UNION_DEF__TYPE:
            return basicGetType () != null;
         case IdlmmPackage.UNION_DEF__SHARED_TYPE:
            return sharedType != null;
         case IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE:
            return getContainingInterface () != null;
         case IdlmmPackage.UNION_DEF__UNIONS:
            return !getUnions ().isEmpty ();
         case IdlmmPackage.UNION_DEF__ALL_UNIONS:
            return !getAllUnions ().isEmpty ();
         case IdlmmPackage.UNION_DEF__STRUCTS:
            return !getStructs ().isEmpty ();
         case IdlmmPackage.UNION_DEF__ALL_STRUCTS:
            return !getAllStructs ().isEmpty ();
         case IdlmmPackage.UNION_DEF__ENUMS:
            return !getEnums ().isEmpty ();
         case IdlmmPackage.UNION_DEF__ALL_ENUMS:
            return !getAllEnums ().isEmpty ();
         case IdlmmPackage.UNION_DEF__CONTAINING_HOME:
            return getContainingHome () != null;
         case IdlmmPackage.UNION_DEF__UNION_CONTENTS:
            return unionContents != null && !unionContents.isEmpty ();
         case IdlmmPackage.UNION_DEF__MEMBERS:
            return !getMembers ().isEmpty ();
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == Container.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.UNION_DEF__CONTENTS:
               return IdlmmPackage.CONTAINER__CONTENTS;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.UNION_DEF__CONTAINING_UNION:
               return IdlmmPackage.UNION_CONTAINED__CONTAINING_UNION;
            default:
               return -1;
         }
      }
      if (baseClass == RepositoryContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY:
               return IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == ExceptionContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION:
               return IdlmmPackage.EXCEPTION_CONTAINED__CONTAINING_EXCEPTION;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.UNION_DEF__CONTAINING_MODULE:
               return IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == StructContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.UNION_DEF__CONTAINING_STRUCT:
               return IdlmmPackage.STRUCT_CONTAINED__CONTAINING_STRUCT;
            default:
               return -1;
         }
      }
      if (baseClass == Typed.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.UNION_DEF__OWNED_TYPE:
               return IdlmmPackage.TYPED__OWNED_TYPE;
            case IdlmmPackage.UNION_DEF__TYPE:
               return IdlmmPackage.TYPED__TYPE;
            case IdlmmPackage.UNION_DEF__SHARED_TYPE:
               return IdlmmPackage.TYPED__SHARED_TYPE;
            default:
               return -1;
         }
      }
      if (baseClass == InterfaceContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE:
               return IdlmmPackage.INTERFACE_CONTAINED__CONTAINING_INTERFACE;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.UNION_DEF__UNIONS:
               return IdlmmPackage.UNION_CONTAINER__UNIONS;
            case IdlmmPackage.UNION_DEF__ALL_UNIONS:
               return IdlmmPackage.UNION_CONTAINER__ALL_UNIONS;
            default:
               return -1;
         }
      }
      if (baseClass == StructContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.UNION_DEF__STRUCTS:
               return IdlmmPackage.STRUCT_CONTAINER__STRUCTS;
            case IdlmmPackage.UNION_DEF__ALL_STRUCTS:
               return IdlmmPackage.STRUCT_CONTAINER__ALL_STRUCTS;
            default:
               return -1;
         }
      }
      if (baseClass == EnumContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.UNION_DEF__ENUMS:
               return IdlmmPackage.ENUM_CONTAINER__ENUMS;
            case IdlmmPackage.UNION_DEF__ALL_ENUMS:
               return IdlmmPackage.ENUM_CONTAINER__ALL_ENUMS;
            default:
               return -1;
         }
      }
      if (baseClass == HomeContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.UNION_DEF__CONTAINING_HOME:
               return IdlmmPackage.HOME_CONTAINED__CONTAINING_HOME;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == Container.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINER__CONTENTS:
               return IdlmmPackage.UNION_DEF__CONTENTS;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.UNION_CONTAINED__CONTAINING_UNION:
               return IdlmmPackage.UNION_DEF__CONTAINING_UNION;
            default:
               return -1;
         }
      }
      if (baseClass == RepositoryContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY:
               return IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == ExceptionContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.EXCEPTION_CONTAINED__CONTAINING_EXCEPTION:
               return IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE:
               return IdlmmPackage.UNION_DEF__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == StructContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.STRUCT_CONTAINED__CONTAINING_STRUCT:
               return IdlmmPackage.UNION_DEF__CONTAINING_STRUCT;
            default:
               return -1;
         }
      }
      if (baseClass == Typed.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.TYPED__OWNED_TYPE:
               return IdlmmPackage.UNION_DEF__OWNED_TYPE;
            case IdlmmPackage.TYPED__TYPE:
               return IdlmmPackage.UNION_DEF__TYPE;
            case IdlmmPackage.TYPED__SHARED_TYPE:
               return IdlmmPackage.UNION_DEF__SHARED_TYPE;
            default:
               return -1;
         }
      }
      if (baseClass == InterfaceContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.INTERFACE_CONTAINED__CONTAINING_INTERFACE:
               return IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.UNION_CONTAINER__UNIONS:
               return IdlmmPackage.UNION_DEF__UNIONS;
            case IdlmmPackage.UNION_CONTAINER__ALL_UNIONS:
               return IdlmmPackage.UNION_DEF__ALL_UNIONS;
            default:
               return -1;
         }
      }
      if (baseClass == StructContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.STRUCT_CONTAINER__STRUCTS:
               return IdlmmPackage.UNION_DEF__STRUCTS;
            case IdlmmPackage.STRUCT_CONTAINER__ALL_STRUCTS:
               return IdlmmPackage.UNION_DEF__ALL_STRUCTS;
            default:
               return -1;
         }
      }
      if (baseClass == EnumContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ENUM_CONTAINER__ENUMS:
               return IdlmmPackage.UNION_DEF__ENUMS;
            case IdlmmPackage.ENUM_CONTAINER__ALL_ENUMS:
               return IdlmmPackage.UNION_DEF__ALL_ENUMS;
            default:
               return -1;
         }
      }
      if (baseClass == HomeContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.HOME_CONTAINED__CONTAINING_HOME:
               return IdlmmPackage.UNION_DEF__CONTAINING_HOME;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContents ()
   {
      return eIsSet (IdlmmPackage.UNION_DEF__UNION_CONTENTS);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean isSetContainer ()
   {
      return super.isSetContainer () || eIsSet (IdlmmPackage.UNION_DEF__CONTAINING_UNION)
            || eIsSet (IdlmmPackage.UNION_DEF__CONTAINING_REPOSITORY) || eIsSet (IdlmmPackage.UNION_DEF__CONTAINING_EXCEPTION)
            || eIsSet (IdlmmPackage.UNION_DEF__CONTAINING_MODULE) || eIsSet (IdlmmPackage.UNION_DEF__CONTAINING_STRUCT)
            || eIsSet (IdlmmPackage.UNION_DEF__CONTAINING_INTERFACE) || eIsSet (IdlmmPackage.UNION_DEF__CONTAINING_HOME);
   }

} //UnionDefImpl
