package com.prismtech.idt.idlmm.impl;

import java.math.BigDecimal;
import java.math.BigInteger;

import com.prismtech.idt.idlmm.AddOperator;


public class AddOperatorExt
{
   public static Object getExpressionValue (AddOperator self)
   {
      Object left = BinaryOperatorExt.getLeftOperand (self);
      Object right = BinaryOperatorExt.getRightOperand (self);

      if (left instanceof BigInteger && right instanceof BigInteger)
      {
         return ((BigInteger) left).add ((BigInteger) right);
      }
      else if (left instanceof BigDecimal && right instanceof BigDecimal)
      {
         return ((BigDecimal) left).add ((BigDecimal) right);
      }
      else
      {
         return null;
      }
   }
}
