package com.prismtech.idt.idlmm.impl;

import java.util.Set;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.ArrayDef;
import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.PrimitiveDef;
import com.prismtech.idt.idlmm.PrimitiveKind;


/**
 * @since 30.08.2007 - 20:04:24
 * @author Aleksey Yashchenko
 * @version $Revision: 1.8 $
 */
public class ArrayDefExt
{
   private static final PrimitiveDef EXP_TYPE = PrimitiveDefExt.create (PrimitiveKind.PK_ULONGLONG);

   public static IDLType getExpressionType (ArrayDef self)
   {
      return EXP_TYPE;
   }

   public static EList<IRObject> getPrerequisites (ArrayDef self)
   {
      Set<IRObject> result = new ArraySet<IRObject> (TypedExt.getPrerequisites (self));
      result.add (self.getLength ());
      result.addAll (self.getLength ().getPrerequisites ());
      return new BasicEList<IRObject> (result);
   }
}
