package com.prismtech.idt.idlmm.impl;

import java.util.Set;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.AttributeDef;
import com.prismtech.idt.idlmm.IRObject;


public class AttributeDefExt
{
   public static EList<IRObject> getPrerequisites (AttributeDef self)
   {
      Set<IRObject> result = new ArraySet<IRObject> (TypedExt.getPrerequisites (self));
      result.addAll (self.getGetExceptions ());
      result.addAll (self.getSetExceptions ());

      return new BasicEList<IRObject> (result);
   }
}
