package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.util.ECollections;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.Repository;


public abstract class IRObjectExt
{
   /**
    * Implementation of {@link Contained#getRepository()}
    */
   public static Repository getRepository (IRObject self)
   {
      EObject eobject = self;

      while ( (eobject != null) && ( (eobject instanceof Repository) == false))
      {
         eobject = eobject.eContainer ();
      }

      return (Repository) eobject;
   }

   public static EList<IRObject> getPrerequisites (IRObject self)
   {
      return ECollections.emptyEList ();
   }
}
