package com.prismtech.idt.idlmm.impl;

import java.util.Set;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.OperationDef;
import com.prismtech.idt.idlmm.ParameterDef;


public class OperationDefExt
{
   public static EList<IRObject> getPrerequisites (OperationDef self)
   {
      Set<IRObject> result = new ArraySet<IRObject> (TypedExt.getPrerequisites (self));
      for (ParameterDef parameter : self.getParameters ())
      {
         result.addAll (parameter.getPrerequisites ());
      }
      result.addAll (self.getExceptions ());
      return new BasicEList<IRObject> (result);
   }
}
