package com.prismtech.idt.idlmm.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.PrimitiveDef;
import com.prismtech.idt.idlmm.PrimitiveKind;
import com.prismtech.idt.idlmm.StringDef;


/**
 * @since 30.08.2007 - 20:04:00
 * @author Aleksey Yashchenko
 * @version $Revision: 1.8 $
 */
public class StringDefExt
{
   private static final PrimitiveDef EXP_TYPE = PrimitiveDefExt.create (PrimitiveKind.PK_ULONGLONG);

   public static IDLType getExpressionType (StringDef self)
   {
      return EXP_TYPE;
   }

   public static EList<IRObject> getPrerequisites (StringDef self)
   {
      List<IRObject> result = new ArrayList<IRObject>();
      result.add (self.getBound ());
      result.addAll (self.getBound ().getPrerequisites ());
      return new BasicEList<IRObject> (result);
   }

}
