package com.prismtech.idt.imports.idl.importer;

import org.eclipse.core.runtime.IStatus;

import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.Pragma;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;


public interface IIdlPragmaHandler
{
   interface CreateContext
   {
      public Container getParent ();

      public String getPragmaText ();

      public Pragma getPragma ();

      public void setPragma (Pragma pragma);

      public Object getData (Object key);

      public void setData (Object key, Object data);

      public IdlParserAST getAst ();

      public void setAst (IdlParserAST ast);
   }

   public boolean matches (String pragmaText);

   public IStatus create (CreateContext ctx);

   public IStatus bind (CreateContext ctx);
}
