/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */
package com.prismtech.idt.imports.idl.internal.importer.builderutil;

import com.prismtech.idt.idlmm.InterfaceDecl;
import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.InterfaceModifier;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;


public class InterfaceDeclPropertiesHolder extends ContainerTypeHolder
{
   public InterfaceDeclPropertiesHolder (String name, InterfaceModifier im, String sourceValue, IdlParserAST... ast)
   {
      super (name, ContainerType.INTERFACE_FORWARD, sourceValue, ast);

      this.setInterfaceModifier (im);
   }

   public InterfaceDeclPropertiesHolder (InterfaceDef id, String sourceValue, IdlParserAST... ast)
   {
      super (id, sourceValue, ast);
   }

   private void setInterfaceModifier (InterfaceModifier im)
   {
      ((InterfaceDecl) this.getDefinition ()).setModifier (im);
   }
}
