/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.NativeDef;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;


/**
 * @author Yuriy Kravchenko
 */

public class NativeDeclPropertiesHolder extends TypeDeclarationPropertiesHolder
{
   private final String m_name;

   public NativeDeclPropertiesHolder (String name, String sourceVal, IdlParserAST... ast)
   {
      super (sourceVal, ast);

      m_name = name;
   }

   @Override
   protected IRObject createDefinitionImpl ()
   {
      NativeDef definition = FACTORY.createNativeDef ();
      definition.setName (this.m_name);
      return definition;
   }

}
