// $ANTLR 2.7.7 (2006-11-01): "IdlParser.g" -> "IdlLexer.java"$

  package com.prismtech.idt.imports.idl.internal.parser;
  
  import java.io.*;
  import java.net.URI;
  import java.util.List;
  import java.util.ArrayList;
  import java.util.Vector;
  import java.util.Hashtable;

import com.prismtech.idt.imports.idl.parser.*;
 
import java.io.InputStream;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.TokenStreamRecognitionException;
import antlr.CharStreamException;
import antlr.CharStreamIOException;
import antlr.ANTLRException;
import java.io.Reader;
import java.util.Hashtable;
import antlr.CharScanner;
import antlr.InputBuffer;
import antlr.ByteBuffer;
import antlr.CharBuffer;
import antlr.Token;
import antlr.CommonToken;
import antlr.RecognitionException;
import antlr.NoViableAltForCharException;
import antlr.MismatchedCharException;
import antlr.TokenStream;
import antlr.ANTLRHashString;
import antlr.LexerSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.SemanticException;

public class IdlLexer extends antlr.CharScanner implements IdlTokenTypes, TokenStream
 {

   private List<IIdlPragma> pragmas = new ArrayList<IIdlPragma> ();
   
   /**
    * Stores the filename from the first line marker we encounter i.e. the name of the primary file.
    */
   private String m_primaryFilename = null;

   public List<IIdlPragma> getPragmas()
   {
      return pragmas;
   }
   
   public String getPrimaryFilename ()
   {
      return m_primaryFilename;
   }

   public void setTokenObjectClass (Class clazz)
   {
      tokenObjectClass = clazz;
   }

   @Override
   protected Token makeToken (int t)
   {
      Token token = super.makeToken (t);
      token.setFilename (getFilename ());
      return token;
   }
public IdlLexer(InputStream in) {
 this(new ByteBuffer(in));
}
public IdlLexer(Reader in) {
 this(new CharBuffer(in));
}
public IdlLexer(InputBuffer ib) {
 this(new LexerSharedInputState(ib));
}
public IdlLexer(LexerSharedInputState state) {
 super(state);
 caseSensitiveLiterals = true;
 setCaseSensitive(true);
 literals = new Hashtable();
 literals.put(new ANTLRHashString("switch", this), new Integer(58));
 literals.put(new ANTLRHashString("typeprefix", this), new Integer(80));
 literals.put(new ANTLRHashString("case", this), new Integer(59));
 literals.put(new ANTLRHashString("finder", this), new Integer(95));
 literals.put(new ANTLRHashString("manages", this), new Integer(93));
 literals.put(new ANTLRHashString("interface", this), new Integer(8));
 literals.put(new ANTLRHashString("provides", this), new Integer(86));
 literals.put(new ANTLRHashString("exception", this), new Integer(69));
 literals.put(new ANTLRHashString("primarykey", this), new Integer(94));
 literals.put(new ANTLRHashString("sequence", this), new Integer(62));
 literals.put(new ANTLRHashString("uses", this), new Integer(87));
 literals.put(new ANTLRHashString("consumes", this), new Integer(91));
 literals.put(new ANTLRHashString("void", this), new Integer(71));
 literals.put(new ANTLRHashString("factory", this), new Integer(24));
 literals.put(new ANTLRHashString("import", this), new Integer(78));
 literals.put(new ANTLRHashString("float", this), new Integer(45));
 literals.put(new ANTLRHashString("publishes", this), new Integer(90));
 literals.put(new ANTLRHashString("private", this), new Integer(23));
 literals.put(new ANTLRHashString("boolean", this), new Integer(52));
 literals.put(new ANTLRHashString("string", this), new Integer(65));
 literals.put(new ANTLRHashString("getraises", this), new Integer(83));
 literals.put(new ANTLRHashString("emits", this), new Integer(89));
 literals.put(new ANTLRHashString("custom", this), new Integer(9));
 literals.put(new ANTLRHashString("component", this), new Integer(85));
 literals.put(new ANTLRHashString("context", this), new Integer(75));
 literals.put(new ANTLRHashString("octet", this), new Integer(53));
 literals.put(new ANTLRHashString("oneway", this), new Integer(70));
 literals.put(new ANTLRHashString("long", this), new Integer(47));
 literals.put(new ANTLRHashString("ValueBase", this), new Integer(77));
 literals.put(new ANTLRHashString("in", this), new Integer(27));
 literals.put(new ANTLRHashString("truncatable", this), new Integer(20));
 literals.put(new ANTLRHashString("FALSE", this), new Integer(42));
 literals.put(new ANTLRHashString("readonly", this), new Integer(81));
 literals.put(new ANTLRHashString("typedef", this), new Integer(43));
 literals.put(new ANTLRHashString("supports", this), new Integer(21));
 literals.put(new ANTLRHashString("short", this), new Integer(48));
 literals.put(new ANTLRHashString("TRUE", this), new Integer(41));
 literals.put(new ANTLRHashString("fixed", this), new Integer(76));
 literals.put(new ANTLRHashString("Object", this), new Integer(55));
 literals.put(new ANTLRHashString("enum", this), new Integer(61));
 literals.put(new ANTLRHashString("home", this), new Integer(92));
 literals.put(new ANTLRHashString("multiple", this), new Integer(88));
 literals.put(new ANTLRHashString("attribute", this), new Integer(82));
 literals.put(new ANTLRHashString("char", this), new Integer(50));
 literals.put(new ANTLRHashString("union", this), new Integer(57));
 literals.put(new ANTLRHashString("local", this), new Integer(7));
 literals.put(new ANTLRHashString("const", this), new Integer(28));
 literals.put(new ANTLRHashString("setraises", this), new Integer(84));
 literals.put(new ANTLRHashString("abstract", this), new Integer(6));
 literals.put(new ANTLRHashString("valuetype", this), new Integer(10));
 literals.put(new ANTLRHashString("inout", this), new Integer(73));
 literals.put(new ANTLRHashString("raises", this), new Integer(74));
 literals.put(new ANTLRHashString("out", this), new Integer(72));
 literals.put(new ANTLRHashString("typeid", this), new Integer(79));
 literals.put(new ANTLRHashString("wchar", this), new Integer(51));
 literals.put(new ANTLRHashString("any", this), new Integer(54));
 literals.put(new ANTLRHashString("double", this), new Integer(46));
 literals.put(new ANTLRHashString("default", this), new Integer(60));
 literals.put(new ANTLRHashString("eventtype", this), new Integer(11));
 literals.put(new ANTLRHashString("wstring", this), new Integer(66));
 literals.put(new ANTLRHashString("unsigned", this), new Integer(49));
 literals.put(new ANTLRHashString("struct", this), new Integer(56));
 literals.put(new ANTLRHashString("public", this), new Integer(22));
 literals.put(new ANTLRHashString("module", this), new Integer(12));
 literals.put(new ANTLRHashString("native", this), new Integer(44));
}

public Token nextToken() throws TokenStreamException {
 Token theRetToken=null;
tryAgain:
 for (;;) {
  Token _token = null;
  int _ttype = Token.INVALID_TYPE;
  resetText();
  try {   // for char stream error handling
   try {   // for lexical error handling
    switch ( LA(1)) {
    case '\t':  case ' ':
    {
     mWS(true);
     theRetToken=_returnToken;
     break;
    }
    case '1':  case '2':  case '3':  case '4':
    case '5':  case '6':  case '7':  case '8':
    case '9':
    {
     mINT(true);
     theRetToken=_returnToken;
     break;
    }
    case '"':
    {
     mSTRING_LITERAL(true);
     theRetToken=_returnToken;
     break;
    }
    case '\n':  case '\r':
    {
     mNL(true);
     theRetToken=_returnToken;
     break;
    }
    case ';':
    {
     mSEMI(true);
     theRetToken=_returnToken;
     break;
    }
    case '?':
    {
     mQUESTION(true);
     theRetToken=_returnToken;
     break;
    }
    case '(':
    {
     mLPAREN(true);
     theRetToken=_returnToken;
     break;
    }
    case ')':
    {
     mRPAREN(true);
     theRetToken=_returnToken;
     break;
    }
    case '[':
    {
     mLBRACK(true);
     theRetToken=_returnToken;
     break;
    }
    case ']':
    {
     mRBRACK(true);
     theRetToken=_returnToken;
     break;
    }
    case '{':
    {
     mLCURLY(true);
     theRetToken=_returnToken;
     break;
    }
    case '}':
    {
     mRCURLY(true);
     theRetToken=_returnToken;
     break;
    }
    case '|':
    {
     mOR(true);
     theRetToken=_returnToken;
     break;
    }
    case '^':
    {
     mXOR(true);
     theRetToken=_returnToken;
     break;
    }
    case '&':
    {
     mAND(true);
     theRetToken=_returnToken;
     break;
    }
    case ',':
    {
     mCOMMA(true);
     theRetToken=_returnToken;
     break;
    }
    case '=':
    {
     mASSIGN(true);
     theRetToken=_returnToken;
     break;
    }
    case '!':
    {
     mNOT(true);
     theRetToken=_returnToken;
     break;
    }
    case '+':
    {
     mPLUS(true);
     theRetToken=_returnToken;
     break;
    }
    case '-':
    {
     mMINUS(true);
     theRetToken=_returnToken;
     break;
    }
    case '~':
    {
     mTILDE(true);
     theRetToken=_returnToken;
     break;
    }
    case '*':
    {
     mSTAR(true);
     theRetToken=_returnToken;
     break;
    }
    case '%':
    {
     mMOD(true);
     theRetToken=_returnToken;
     break;
    }
    case '\'':
    {
     mCHAR_LITERAL(true);
     theRetToken=_returnToken;
     break;
    }
    case '_':
    {
     mESCAPED_IDENT(true);
     theRetToken=_returnToken;
     break;
    }
    default:
     if ((LA(1)=='#') && (LA(2)=='\t'||LA(2)==' ')) {
      mLINEMARKER(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='#') && (LA(2)=='p')) {
      mPRAGMA(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='<') && (LA(2)=='<')) {
      mLSHIFT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='>') && (LA(2)=='>')) {
      mRSHIFT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)==':') && (LA(2)==':')) {
      mSCOPEOP(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='/') && (LA(2)=='*'||LA(2)=='/')) {
      mCOMMENT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='L') && (LA(2)=='\'')) {
      mWIDE_CHAR_LITERAL(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='L') && (LA(2)=='"')) {
      mWIDE_STRING_LITERAL(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='0') && (LA(2)=='X'||LA(2)=='x')) {
      mHEX(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='.') && ((LA(2) >= '0' && LA(2) <= '9'))) {
      mFLOAT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='#') && (true)) {
      mSHARP(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)==':') && (true)) {
      mCOLON(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='.') && (true)) {
      mDOT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='<') && (true)) {
      mLT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='>') && (true)) {
      mGT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='/') && (true)) {
      mDIV(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='0') && (true)) {
      mOCTAL(true);
      theRetToken=_returnToken;
     }
     else if ((_tokenSet_0.member(LA(1))) && (true)) {
      mIDENT(true);
      theRetToken=_returnToken;
     }
    else {
     if (LA(1)==EOF_CHAR) {uponEOF(); _returnToken = makeToken(Token.EOF_TYPE);}
    else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
    }
    }
    if ( _returnToken==null ) continue tryAgain; // found SKIP token
    _ttype = _returnToken.getType();
    _ttype = testLiteralsTable(_ttype);
    _returnToken.setType(_ttype);
    return _returnToken;
   }
   catch (RecognitionException e) {
    throw new TokenStreamRecognitionException(e);
   }
  }
  catch (CharStreamException cse) {
   if ( cse instanceof CharStreamIOException ) {
    throw new TokenStreamIOException(((CharStreamIOException)cse).io);
   }
   else {
    throw new TokenStreamException(cse.getMessage());
   }
  }
 }
}

 public final void mLINEMARKER(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = LINEMARKER;
  int _saveIndex;
  Token line=null;
  Token file=null;
  Token flag=null;
  
  mSHARP(false);
  mWS(false);
  mINT(true);
  line=_returnToken;
  mWS(false);
  mSTRING_LITERAL(true);
  file=_returnToken;
  {
  switch ( LA(1)) {
  case '\t':  case ' ':
  {
   mWS(false);
   break;
  }
  case '\n':  case '\r':  case '1':  case '2':
  case '3':  case '4':  case '5':  case '6':
  case '7':  case '8':  case '9':
  {
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  {
  switch ( LA(1)) {
  case '1':  case '2':  case '3':  case '4':
  case '5':  case '6':  case '7':  case '8':
  case '9':
  {
   mINT(true);
   flag=_returnToken;
   break;
  }
  case '\n':  case '\r':
  {
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  mNL(false);
  
  if (flag == null)
  {
  if (m_primaryFilename == null)
  {
  m_primaryFilename = file.getText ();
  }
  }
  
  _ttype = Token.SKIP;
  setFilename (file.getText ());
  setLine (Integer.parseInt (line.getText ()));
  
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mSHARP(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = SHARP;
  int _saveIndex;
  
  match('#');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mWS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = WS;
  int _saveIndex;
  
  {
  switch ( LA(1)) {
  case ' ':
  {
   match(' ');
   break;
  }
  case '\t':
  {
   match('\t');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  
  _ttype = Token.SKIP;
  
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mINT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = INT;
  int _saveIndex;
  
  mNONZERODIGIT(false);
  {
  _loop367:
  do {
   if (((LA(1) >= '0' && LA(1) <= '9'))) {
    mDIGIT(false);
   }
   else {
    break _loop367;
   }
   
  } while (true);
  }
  {
  switch ( LA(1)) {
  case '.':
  {
   match('.');
   {
   _loop370:
   do {
    if (((LA(1) >= '0' && LA(1) <= '9'))) {
     mDIGIT(false);
    }
    else {
     break _loop370;
    }
    
   } while (true);
   }
   {
   switch ( LA(1)) {
   case 'E':  case 'e':
   {
    {
    {
    switch ( LA(1)) {
    case 'e':
    {
     match('e');
     break;
    }
    case 'E':
    {
     match('E');
     break;
    }
    default:
    {
     throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
    }
    }
    }
    {
    switch ( LA(1)) {
    case '+':
    {
     match('+');
     break;
    }
    case '-':
    {
     match('-');
     break;
    }
    case '0':  case '1':  case '2':  case '3':
    case '4':  case '5':  case '6':  case '7':
    case '8':  case '9':
    {
     break;
    }
    default:
    {
     throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
    }
    }
    }
    {
    int _cnt376=0;
    _loop376:
    do {
     if (((LA(1) >= '0' && LA(1) <= '9'))) {
      mDIGIT(false);
     }
     else {
      if ( _cnt376>=1 ) { break _loop376; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
     }
     
     _cnt376++;
    } while (true);
    }
    }
    _ttype = FLOAT;
    break;
   }
   case 'D':  case 'd':
   {
    {
    switch ( LA(1)) {
    case 'd':
    {
     match('d');
     break;
    }
    case 'D':
    {
     match('D');
     break;
    }
    default:
    {
     throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
    }
    }
    }
    _ttype = FIXED;
    break;
   }
   default:
    {
     _ttype = FLOAT;
    }
   }
   }
   break;
  }
  case 'E':  case 'e':
  {
   {
   switch ( LA(1)) {
   case 'e':
   {
    match('e');
    break;
   }
   case 'E':
   {
    match('E');
    break;
   }
   default:
   {
    throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   }
   }
   {
   switch ( LA(1)) {
   case '+':
   {
    match('+');
    break;
   }
   case '-':
   {
    match('-');
    break;
   }
   case '0':  case '1':  case '2':  case '3':
   case '4':  case '5':  case '6':  case '7':
   case '8':  case '9':
   {
    break;
   }
   default:
   {
    throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   }
   }
   {
   int _cnt381=0;
   _loop381:
   do {
    if (((LA(1) >= '0' && LA(1) <= '9'))) {
     mDIGIT(false);
    }
    else {
     if ( _cnt381>=1 ) { break _loop381; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
    }
    
    _cnt381++;
   } while (true);
   }
   _ttype = FLOAT;
   break;
  }
  case 'D':  case 'd':
  {
   {
   switch ( LA(1)) {
   case 'd':
   {
    match('d');
    break;
   }
   case 'D':
   {
    match('D');
    break;
   }
   default:
   {
    throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   }
   }
   _ttype = FIXED;
   break;
  }
  default:
   {
   }
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mSTRING_LITERAL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = STRING_LITERAL;
  int _saveIndex;
  
  _saveIndex=text.length();
  match('"');
  text.setLength(_saveIndex);
  {
  _loop345:
  do {
   if ((LA(1)=='\\')) {
    mESC(false);
   }
   else if ((_tokenSet_1.member(LA(1)))) {
    matchNot('"');
   }
   else {
    break _loop345;
   }
   
  } while (true);
  }
  _saveIndex=text.length();
  match('"');
  text.setLength(_saveIndex);
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mNL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = NL;
  int _saveIndex;
  
  {
  switch ( LA(1)) {
  case '\n':
  {
   match('\n');
   break;
  }
  case '\r':
  {
   match('\r');
   {
   if ((LA(1)=='\n') && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
    match('\n');
   }
   else {
   }
   
   }
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  
  newline(); 
  _ttype = Token.SKIP; 
  
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mPRAGMA(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = PRAGMA;
  int _saveIndex;
  
  _saveIndex=text.length();
  mSHARP(false);
  text.setLength(_saveIndex);
  _saveIndex=text.length();
  match("pragma");
  text.setLength(_saveIndex);
  {
  int _cnt297=0;
  _loop297:
  do {
   if ((LA(1)=='\t'||LA(1)==' ') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
    _saveIndex=text.length();
    mWS(false);
    text.setLength(_saveIndex);
   }
   else {
    if ( _cnt297>=1 ) { break _loop297; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
   }
   
   _cnt297++;
  } while (true);
  }
  {
  _loop300:
  do {
   if ((_tokenSet_2.member(LA(1)))) {
    {
    match(_tokenSet_2);
    }
   }
   else {
    break _loop300;
   }
   
  } while (true);
  }
  _saveIndex=text.length();
  mNL(false);
  text.setLength(_saveIndex);
  
  pragmas.add(new IdlPragma(getFilename(), getLine(), getColumn(), new String(text.getBuffer(),_begin,text.length()-_begin)));
  
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mSEMI(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = SEMI;
  int _saveIndex;
  
  match(';');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mQUESTION(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = QUESTION;
  int _saveIndex;
  
  match('?');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mLPAREN(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = LPAREN;
  int _saveIndex;
  
  match('(');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mRPAREN(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = RPAREN;
  int _saveIndex;
  
  match(')');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mLBRACK(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = LBRACK;
  int _saveIndex;
  
  match('[');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mRBRACK(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = RBRACK;
  int _saveIndex;
  
  match(']');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mLCURLY(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = LCURLY;
  int _saveIndex;
  
  match('{');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mRCURLY(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = RCURLY;
  int _saveIndex;
  
  match('}');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mOR(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = OR;
  int _saveIndex;
  
  match('|');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mXOR(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = XOR;
  int _saveIndex;
  
  match('^');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mAND(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = AND;
  int _saveIndex;
  
  match('&');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mCOLON(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = COLON;
  int _saveIndex;
  
  match(':');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mCOMMA(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = COMMA;
  int _saveIndex;
  
  match(',');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mDOT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = DOT;
  int _saveIndex;
  
  match('.');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mASSIGN(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = ASSIGN;
  int _saveIndex;
  
  match('=');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mNOT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = NOT;
  int _saveIndex;
  
  match('!');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mLT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = LT;
  int _saveIndex;
  
  match('<');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mLSHIFT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = LSHIFT;
  int _saveIndex;
  
  match("<<");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mGT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = GT;
  int _saveIndex;
  
  match('>');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mRSHIFT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = RSHIFT;
  int _saveIndex;
  
  match(">>");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mDIV(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = DIV;
  int _saveIndex;
  
  match('/');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mPLUS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = PLUS;
  int _saveIndex;
  
  match('+');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mMINUS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = MINUS;
  int _saveIndex;
  
  match('-');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mTILDE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = TILDE;
  int _saveIndex;
  
  match('~');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mSTAR(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = STAR;
  int _saveIndex;
  
  match('*');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mMOD(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = MOD;
  int _saveIndex;
  
  match('%');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mSCOPEOP(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = SCOPEOP;
  int _saveIndex;
  
  match("::");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mCOMMENT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = COMMENT;
  int _saveIndex;
  
  _ttype = Token.SKIP; 
  
  
  if ((LA(1)=='/') && (LA(2)=='/')) {
   match("//");
   {
   _loop337:
   do {
    if ((_tokenSet_2.member(LA(1)))) {
     {
     match(_tokenSet_2);
     }
    }
    else {
     break _loop337;
    }
    
   } while (true);
   }
   _saveIndex=text.length();
   mNL(false);
   text.setLength(_saveIndex);
  }
  else if ((LA(1)=='/') && (LA(2)=='*')) {
   match("/*");
   {
   _loop339:
   do {
    // nongreedy exit test
    if ((LA(1)=='*') && (LA(2)=='/') && (true)) break _loop339;
    if ((LA(1)=='\n'||LA(1)=='\r') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && ((LA(3) >= '\u0000' && LA(3) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true)) {
     mNL(false);
    }
    else if (((LA(1) >= '\u0000' && LA(1) <= '\ufffe')) && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && ((LA(3) >= '\u0000' && LA(3) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true)) {
     matchNot(EOF_CHAR);
    }
    else {
     break _loop339;
    }
    
   } while (true);
   }
   match("*/");
  }
  else {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mCHAR_LITERAL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = CHAR_LITERAL;
  int _saveIndex;
  
  _saveIndex=text.length();
  match('\'');
  text.setLength(_saveIndex);
  {
  if ((LA(1)=='\\')) {
   mESC(false);
  }
  else if ((_tokenSet_3.member(LA(1)))) {
   matchNot('\'');
  }
  else {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  
  }
  _saveIndex=text.length();
  match('\'');
  text.setLength(_saveIndex);
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mESC(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = ESC;
  int _saveIndex;
  
  _saveIndex=text.length();
  match('\\');
  text.setLength(_saveIndex);
  {
  if ((LA(1)=='x') && (_tokenSet_4.member(LA(2))) && ((LA(3) >= '\u0000' && LA(3) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true)) {
   _saveIndex=text.length();
   match('x');
   text.setLength(_saveIndex);
   mHEXDIGIT(false);
   {
   if ((_tokenSet_4.member(LA(1))) && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
    mHEXDIGIT(false);
   }
   else if (((LA(1) >= '\u0000' && LA(1) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
   }
   else {
    throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   
   }
   char realc = (char) Integer.valueOf(new String(text.getBuffer(),_begin,text.length()-_begin), 16).intValue(); text.setLength(_begin); text.append(realc);
  }
  else if ((LA(1)=='u') && (_tokenSet_4.member(LA(2))) && ((LA(3) >= '\u0000' && LA(3) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true)) {
   _saveIndex=text.length();
   match('u');
   text.setLength(_saveIndex);
   mHEXDIGIT(false);
   {
   if ((_tokenSet_4.member(LA(1))) && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
    mHEXDIGIT(false);
    {
    if ((_tokenSet_4.member(LA(1))) && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
     mHEXDIGIT(false);
     {
     if ((_tokenSet_4.member(LA(1))) && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
      mHEXDIGIT(false);
     }
     else if (((LA(1) >= '\u0000' && LA(1) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
     }
     else {
      throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
     }
     
     }
    }
    else if (((LA(1) >= '\u0000' && LA(1) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
    }
    else {
     throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
    }
    
    }
   }
   else if (((LA(1) >= '\u0000' && LA(1) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
   }
   else {
    throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   
   }
   char realc = (char) Integer.valueOf(new String(text.getBuffer(),_begin,text.length()-_begin), 16).intValue(); text.setLength(_begin); text.append(realc);
  }
  else if ((LA(1)=='n') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
   match('n');
   text.setLength(_begin); text.append("\n");
  }
  else if ((LA(1)=='t') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
   match('t');
   text.setLength(_begin); text.append("\t");
  }
  else if ((LA(1)=='v') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
   match('v');
   text.setLength(_begin); text.append("\013");
  }
  else if ((LA(1)=='b') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
   match('b');
   text.setLength(_begin); text.append("\b");
  }
  else if ((LA(1)=='r') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
   match('r');
   text.setLength(_begin); text.append("\r");
  }
  else if ((LA(1)=='f') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
   match('f');
   text.setLength(_begin); text.append("\r");
  }
  else if ((LA(1)=='a') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
   match('a');
   text.setLength(_begin); text.append("\007");
  }
  else if ((LA(1)=='\\') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
   match('\\');
   text.setLength(_begin); text.append("\\");
  }
  else if ((LA(1)=='?') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
   match('?');
   text.setLength(_begin); text.append("?");
  }
  else if ((LA(1)=='\'') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
   match('\'');
   text.setLength(_begin); text.append("'");
  }
  else if ((LA(1)=='"') && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
   match('"');
   text.setLength(_begin); text.append("\"");
  }
  else if (((LA(1) >= '0' && LA(1) <= '7')) && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
   mOCTDIGIT(false);
   {
   if (((LA(1) >= '0' && LA(1) <= '7')) && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
    mOCTDIGIT(false);
    {
    if (((LA(1) >= '0' && LA(1) <= '7')) && ((LA(2) >= '\u0000' && LA(2) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true)) {
     mOCTDIGIT(false);
    }
    else if (((LA(1) >= '\u0000' && LA(1) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
    }
    else {
     throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
    }
    
    }
   }
   else if (((LA(1) >= '\u0000' && LA(1) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
   }
   else {
    throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   
   }
   char realc = (char) Integer.valueOf(new String(text.getBuffer(),_begin,text.length()-_begin), 8).intValue(); text.setLength(_begin); text.append(realc);
  }
  else if (((LA(1) >= '\u0000' && LA(1) <= '\ufffe')) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
  }
  else {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mWIDE_CHAR_LITERAL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = WIDE_CHAR_LITERAL;
  int _saveIndex;
  
  _saveIndex=text.length();
  match('L');
  text.setLength(_saveIndex);
  mCHAR_LITERAL(false);
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mWIDE_STRING_LITERAL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = WIDE_STRING_LITERAL;
  int _saveIndex;
  
  _saveIndex=text.length();
  match('L');
  text.setLength(_saveIndex);
  mSTRING_LITERAL(false);
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mOCTDIGIT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = OCTDIGIT;
  int _saveIndex;
  
  matchRange('0','7');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mHEXDIGIT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = HEXDIGIT;
  int _saveIndex;
  
  {
  switch ( LA(1)) {
  case '0':  case '1':  case '2':  case '3':
  case '4':  case '5':  case '6':  case '7':
  case '8':  case '9':
  {
   matchRange('0','9');
   break;
  }
  case 'a':  case 'b':  case 'c':  case 'd':
  case 'e':  case 'f':
  {
   matchRange('a','f');
   break;
  }
  case 'A':  case 'B':  case 'C':  case 'D':
  case 'E':  case 'F':
  {
   matchRange('A','F');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mVOCAB(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = VOCAB;
  int _saveIndex;
  
  matchRange('\3','\377');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mDIGIT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = DIGIT;
  int _saveIndex;
  
  matchRange('0','9');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mNONZERODIGIT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = NONZERODIGIT;
  int _saveIndex;
  
  matchRange('1','9');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mHEX(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = HEX;
  int _saveIndex;
  
  {
  if ((LA(1)=='0') && (LA(2)=='x')) {
   match("0x");
  }
  else if ((LA(1)=='0') && (LA(2)=='X')) {
   match("0X");
  }
  else {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  
  }
  {
  int _cnt364=0;
  _loop364:
  do {
   if ((_tokenSet_4.member(LA(1)))) {
    mHEXDIGIT(false);
   }
   else {
    if ( _cnt364>=1 ) { break _loop364; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
   }
   
   _cnt364++;
  } while (true);
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mOCTAL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = OCTAL;
  int _saveIndex;
  
  match('0');
  {
  switch ( LA(1)) {
  case '0':  case '1':  case '2':  case '3':
  case '4':  case '5':  case '6':  case '7':
  case '8':  case '9':
  {
   {
   int _cnt386=0;
   _loop386:
   do {
    if (((LA(1) >= '0' && LA(1) <= '9'))) {
     mDIGIT(false);
    }
    else {
     if ( _cnt386>=1 ) { break _loop386; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
    }
    
    _cnt386++;
   } while (true);
   }
   break;
  }
  case '.':
  {
   mFLOAT(false);
   _ttype = FLOAT;
   break;
  }
  case 'D':  case 'd':
  {
   {
   switch ( LA(1)) {
   case 'd':
   {
    match('d');
    break;
   }
   case 'D':
   {
    match('D');
    break;
   }
   default:
   {
    throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   }
   }
   _ttype = FIXED;
   break;
  }
  default:
   {
    _ttype = INT;
   }
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mFLOAT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = FLOAT;
  int _saveIndex;
  
  match('.');
  {
  int _cnt390=0;
  _loop390:
  do {
   if (((LA(1) >= '0' && LA(1) <= '9'))) {
    mDIGIT(false);
   }
   else {
    if ( _cnt390>=1 ) { break _loop390; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
   }
   
   _cnt390++;
  } while (true);
  }
  {
  switch ( LA(1)) {
  case 'E':  case 'e':
  {
   {
   switch ( LA(1)) {
   case 'e':
   {
    match('e');
    break;
   }
   case 'E':
   {
    match('E');
    break;
   }
   default:
   {
    throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   }
   }
   {
   switch ( LA(1)) {
   case '+':
   {
    match('+');
    break;
   }
   case '-':
   {
    match('-');
    break;
   }
   case '0':  case '1':  case '2':  case '3':
   case '4':  case '5':  case '6':  case '7':
   case '8':  case '9':
   {
    break;
   }
   default:
   {
    throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   }
   }
   {
   int _cnt395=0;
   _loop395:
   do {
    if (((LA(1) >= '0' && LA(1) <= '9'))) {
     mDIGIT(false);
    }
    else {
     if ( _cnt395>=1 ) { break _loop395; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
    }
    
    _cnt395++;
   } while (true);
   }
   break;
  }
  case 'D':  case 'd':
  {
   {
   switch ( LA(1)) {
   case 'd':
   {
    match('d');
    break;
   }
   case 'D':
   {
    match('D');
    break;
   }
   default:
   {
    throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   }
   }
   _ttype = FIXED;
   break;
  }
  default:
   {
   }
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mIDENT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = IDENT;
  int _saveIndex;
  
  {
  switch ( LA(1)) {
  case 'a':  case 'b':  case 'c':  case 'd':
  case 'e':  case 'f':  case 'g':  case 'h':
  case 'i':  case 'j':  case 'k':  case 'l':
  case 'm':  case 'n':  case 'o':  case 'p':
  case 'q':  case 'r':  case 's':  case 't':
  case 'u':  case 'v':  case 'w':  case 'x':
  case 'y':  case 'z':
  {
   matchRange('a','z');
   break;
  }
  case 'A':  case 'B':  case 'C':  case 'D':
  case 'E':  case 'F':  case 'G':  case 'H':
  case 'I':  case 'J':  case 'K':  case 'L':
  case 'M':  case 'N':  case 'O':  case 'P':
  case 'Q':  case 'R':  case 'S':  case 'T':
  case 'U':  case 'V':  case 'W':  case 'X':
  case 'Y':  case 'Z':
  {
   matchRange('A','Z');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  {
  _loop400:
  do {
   switch ( LA(1)) {
   case 'a':  case 'b':  case 'c':  case 'd':
   case 'e':  case 'f':  case 'g':  case 'h':
   case 'i':  case 'j':  case 'k':  case 'l':
   case 'm':  case 'n':  case 'o':  case 'p':
   case 'q':  case 'r':  case 's':  case 't':
   case 'u':  case 'v':  case 'w':  case 'x':
   case 'y':  case 'z':
   {
    matchRange('a','z');
    break;
   }
   case 'A':  case 'B':  case 'C':  case 'D':
   case 'E':  case 'F':  case 'G':  case 'H':
   case 'I':  case 'J':  case 'K':  case 'L':
   case 'M':  case 'N':  case 'O':  case 'P':
   case 'Q':  case 'R':  case 'S':  case 'T':
   case 'U':  case 'V':  case 'W':  case 'X':
   case 'Y':  case 'Z':
   {
    matchRange('A','Z');
    break;
   }
   case '_':
   {
    match('_');
    break;
   }
   case '0':  case '1':  case '2':  case '3':
   case '4':  case '5':  case '6':  case '7':
   case '8':  case '9':
   {
    matchRange('0','9');
    break;
   }
   default:
   {
    break _loop400;
   }
   }
  } while (true);
  }
  _ttype = testLiteralsTable(_ttype);
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mESCAPED_IDENT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = ESCAPED_IDENT;
  int _saveIndex;
  
  match('_');
  mIDENT(false);
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 
 private static final long[] mk_tokenSet_0() {
  long[] data = new long[1025];
  data[1]=576460743847706622L;
  return data;
 }
 public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
 private static final long[] mk_tokenSet_1() {
  long[] data = new long[2048];
  data[0]=-17179869185L;
  data[1]=-268435457L;
  for (int i = 2; i<=1022; i++) { data[i]=-1L; }
  data[1023]=9223372036854775807L;
  return data;
 }
 public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
 private static final long[] mk_tokenSet_2() {
  long[] data = new long[2048];
  data[0]=-9217L;
  for (int i = 1; i<=1022; i++) { data[i]=-1L; }
  data[1023]=9223372036854775807L;
  return data;
 }
 public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
 private static final long[] mk_tokenSet_3() {
  long[] data = new long[2048];
  data[0]=-549755813889L;
  data[1]=-268435457L;
  for (int i = 2; i<=1022; i++) { data[i]=-1L; }
  data[1023]=9223372036854775807L;
  return data;
 }
 public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
 private static final long[] mk_tokenSet_4() {
  long[] data = new long[1025];
  data[0]=287948901175001088L;
  data[1]=541165879422L;
  return data;
 }
 public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
 
 }
