package com.prismtech.idt.imports.idl.parser;

public interface IIdlParserStatus
{
   public static final int OK = 0;

   public static final int INFO = 0x01;

   public static final int WARNING = 0x02;

   public static final int ERROR = 0x04;

   public static final int CANCEL = 0x08;

   public int getSeverity ();
   
   public String getMessage ();
   
   public String getFilename ();

   public int getLine ();

   public int getColumn ();

   public Throwable getException ();
   
   public IIdlParserStatus[] getChildStati();
   
   public boolean isOK();
   
   public boolean isMultiStatus();
}
