// $ANTLR 2.7.7 (2006-11-01): "ExpLexer.g" -> "ExpLexer.java"$

  package com.prismtech.idt.imports.idl.internal.preprocessor;

import java.io.InputStream;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.TokenStreamRecognitionException;
import antlr.CharStreamException;
import antlr.CharStreamIOException;
import antlr.ANTLRException;
import java.io.Reader;
import java.util.Hashtable;
import antlr.CharScanner;
import antlr.InputBuffer;
import antlr.ByteBuffer;
import antlr.CharBuffer;
import antlr.Token;
import antlr.CommonToken;
import antlr.RecognitionException;
import antlr.NoViableAltForCharException;
import antlr.MismatchedCharException;
import antlr.TokenStream;
import antlr.ANTLRHashString;
import antlr.LexerSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.SemanticException;

public class ExpLexer extends antlr.CharScanner implements ExpLexerTokenTypes, TokenStream
 {
public ExpLexer(InputStream in) {
 this(new ByteBuffer(in));
}
public ExpLexer(Reader in) {
 this(new CharBuffer(in));
}
public ExpLexer(InputBuffer ib) {
 this(new LexerSharedInputState(ib));
}
public ExpLexer(LexerSharedInputState state) {
 super(state);
 caseSensitiveLiterals = true;
 setCaseSensitive(true);
 literals = new Hashtable();
}

public Token nextToken() throws TokenStreamException {
 Token theRetToken=null;
tryAgain:
 for (;;) {
  Token _token = null;
  int _ttype = Token.INVALID_TYPE;
  resetText();
  try {   // for char stream error handling
   try {   // for lexical error handling
    switch ( LA(1)) {
    case '1':  case '2':  case '3':  case '4':
    case '5':  case '6':  case '7':  case '8':
    case '9':
    {
     mDEC_INT(true);
     theRetToken=_returnToken;
     break;
    }
    case '\t':  case '\n':  case '\r':  case ' ':
    {
     mWS(true);
     theRetToken=_returnToken;
     break;
    }
    case '(':
    {
     mLPAREN(true);
     theRetToken=_returnToken;
     break;
    }
    case ')':
    {
     mRPAREN(true);
     theRetToken=_returnToken;
     break;
    }
    case '+':
    {
     mPLUS(true);
     theRetToken=_returnToken;
     break;
    }
    case '-':
    {
     mMINUS(true);
     theRetToken=_returnToken;
     break;
    }
    case '*':
    {
     mMULTIPLY(true);
     theRetToken=_returnToken;
     break;
    }
    case '/':
    {
     mDIVIDE(true);
     theRetToken=_returnToken;
     break;
    }
    case '%':
    {
     mREMAINDER(true);
     theRetToken=_returnToken;
     break;
    }
    case '~':
    {
     mCOMPLIMENT(true);
     theRetToken=_returnToken;
     break;
    }
    case '^':
    {
     mBIT_EXC_OR(true);
     theRetToken=_returnToken;
     break;
    }
    case '=':
    {
     mEQUAL(true);
     theRetToken=_returnToken;
     break;
    }
    default:
     if ((LA(1)=='0') && (LA(2)=='X'||LA(2)=='x')) {
      mHEX_INT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='<') && (LA(2)=='<')) {
      mLSHIFT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='>') && (LA(2)=='>')) {
      mRSHIFT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='|') && (LA(2)=='|')) {
      mOR(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='&') && (LA(2)=='&')) {
      mAND(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='!') && (LA(2)=='=')) {
      mNOT_EQUAL(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='<') && (LA(2)=='=')) {
      mLE(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='>') && (LA(2)=='=')) {
      mGE(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='d') && (LA(2)=='e')) {
      mDEFINED(true);
      theRetToken=_returnToken;
     }
     else if ((_tokenSet_0.member(LA(1))) && (true)) {
      mRAW_IDENTIFIER(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='0') && (true)) {
      mOCT_INT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='&') && (true)) {
      mBIT_AND(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='|') && (true)) {
      mBIT_INC_OR(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='!') && (true)) {
      mNOT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='<') && (true)) {
      mLT(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='>') && (true)) {
      mGT(true);
      theRetToken=_returnToken;
     }
    else {
     if (LA(1)==EOF_CHAR) {uponEOF(); _returnToken = makeToken(Token.EOF_TYPE);}
    else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
    }
    }
    if ( _returnToken==null ) continue tryAgain; // found SKIP token
    _ttype = _returnToken.getType();
    _ttype = testLiteralsTable(_ttype);
    _returnToken.setType(_ttype);
    return _returnToken;
   }
   catch (RecognitionException e) {
    throw new TokenStreamRecognitionException(e);
   }
  }
  catch (CharStreamException cse) {
   if ( cse instanceof CharStreamIOException ) {
    throw new TokenStreamIOException(((CharStreamIOException)cse).io);
   }
   else {
    throw new TokenStreamException(cse.getMessage());
   }
  }
 }
}

 public final void mRAW_IDENTIFIER(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = RAW_IDENTIFIER;
  int _saveIndex;
  
  {
  switch ( LA(1)) {
  case 'a':  case 'b':  case 'c':  case 'd':
  case 'e':  case 'f':  case 'g':  case 'h':
  case 'i':  case 'j':  case 'k':  case 'l':
  case 'm':  case 'n':  case 'o':  case 'p':
  case 'q':  case 'r':  case 's':  case 't':
  case 'u':  case 'v':  case 'w':  case 'x':
  case 'y':  case 'z':
  {
   matchRange('a','z');
   break;
  }
  case 'A':  case 'B':  case 'C':  case 'D':
  case 'E':  case 'F':  case 'G':  case 'H':
  case 'I':  case 'J':  case 'K':  case 'L':
  case 'M':  case 'N':  case 'O':  case 'P':
  case 'Q':  case 'R':  case 'S':  case 'T':
  case 'U':  case 'V':  case 'W':  case 'X':
  case 'Y':  case 'Z':
  {
   matchRange('A','Z');
   break;
  }
  case '_':
  {
   match('_');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  {
  _loop4:
  do {
   switch ( LA(1)) {
   case 'a':  case 'b':  case 'c':  case 'd':
   case 'e':  case 'f':  case 'g':  case 'h':
   case 'i':  case 'j':  case 'k':  case 'l':
   case 'm':  case 'n':  case 'o':  case 'p':
   case 'q':  case 'r':  case 's':  case 't':
   case 'u':  case 'v':  case 'w':  case 'x':
   case 'y':  case 'z':
   {
    matchRange('a','z');
    break;
   }
   case 'A':  case 'B':  case 'C':  case 'D':
   case 'E':  case 'F':  case 'G':  case 'H':
   case 'I':  case 'J':  case 'K':  case 'L':
   case 'M':  case 'N':  case 'O':  case 'P':
   case 'Q':  case 'R':  case 'S':  case 'T':
   case 'U':  case 'V':  case 'W':  case 'X':
   case 'Y':  case 'Z':
   {
    matchRange('A','Z');
    break;
   }
   case '_':
   {
    match('_');
    break;
   }
   case '0':  case '1':  case '2':  case '3':
   case '4':  case '5':  case '6':  case '7':
   case '8':  case '9':
   {
    matchRange('0','9');
    break;
   }
   default:
   {
    break _loop4;
   }
   }
  } while (true);
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mINT_SUFFIX(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = INT_SUFFIX;
  int _saveIndex;
  
  {
  if ((LA(1)=='l') && (LA(2)=='u')) {
   match("lu");
  }
  else if ((LA(1)=='L') && (LA(2)=='u')) {
   match("Lu");
  }
  else if ((LA(1)=='l') && (LA(2)=='U')) {
   match("lU");
  }
  else if ((LA(1)=='L') && (LA(2)=='U')) {
   match("LU");
  }
  else if ((LA(1)=='u') && (LA(2)=='l')) {
   match("ul");
  }
  else if ((LA(1)=='U') && (LA(2)=='l')) {
   match("Ul");
  }
  else if ((LA(1)=='u') && (LA(2)=='L')) {
   match("uL");
  }
  else if ((LA(1)=='U') && (LA(2)=='L')) {
   match("UL");
  }
  else if ((LA(1)=='l') && (true)) {
   match("l");
  }
  else if ((LA(1)=='L') && (true)) {
   match("L");
  }
  else if ((LA(1)=='u') && (true)) {
   match("u");
  }
  else if ((LA(1)=='U') && (true)) {
   match("U");
  }
  else {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mDEC_DIGITS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = DEC_DIGITS;
  int _saveIndex;
  
  {
  matchRange('1','9');
  }
  {
  _loop10:
  do {
   if (((LA(1) >= '0' && LA(1) <= '9'))) {
    matchRange('0','9');
   }
   else {
    break _loop10;
   }
   
  } while (true);
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mHEX_PREFIX(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = HEX_PREFIX;
  int _saveIndex;
  
  match('0');
  {
  switch ( LA(1)) {
  case 'x':
  {
   match('x');
   break;
  }
  case 'X':
  {
   match('X');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mHEX_DIGITS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = HEX_DIGITS;
  int _saveIndex;
  
  {
  int _cnt15=0;
  _loop15:
  do {
   switch ( LA(1)) {
   case '0':  case '1':  case '2':  case '3':
   case '4':  case '5':  case '6':  case '7':
   case '8':  case '9':
   {
    matchRange('0','9');
    break;
   }
   case 'a':  case 'b':  case 'c':  case 'd':
   case 'e':  case 'f':
   {
    matchRange('a','f');
    break;
   }
   case 'A':  case 'B':  case 'C':  case 'D':
   case 'E':  case 'F':
   {
    matchRange('A','F');
    break;
   }
   default:
   {
    if ( _cnt15>=1 ) { break _loop15; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
   }
   }
   _cnt15++;
  } while (true);
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mOCT_PREFIX(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = OCT_PREFIX;
  int _saveIndex;
  
  match('0');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mOCT_DIGITS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = OCT_DIGITS;
  int _saveIndex;
  
  {
  _loop19:
  do {
   if (((LA(1) >= '0' && LA(1) <= '7'))) {
    matchRange('0','7');
   }
   else {
    break _loop19;
   }
   
  } while (true);
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mDEC_INT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = DEC_INT;
  int _saveIndex;
  
  mDEC_DIGITS(false);
  {
  if ((_tokenSet_1.member(LA(1)))) {
   _saveIndex=text.length();
   mINT_SUFFIX(false);
   text.setLength(_saveIndex);
  }
  else {
  }
  
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mHEX_INT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = HEX_INT;
  int _saveIndex;
  
  _saveIndex=text.length();
  mHEX_PREFIX(false);
  text.setLength(_saveIndex);
  mHEX_DIGITS(false);
  {
  if ((_tokenSet_1.member(LA(1)))) {
   _saveIndex=text.length();
   mINT_SUFFIX(false);
   text.setLength(_saveIndex);
  }
  else {
  }
  
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mOCT_INT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = OCT_INT;
  int _saveIndex;
  
  mOCT_PREFIX(false);
  mOCT_DIGITS(false);
  {
  if ((_tokenSet_1.member(LA(1)))) {
   _saveIndex=text.length();
   mINT_SUFFIX(false);
   text.setLength(_saveIndex);
  }
  else {
  }
  
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mWS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = WS;
  int _saveIndex;
  
  {
  switch ( LA(1)) {
  case ' ':
  {
   match(' ');
   break;
  }
  case '\t':
  {
   match('\t');
   break;
  }
  case '\r':
  {
   match('\r');
   break;
  }
  case '\n':
  {
   match('\n');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  _ttype = Token.SKIP;
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mLPAREN(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = LPAREN;
  int _saveIndex;
  
  match('(');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mRPAREN(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = RPAREN;
  int _saveIndex;
  
  match(')');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mPLUS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = PLUS;
  int _saveIndex;
  
  match('+');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mMINUS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = MINUS;
  int _saveIndex;
  
  match('-');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mMULTIPLY(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = MULTIPLY;
  int _saveIndex;
  
  match('*');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mDIVIDE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = DIVIDE;
  int _saveIndex;
  
  match('/');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mREMAINDER(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = REMAINDER;
  int _saveIndex;
  
  match('%');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mCOMPLIMENT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = COMPLIMENT;
  int _saveIndex;
  
  match('~');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mLSHIFT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = LSHIFT;
  int _saveIndex;
  
  match("<<");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mRSHIFT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = RSHIFT;
  int _saveIndex;
  
  match(">>");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mBIT_AND(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = BIT_AND;
  int _saveIndex;
  
  match("&");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mBIT_INC_OR(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = BIT_INC_OR;
  int _saveIndex;
  
  match("|");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mBIT_EXC_OR(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = BIT_EXC_OR;
  int _saveIndex;
  
  match("^");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mOR(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = OR;
  int _saveIndex;
  
  match("||");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mAND(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = AND;
  int _saveIndex;
  
  match("&&");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mEQUAL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = EQUAL;
  int _saveIndex;
  
  match("==");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mNOT_EQUAL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = NOT_EQUAL;
  int _saveIndex;
  
  match("!=");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mNOT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = NOT;
  int _saveIndex;
  
  match('!');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mLT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = LT;
  int _saveIndex;
  
  match('<');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mLE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = LE;
  int _saveIndex;
  
  match("<=");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mGE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = GE;
  int _saveIndex;
  
  match(">=");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mGT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = GT;
  int _saveIndex;
  
  match('>');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mDEFINED(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = DEFINED;
  int _saveIndex;
  
  match("defined");
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 
 private static final long[] mk_tokenSet_0() {
  long[] data = { 0L, 576460745995190270L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
 private static final long[] mk_tokenSet_1() {
  long[] data = { 0L, 9024791442886656L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
 
 }
