// $ANTLR 2.7.7 (2006-11-01): "ExpLexer.g" -> "ExpTreeParser.java"$

  package com.prismtech.idt.imports.idl.internal.preprocessor;

import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

  import java.io.*;
  import java.util.*;
  import antlr.*;
  import com.prismtech.idt.imports.idl.preprocessor.IIdlPreprocessor;
  import com.prismtech.idt.imports.idl.preprocessor.IIdlPreprocessorStatus;


public class ExpTreeParser extends antlr.TreeParser       implements ExpLexerTokenTypes
 {

  private List<IIdlPreprocessorStatus> m_status = new ArrayList<IIdlPreprocessorStatus> ();
  CppLexer parent;
  
  public ExpTreeParser(CppLexer parent)
  {
   this.parent = parent;
  }
  
  public IIdlPreprocessorStatus getStatus()
  {
    switch (m_status.size())
    {
      case 0 :
      {
        return new PreprocessorStatus(IIdlPreprocessorStatus.OK);
      }
      case 1 :
      {
        return m_status.get(0);
      }
      default :
      {
        PreprocessorStatus status = new PreprocessorStatus();
        for (IIdlPreprocessorStatus s : m_status)
          status.add (s);
        return status;
      }
    }
  } 
  
  @Override
  public void reportError(RecognitionException recex)
  {
   m_status.add(new PreprocessorStatus(parent, IIdlPreprocessorStatus.ERROR, recex.getMessage(), recex));
  }
  
  @Override
  public void reportError(String message)
  {
   m_status.add(new PreprocessorStatus(parent, IIdlPreprocessorStatus.ERROR, message, null));
  }
  
  @Override
  public void reportWarning(String message)
  {
   m_status.add(new PreprocessorStatus(parent, IIdlPreprocessorStatus.WARNING, message, null));
  }
public ExpTreeParser() {
 tokenNames = _tokenNames;
}

 public final  int  value(AST _t) throws RecognitionException {
   int i ;
  
  AST value_AST_in = (_t == ASTNULL) ? null : (AST)_t;
  AST d = null;
  AST h = null;
  AST o = null;
  AST r = null;
  
  int x, y;
  i = 0;
  
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case BIT_INC_OR:
   {
    AST __t90 = _t;
    AST tmp35_AST_in = (AST)_t;
    match(_t,BIT_INC_OR);
    _t = _t.getFirstChild();
    x=value(_t);
    _t = _retTree;
    y=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     i = x|y;
    }
    _t = __t90;
    _t = _t.getNextSibling();
    break;
   }
   case BIT_EXC_OR:
   {
    AST __t91 = _t;
    AST tmp36_AST_in = (AST)_t;
    match(_t,BIT_EXC_OR);
    _t = _t.getFirstChild();
    x=value(_t);
    _t = _retTree;
    y=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     i = x^y;
    }
    _t = __t91;
    _t = _t.getNextSibling();
    break;
   }
   case BIT_AND:
   {
    AST __t92 = _t;
    AST tmp37_AST_in = (AST)_t;
    match(_t,BIT_AND);
    _t = _t.getFirstChild();
    x=value(_t);
    _t = _retTree;
    y=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     i = x&y;
    }
    _t = __t92;
    _t = _t.getNextSibling();
    break;
   }
   case LSHIFT:
   {
    AST __t93 = _t;
    AST tmp38_AST_in = (AST)_t;
    match(_t,LSHIFT);
    _t = _t.getFirstChild();
    x=value(_t);
    _t = _retTree;
    y=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     i = x<<y;
    }
    _t = __t93;
    _t = _t.getNextSibling();
    break;
   }
   case RSHIFT:
   {
    AST __t94 = _t;
    AST tmp39_AST_in = (AST)_t;
    match(_t,RSHIFT);
    _t = _t.getFirstChild();
    x=value(_t);
    _t = _retTree;
    y=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     i = x>>y;
    }
    _t = __t94;
    _t = _t.getNextSibling();
    break;
   }
   case MULTIPLY:
   {
    AST __t105 = _t;
    AST tmp40_AST_in = (AST)_t;
    match(_t,MULTIPLY);
    _t = _t.getFirstChild();
    x=value(_t);
    _t = _retTree;
    y=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     i = x*y;
    }
    _t = __t105;
    _t = _t.getNextSibling();
    break;
   }
   case DIVIDE:
   {
    AST __t106 = _t;
    AST tmp41_AST_in = (AST)_t;
    match(_t,DIVIDE);
    _t = _t.getFirstChild();
    x=value(_t);
    _t = _retTree;
    y=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     i = x/y;
    }
    _t = __t106;
    _t = _t.getNextSibling();
    break;
   }
   case REMAINDER:
   {
    AST __t107 = _t;
    AST tmp42_AST_in = (AST)_t;
    match(_t,REMAINDER);
    _t = _t.getFirstChild();
    x=value(_t);
    _t = _retTree;
    y=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     i = x%y;
    }
    _t = __t107;
    _t = _t.getNextSibling();
    break;
   }
   case COMPLIMENT:
   {
    AST __t108 = _t;
    AST tmp43_AST_in = (AST)_t;
    match(_t,COMPLIMENT);
    _t = _t.getFirstChild();
    x=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     i = ~x;
    }
    _t = __t108;
    _t = _t.getNextSibling();
    break;
   }
   case DEC_INT:
   {
    d = (AST)_t;
    match(_t,DEC_INT);
    _t = _t.getNextSibling();
    if ( inputState.guessing==0 ) {
     i = Integer.parseInt(d.getText(), 10);
    }
    break;
   }
   case HEX_INT:
   {
    h = (AST)_t;
    match(_t,HEX_INT);
    _t = _t.getNextSibling();
    if ( inputState.guessing==0 ) {
     i = Integer.parseInt(h.getText(), 16);
    }
    break;
   }
   case OCT_INT:
   {
    o = (AST)_t;
    match(_t,OCT_INT);
    _t = _t.getNextSibling();
    if ( inputState.guessing==0 ) {
     i = Integer.parseInt(o.getText(), 8);
    }
    break;
   }
   case RAW_IDENTIFIER:
   {
    r = (AST)_t;
    match(_t,RAW_IDENTIFIER);
    _t = _t.getNextSibling();
    if ( inputState.guessing==0 ) {
     i = 0;
    }
    break;
   }
   default:
    boolean synPredMatched97 = false;
    if (_t==null) _t=ASTNULL;
    if (((_t.getType()==PLUS))) {
     AST __t97 = _t;
     synPredMatched97 = true;
     inputState.guessing++;
     try {
      {
      AST __t96 = _t;
      AST tmp44_AST_in = (AST)_t;
      match(_t,PLUS);
      _t = _t.getFirstChild();
      x=value(_t);
      _t = _retTree;
      y=value(_t);
      _t = _retTree;
      _t = __t96;
      _t = _t.getNextSibling();
      }
     }
     catch (RecognitionException pe) {
      synPredMatched97 = false;
     }
     _t = __t97;
inputState.guessing--;
    }
    if ( synPredMatched97 ) {
     AST __t98 = _t;
     AST tmp45_AST_in = (AST)_t;
     match(_t,PLUS);
     _t = _t.getFirstChild();
     x=value(_t);
     _t = _retTree;
     y=value(_t);
     _t = _retTree;
     if ( inputState.guessing==0 ) {
      i = x+y;
     }
     _t = __t98;
     _t = _t.getNextSibling();
    }
    else if ((_t.getType()==PLUS)) {
     AST __t99 = _t;
     AST tmp46_AST_in = (AST)_t;
     match(_t,PLUS);
     _t = _t.getFirstChild();
     x=value(_t);
     _t = _retTree;
     if ( inputState.guessing==0 ) {
      i = x;
     }
     _t = __t99;
     _t = _t.getNextSibling();
    }
    else {
     boolean synPredMatched102 = false;
     if (_t==null) _t=ASTNULL;
     if (((_t.getType()==MINUS))) {
      AST __t102 = _t;
      synPredMatched102 = true;
      inputState.guessing++;
      try {
       {
       AST __t101 = _t;
       AST tmp47_AST_in = (AST)_t;
       match(_t,MINUS);
       _t = _t.getFirstChild();
       x=value(_t);
       _t = _retTree;
       y=value(_t);
       _t = _retTree;
       _t = __t101;
       _t = _t.getNextSibling();
       }
      }
      catch (RecognitionException pe) {
       synPredMatched102 = false;
      }
      _t = __t102;
inputState.guessing--;
     }
     if ( synPredMatched102 ) {
      AST __t103 = _t;
      AST tmp48_AST_in = (AST)_t;
      match(_t,MINUS);
      _t = _t.getFirstChild();
      x=value(_t);
      _t = _retTree;
      y=value(_t);
      _t = _retTree;
      if ( inputState.guessing==0 ) {
       i = x-y;
      }
      _t = __t103;
      _t = _t.getNextSibling();
     }
     else if ((_t.getType()==MINUS)) {
      AST __t104 = _t;
      AST tmp49_AST_in = (AST)_t;
      match(_t,MINUS);
      _t = _t.getFirstChild();
      x=value(_t);
      _t = _retTree;
      if ( inputState.guessing==0 ) {
       i = -1*x;
      }
      _t = __t104;
      _t = _t.getNextSibling();
     }
    else {
     throw new NoViableAltException(_t);
    }
    }}
   }
   catch (RecognitionException ex) {
    if (inputState.guessing==0) {
     reportError(ex);
     if (_t!=null) {_t = _t.getNextSibling();}
    } else {
      throw ex;
    }
   }
   _retTree = _t;
   return i ;
  }
  
 public final  String  identifier(AST _t) throws RecognitionException {
   String s ;
  
  AST identifier_AST_in = (_t == ASTNULL) ? null : (AST)_t;
  AST i = null;
  
  s = null;
  
  
  try {      // for error handling
   i = (AST)_t;
   match(_t,RAW_IDENTIFIER);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    s = i.getText();
    
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  _retTree = _t;
  return s ;
 }
 
 public final  boolean  expression(AST _t) throws RecognitionException {
   boolean e ;
  
  AST expression_AST_in = (_t == ASTNULL) ? null : (AST)_t;
  
  boolean a, b;
  int l, r;
  String i;
  
  e = false;
  
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case AND:
   {
    AST __t111 = _t;
    AST tmp50_AST_in = (AST)_t;
    match(_t,AND);
    _t = _t.getFirstChild();
    a=expression(_t);
    _t = _retTree;
    b=expression(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     e = a && b;
    }
    _t = __t111;
    _t = _t.getNextSibling();
    break;
   }
   case BAND:
   {
    AST __t112 = _t;
    AST tmp51_AST_in = (AST)_t;
    match(_t,BAND);
    _t = _t.getFirstChild();
    a=expression(_t);
    _t = _retTree;
    b=expression(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     e = a & b;
    }
    _t = __t112;
    _t = _t.getNextSibling();
    break;
   }
   case OR:
   {
    AST __t113 = _t;
    AST tmp52_AST_in = (AST)_t;
    match(_t,OR);
    _t = _t.getFirstChild();
    a=expression(_t);
    _t = _retTree;
    b=expression(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     e = a || b;
    }
    _t = __t113;
    _t = _t.getNextSibling();
    break;
   }
   case BOR:
   {
    AST __t114 = _t;
    AST tmp53_AST_in = (AST)_t;
    match(_t,BOR);
    _t = _t.getFirstChild();
    a=expression(_t);
    _t = _retTree;
    b=expression(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     e = a | b;
    }
    _t = __t114;
    _t = _t.getNextSibling();
    break;
   }
   case NOT:
   {
    AST __t115 = _t;
    AST tmp54_AST_in = (AST)_t;
    match(_t,NOT);
    _t = _t.getFirstChild();
    a=expression(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     e = !a;
    }
    _t = __t115;
    _t = _t.getNextSibling();
    break;
   }
   case EQUAL:
   {
    AST __t116 = _t;
    AST tmp55_AST_in = (AST)_t;
    match(_t,EQUAL);
    _t = _t.getFirstChild();
    l=value(_t);
    _t = _retTree;
    r=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     e = l==r;
    }
    _t = __t116;
    _t = _t.getNextSibling();
    break;
   }
   case NOT_EQUAL:
   {
    AST __t117 = _t;
    AST tmp56_AST_in = (AST)_t;
    match(_t,NOT_EQUAL);
    _t = _t.getFirstChild();
    l=value(_t);
    _t = _retTree;
    r=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     e = l!=r;
    }
    _t = __t117;
    _t = _t.getNextSibling();
    break;
   }
   case LT:
   {
    AST __t118 = _t;
    AST tmp57_AST_in = (AST)_t;
    match(_t,LT);
    _t = _t.getFirstChild();
    l=value(_t);
    _t = _retTree;
    r=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     e = l<r;
    }
    _t = __t118;
    _t = _t.getNextSibling();
    break;
   }
   case LE:
   {
    AST __t119 = _t;
    AST tmp58_AST_in = (AST)_t;
    match(_t,LE);
    _t = _t.getFirstChild();
    l=value(_t);
    _t = _retTree;
    r=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     e = l<=r;
    }
    _t = __t119;
    _t = _t.getNextSibling();
    break;
   }
   case GE:
   {
    AST __t120 = _t;
    AST tmp59_AST_in = (AST)_t;
    match(_t,GE);
    _t = _t.getFirstChild();
    l=value(_t);
    _t = _retTree;
    r=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     e = l>=r;
    }
    _t = __t120;
    _t = _t.getNextSibling();
    break;
   }
   case GT:
   {
    AST __t121 = _t;
    AST tmp60_AST_in = (AST)_t;
    match(_t,GT);
    _t = _t.getFirstChild();
    l=value(_t);
    _t = _retTree;
    r=value(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     e = l>r;
    }
    _t = __t121;
    _t = _t.getNextSibling();
    break;
   }
   case DEFINED:
   {
    AST __t122 = _t;
    AST tmp61_AST_in = (AST)_t;
    match(_t,DEFINED);
    _t = _t.getFirstChild();
    i=identifier(_t);
    _t = _retTree;
    if ( inputState.guessing==0 ) {
     e = parent.defines.containsKey(i);
    }
    _t = __t122;
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  _retTree = _t;
  return e ;
 }
 
 
 public static final String[] _tokenNames = {
  "<0>",
  "EOF",
  "<2>",
  "NULL_TREE_LOOKAHEAD",
  "RAW_IDENTIFIER",
  "INT_SUFFIX",
  "DEC_DIGITS",
  "HEX_PREFIX",
  "HEX_DIGITS",
  "OCT_PREFIX",
  "OCT_DIGITS",
  "DEC_INT",
  "HEX_INT",
  "OCT_INT",
  "WS",
  "LPAREN",
  "RPAREN",
  "PLUS",
  "MINUS",
  "MULTIPLY",
  "DIVIDE",
  "REMAINDER",
  "COMPLIMENT",
  "LSHIFT",
  "RSHIFT",
  "BIT_AND",
  "BIT_INC_OR",
  "BIT_EXC_OR",
  "OR",
  "AND",
  "EQUAL",
  "NOT_EQUAL",
  "NOT",
  "LT",
  "LE",
  "GE",
  "GT",
  "DEFINED",
  "BAND",
  "BOR"
 };
 
 }
 
