<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
import com.thalesgroup.ccm.codegenerator.container.cpp.SessionContext_hpp
%>

<%script type="idlmm.ComponentDef" name="extensionFilePath" post="trim()"%>
<%generatedExtensionContextClassname%>.hpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.ComponentDef" name="ExtensionContext_hpp" file="<%extensionFilePath%>"%>
<%copyrightHeader%>


<%openIfndefMacro(generatedExtensionContextFullClassname)%>

<%genIncludeCdmwCifSkelFile%>

#include <CCMContainer/ccmcif/ExtensionContext_impl.hpp>
#include <CCMContainer/ccmcif/CCMObject_impl.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>


<%openNamespace(generatedContextPackage)%>

    class <%generatedExtensionContextClassname%> : virtual public <%generatedExtensionContextInterface%>,
                                                   public ExtensionContext_impl
    {
        public:
            <%generatedExtensionContextClassname%>(Components::CCMContext_ptr ctx,
                                                   ::Cdmw::CCM::CIF::CCMObject_impl* component,
                                                   CdmwLogging::LoggerFactory_ptr logger_factory)
                throw (CORBA::SystemException);

            ~<%generatedExtensionContextClassname%>();

            <%--
                Receptacles.
            --%>

            <%allUsesPorts.genUsesCode%>
    

            <%--
                Emitters.
            --%>
    
            <%allEmitsPorts.genEventPortCode%>

            <%--
                Publishers.
            --%>
    
            <%allPublishesPorts.genEventPortCode%>

        private:
            <%generatedExtensionContextClassname%>();

            <%generatedExtensionContextClassname%>(const <%generatedExtensionContextClassname%>&);
            void operator=(const <%generatedExtensionContextClassname%>&);

             // Component servant implementation
            ::Cdmw::CCM::CIF::CCMObject_impl* m_component;

            // logger to be used in CCMContext
            CdmwLogging::Logger_var m_logger;
    };



<%closeNamespace(generatedContextPackage)%>

<%closeIfndefMacro(generatedExtensionContextFullClassname)%>


