<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.CommonServices
%>



<%-- 
  -- PrimitiveDef mapping
  --%>
<%script type="idlmm.PrimitiveDef" name="asReturnParameterDef" post="trim()"%>
    <%if (kind == "pk_null"){%>
        <%abort("ERROR: no existing java mapping for 'pk_null' PrimitiveDef.")%>
    <%}else if (kind == "pk_void"){%>
        void
    <%}else if (kind == "pk_short"){%>
        short
    <%}else if (kind == "pk_long"){%>
        int
    <%}else if (kind == "pk_ushort"){%>
        short
    <%}else if (kind == "pk_ulong"){%>
        int
    <%}else if (kind == "pk_float"){%>
        float
    <%}else if (kind == "pk_double"){%>
        double
    <%}else if (kind == "pk_boolean"){%>
        boolean
    <%}else if (kind == "pk_char"){%>
        char
    <%}else if (kind == "pk_octet"){%>
        byte
    <%}else if (kind == "pk_any"){%>
        org.omg.CORBA.Any
    <%}else if (kind == "pk_type_code"){%>
        org.omg.CORBA.TypeCode
    <%}else if (kind == "pk_principal"){%>
        org.omg.CORBA.Principal
    <%}else if (kind == "pk_string"){%>
        java.lang.String
    <%}else if (kind == "pk_objref"){%>
        org.omg.CORBA.Object
    <%}else if (kind == "pk_longlong"){%>
        long
    <%}else if (kind == "pk_ulonglong"){%>
        long
    <%}else if (kind == "pk_longdouble"){%>
        double
    <%}else if (kind == "pk_wchar"){%>
        char
    <%}else if (kind == "pk_wstring"){%>
        java.lang.String
    <%}else if (kind == "pk_value_base"){%>
        java.io.Serializable
    <%}else{%>
        <%abort("INTERNAL ERROR: PrimitiveDef with kind '" + kind + "' has no specified mapping")%>
    <%}%>

<%script type="idlmm.PrimitiveDef" name="asInParameterDef" post="trim()"%>
    <%asReturnParameterDef%>

    
<%script type="idlmm.PrimitiveDef" name="asInoutParameterDef" post="trim()"%>
    <%if (kind == "pk_null"){%>
        <%abort("ERROR: no existing java mapping for 'pk_null' PrimitiveDef.")%>
    <%}else if (kind == "pk_void"){%>
        void
    <%}else if (kind == "pk_short"){%>
        org.omg.CORBA.ShortHolder
    <%}else if (kind == "pk_long"){%>
        org.omg.CORBA.IntHolder
    <%}else if (kind == "pk_ushort"){%>
        org.omg.CORBA.ShortHolder
    <%}else if (kind == "pk_ulong"){%>
        org.omg.CORBA.IntHolder
    <%}else if (kind == "pk_float"){%>
        org.omg.CORBA.FloatHolder
    <%}else if (kind == "pk_double"){%>
        org.omg.CORBA.DoubleHolder
    <%}else if (kind == "pk_boolean"){%>
        org.omg.CORBA.BooleanHolder
    <%}else if (kind == "pk_char"){%>
        org.omg.CORBA.CharHolder
    <%}else if (kind == "pk_octet"){%>
        org.omg.CORBA.ByteHolder
    <%}else if (kind == "pk_any"){%>
        org.omg.CORBA.AnyHolder
    <%}else if (kind == "pk_type_code"){%>
        org.omg.CORBA.TypeCodeHolder
    <%}else if (kind == "pk_principal"){%>
        org.omg.CORBA.PrincipalHolder
    <%}else if (kind == "pk_string"){%>
        org.omg.CORBA.StringHolder
    <%}else if (kind == "pk_objref"){%>
        org.omg.CORBA.ObjectHolder
    <%}else if (kind == "pk_longlong"){%>
        org.omg.CORBA.LongHolder
    <%}else if (kind == "pk_ulonglong"){%>
        org.omg.CORBA.LongHolder
    <%}else if (kind == "pk_longdouble"){%>
        org.omg.CORBA.DoubleHolder
    <%}else if (kind == "pk_wchar"){%>
        org.omg.CORBA.CharHolder
    <%}else if (kind == "pk_wstring"){%>
        org.omg.CORBA.StringHolder
    <%}else if (kind == "pk_value_base"){%>
        org.omg.CORBA.ValueBaseHolder
    <%}else{%>
        <%abort("INTERNAL ERROR: PrimitiveDef with kind '" + kind + "' has no specified mapping")%>
    <%}%>

<%script type="idlmm.PrimitiveDef" name="asOutParameterDef" post="trim()"%>
    <%asInoutParameterDef%>

<%script type="idlmm.PrimitiveDef" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.PrimitiveDef" name="getInitValue" post="trim()"%>
    <%if (kind == "pk_null"){%>
        null
    <%}else if (kind == "pk_void"){%>
        <%abort("ERROR: cannot set initial value for 'pk_void' PrimitiveDef.")%>
    <%}else if (kind == "pk_short"){%>
        0
    <%}else if (kind == "pk_long"){%>
        0
    <%}else if (kind == "pk_ushort"){%>
        0
    <%}else if (kind == "pk_ulong"){%>
        0
    <%}else if (kind == "pk_float"){%>
        0
    <%}else if (kind == "pk_double"){%>
        0
    <%}else if (kind == "pk_boolean"){%>
        false
    <%}else if (kind == "pk_char"){%>
        0
    <%}else if (kind == "pk_octet"){%>
        0
    <%}else if (kind == "pk_any"){%>
        null
    <%}else if (kind == "pk_type_code"){%>
        null
    <%}else if (kind == "pk_principal"){%>
        null
    <%}else if (kind == "pk_string"){%>
        null
    <%}else if (kind == "pk_objref"){%>
        null
    <%}else if (kind == "pk_longlong"){%>
        0
    <%}else if (kind == "pk_ulonglong"){%>
        0
    <%}else if (kind == "pk_longdouble"){%>
        0
    <%}else if (kind == "pk_wchar"){%>
        0
    <%}else if (kind == "pk_wstring"){%>
        null
    <%}else if (kind == "pk_value_base"){%>
        null
    <%}else{%>
        <%abort("INTERNAL ERROR: PrimitiveDef with kind '" + kind + "' has no specified mapping")%>
    <%}%>

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.PrimitiveDef" name="genAnyInsertion" post="trim()"%>
    <%if (kind == "pk_null"){%>
        <%abort("ERROR: cannot insert 'pk_null' PrimitiveDef in an Any (use DynAny).")%>
    <%}else if (kind == "pk_void"){%>
        <%abort("ERROR: cannot insert 'pk_void' PrimitiveDef in an Any (use DynAny).")%>
    <%}else if (kind == "pk_short"){%>
        <%args(0)%>.insert_short(<%args(1)%>)
    <%}else if (kind == "pk_long"){%>
        <%args(0)%>.insert_long(<%args(1)%>)
    <%}else if (kind == "pk_ushort"){%>
        <%args(0)%>.insert_ushort(<%args(1)%>)
    <%}else if (kind == "pk_ulong"){%>
        <%args(0)%>.insert_ulong(<%args(1)%>)
    <%}else if (kind == "pk_float"){%>
        <%args(0)%>.insert_float(<%args(1)%>)
    <%}else if (kind == "pk_double"){%>
        <%args(0)%>.insert_double(<%args(1)%>)
    <%}else if (kind == "pk_boolean"){%>
        <%args(0)%>.insert_boolean(<%args(1)%>)
    <%}else if (kind == "pk_char"){%>
        <%args(0)%>.insert_char(<%args(1)%>)
    <%}else if (kind == "pk_octet"){%>
        <%args(0)%>.insert_octet(<%args(1)%>)
    <%}else if (kind == "pk_any"){%>
        <%args(0)%>.insert_any(<%args(1)%>)
    <%}else if (kind == "pk_type_code"){%>
        <%args(0)%>.insert_TypeCode(<%args(1)%>)
    <%}else if (kind == "pk_principal"){%>
        <%args(0)%>.insert_Principal(<%args(1)%>)
    <%}else if (kind == "pk_string"){%>
        <%args(0)%>.insert_string(<%args(1)%>)
    <%}else if (kind == "pk_objref"){%>
        <%args(0)%>.insert_Object(<%args(1)%>)
    <%}else if (kind == "pk_longlong"){%>
        <%args(0)%>.insert_longlong(<%args(1)%>)
    <%}else if (kind == "pk_ulonglong"){%>
        <%args(0)%>.insert_ulonglong(<%args(1)%>)
    <%}else if (kind == "pk_longdouble"){%>
        <%args(0)%>.insert_longdouble(<%args(1)%>)
    <%}else if (kind == "pk_wchar"){%>
        <%args(0)%>.insert_wchar(<%args(1)%>)
    <%}else if (kind == "pk_wstring"){%>
        <%args(0)%>.insert_wstring(<%args(1)%>)
    <%}else if (kind == "pk_value_base"){%>
        <%args(0)%>.insert_Value(<%args(1)%>)
    <%}else{%>
        <%abort("INTERNAL ERROR: PrimitiveDef with kind '" + kind + "' has no specified mapping")%>
    <%}%>

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.PrimitiveDef" name="genAnyExtraction" post="trim()"%>
    <%if (kind == "pk_null"){%>
        <%abort("ERROR: cannot extract 'pk_null' PrimitiveDef from an Any (use DynAny).")%>
    <%}else if (kind == "pk_void"){%>
        <%abort("ERROR: cannot extract 'pk_void' PrimitiveDef from an Any (use DynAny).")%>
    <%}else if (kind == "pk_short"){%>
        <%args(0)%>.extract_short()
    <%}else if (kind == "pk_long"){%>
        <%args(0)%>.extract_long()
    <%}else if (kind == "pk_ushort"){%>
        <%args(0)%>.extract_ushort()
    <%}else if (kind == "pk_ulong"){%>
        <%args(0)%>.extract_ulong()
    <%}else if (kind == "pk_float"){%>
        <%args(0)%>.extract_float()
    <%}else if (kind == "pk_double"){%>
        <%args(0)%>.extract_double()
    <%}else if (kind == "pk_boolean"){%>
        <%args(0)%>.extract_boolean()
    <%}else if (kind == "pk_char"){%>
        <%args(0)%>.extract_char()
    <%}else if (kind == "pk_octet"){%>
        <%args(0)%>.extract_octet()
    <%}else if (kind == "pk_any"){%>
        <%args(0)%>.extract_any()
    <%}else if (kind == "pk_type_code"){%>
        <%args(0)%>.extract_TypeCode()
    <%}else if (kind == "pk_principal"){%>
        <%args(0)%>.extract_Principal()
    <%}else if (kind == "pk_string"){%>
        <%args(0)%>.extract_string()
    <%}else if (kind == "pk_objref"){%>
        <%args(0)%>.extract_Object()
    <%}else if (kind == "pk_longlong"){%>
        <%args(0)%>.extract_longlong()
    <%}else if (kind == "pk_ulonglong"){%>
        <%args(0)%>.extract_ulonglong()
    <%}else if (kind == "pk_longdouble"){%>
        <%args(0)%>.extract_longdouble()
    <%}else if (kind == "pk_wchar"){%>
        <%args(0)%>.extract_wchar()
    <%}else if (kind == "pk_wstring"){%>
        <%args(0)%>.extract_wstring()
    <%}else if (kind == "pk_value_base"){%>
        <%args(0)%>.extract_Value()
    <%}else{%>
        <%abort("INTERNAL ERROR: PrimitiveDef with kind '" + kind + "' has no specified mapping")%>
    <%}%>



<%-- 
  -- StringDef mapping (for bounded string)
  --%>
<%script type="idlmm.StringDef" name="asReturnParameterDef" post="trim()"%>
    java.lang.String

<%script type="idlmm.StringDef" name="asInParameterDef" post="trim()"%>
    java.lang.String

<%script type="idlmm.StringDef" name="asInoutParameterDef" post="trim()"%>
    org.omg.CORBA.StringHolder

<%script type="idlmm.StringDef" name="asOutParameterDef" post="trim()"%>
    org.omg.CORBA.StringHolder

<%script type="idlmm.StringDef" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.StringDef" name="getInitValue" post="trim()"%>
    null

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.StringDef" name="genAnyInsertion" post="trim()"%>
    <%args(0)%>.insert_string(<%args(1)%>)
    
    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.StringDef" name="genAnyExtraction" post="trim()"%>
    <%args(0)%>.extract_string()

    
<%-- 
  -- WStringDef mapping (for bounded wstring)
  --%>
<%script type="idlmm.WStringDef" name="asReturnParameterDef" post="trim()"%>
    java.lang.String

<%script type="idlmm.WStringDef" name="asInParameterDef" post="trim()"%>
    java.lang.String

<%script type="idlmm.WStringDef" name="asInoutParameterDef" post="trim()"%>
    org.omg.CORBA.StringHolder

<%script type="idlmm.WStringDef" name="asOutParameterDef" post="trim()"%>
    org.omg.CORBA.StringHolder
    
<%script type="idlmm.WStringDef" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.WStringDef" name="getInitValue" post="trim()"%>
    null
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.WStringDef" name="genAnyInsertion" post="trim()"%>
    <%args(0)%>.insert_wstring(<%args(1)%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.WStringDef" name="genAnyExtraction" post="trim()"%>
    <%args(0)%>.extract_wstring()

    
<%-- 
  -- FixedDef mapping (for bounded string)
  --%>
<%script type="idlmm.FixedDef" name="asReturnParameterDef" post="trim()"%>
    java.math.BigDecimal

<%script type="idlmm.FixedDef" name="asInParameterDef" post="trim()"%>
    java.lang.BigDecimal

<%script type="idlmm.FixedDef" name="asInoutParameterDef" post="trim()"%>
    org.omg.CORBA.FixedHolder

<%script type="idlmm.FixedDef" name="asOutParameterDef" post="trim()"%>
    org.omg.CORBA.FixedHolder
    
<%script type="idlmm.FixedDef" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.FixedDef" name="getInitValue" post="trim()"%>
    null
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.FixedDef" name="genAnyInsertion" post="trim()"%>
    <%args(0)%>.insert_fixed(<%args(1)%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.FixedDef" name="genAnyExtraction" post="trim()"%>
    <%args(0)%>.extract_fixed()
    