<%
metamodel http://www.prismtech.com/idlmm
%>

<%script type="idlmm.Repository" name="initClockService"%>
#ifdef CDMW_TIME_SERVICE_ENABLED

// *****************************************************************
// *********Init The CDMW Time Service  *********
// ***************************************************************** 
{
    CDMW_DEBUG(InitUtils::Get_Logger(), "Init Time Service");
    // definition of Corbaname URL :
    //   Note : Time Service default port is set to 4883
      
    // initializes the CosClockServices.
    if (Cdmw::clock::CosClock::init (orb, argc, argv) == false)
    {
        CDMW_WARN(InitUtils::Get_Logger(),"It is not possible not initialize clock service!");
      
    }
    
}

#endif // CDMW_TIME_SERVICE_ENABLED



<%script type="idlmm.Repository" name="stopClockService"%>
#ifdef CDMW_TIME_SERVICE_ENABLED

Cdmw::clock::CosClock::close();
 
#endif //CDMW_TIME_SERVICE_ENABLED

