<%
metamodel http://www.prismtech.com/idlmm
%>


<%script type="idlmm.Repository" name="initRepositoryInterface"%>
// *****************************************************************
// *****************  INIT of RepositoryInterface ******************
// *****************************************************************
String defaultDomaineName = "";

try {
    defaultDomaineName =
        xmlData.getServiceAttributeValue(
            "repository-interface",
            "default-domain-name");
} catch (BadParameterException bpe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (XMLErrorException xmle) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}

try {
    RepositoryInterface.init(defaultDomaineName, repository);
} catch (
    com.thalesgroup.CdmwNamingAndRepository.NoNameDomain nnd) {
    processImpl.setCdmwInitExceptionRaised();
    // Default NameDomain is not a NameDomain!
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMNameDomainNotFound,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (com.thalesgroup.CdmwNamingAndRepository.InvalidName in) {
    processImpl.setCdmwInitExceptionRaised();
    // Default NameDomain name is ill-formed!
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidDefaultDomainName,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}



<%script type="idlmm.Repository" name="stopRepositoryInterface"%>
// Release all static object references held by RepositoryInterface
RepositoryInterface.finish();

