<%
metamodel http://www.prismtech.com/idlmm
%>


<%script type="idlmm.Repository" name="initWatchdogService"%>
// *****************************************************************
// *************  setup WatchdogServiceInit  **********
// *****************************************************************
try {
    cdmw.ft.watchdog.WatchdogServiceInit.init(args);
} catch (org.omg.CORBA.SystemException  e) {
    try {
        System.out.println("CDMW_preORBInit: Fatal Error: \n");
        e.printStackTrace();
    } catch(Exception ex) {
        Assert.check(false);
    }
}        



<%script type="idlmm.Repository" name="setupWatchdogService"%>
// *****************************************************************
// *************  INIT WatchdogServiceInit  **********
// *****************************************************************
try {
    // No System.getProperty() performed like in C++ code because
    // WATCHDOG_TIMEOUT_PROPERTY_NAME property is set by default 
    // with the default request_timeout value. Thus the property
    // is not null.
    String str = xmlData.getServiceAttributeValue("watchdog", 
                                              "timeout");

    int milliseconds = Integer.parseInt(str); 
    cdmw.ft.watchdog.WatchdogServiceInit.setTimeout(milliseconds);

    // export property for debug purpose
    System.setProperty(
        cdmw.ft.FTSystemProperties.WATCHDOG_TIMEOUT_PROPERTY_NAME, 
        str);
      
} catch (BadParameterException bpe) {
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (XMLErrorException xmle) {
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (NumberFormatException e) {
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (org.omg.CORBA.BAD_PARAM e) {
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAM,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}

