<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.lifecycle.ModelServices
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
%>


<%script type="idlmm.OperationDef" name="checkCdmwLifeCycleKeyParameterForNamedFactory"%>
<%--
   Check whether the first parameter of the operation is of type CdmwLifeCycle::Key.
   (For a named factory, all factory operations should have it)
--%>
<%if (!parameters.nFirst.type.isCdmwLifeCycleKey){%>
<%abort("FAILURE : The interface <%containingInterface.absoluteName%> contains operations with a missing CdmwLifeCycle.Key parameter.
 Are you using a suitable IDL interface to generate this named factory ?
 The generation of the factory <%factoryImplClassname%> is aborted.
")%>
<%}%>


<%script type="idlmm.OperationDef" name="checkCdmwLifeCycleKeyParameterForAnonymousFactory"%>
<%--
   Check whether the first parameter of the operation is of type CdmwLifeCycle::Key.
   (For an anonymous factory, all factory operations shouldn't have it)
--%>
<%if (parameters.nFirst.type.isCdmwLifeCycleKey){%>
<%abort("FAILURE : The interface <%containingInterface.absoluteName%> contains operations with a CdmwLifeCycle.Key parameter.
 Are you using a suitable IDL interface to generate this anonymous factory ?
 The generation of the factory <%factoryImplClassname%> is aborted.
")%>
<%}%>



<%-- return true if the type is a ::CdmwLifeCycle::Key --%>
<%script type="idlmm.Contained" name="isCdmwLifeCycleKey" post="trim()"%>
<%if (absoluteName == "::CdmwLifeCycle::Key"){%>
<%true%>
<%}else{%>
<%false%>
<%}%>

<%-- return true if the type is a ::CdmwLifeCycle::Key --%>
<%-- (fallback case: always return false)              --%>
<%script type="idlmm.IDLType" name="isCdmwLifeCycleKey" post="trim()"%>
<%false%>

