<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.lifecycle.LifeCycleServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.ModelServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.cpp.Utils
import com.thalesgroup.cdmw.codegenerator.lifecycle.cpp.ServantProvider_hpp
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.container.Utils
%>


<%script type="idlmm.Repository" name="cppFilePath" post="trim()"%>
<%if (servantProviderFilename.length() > 0){%>
<%servantProviderDirectoryPrefix%><%servantProviderFilename%>
<%}else{%>
<%servantProviderDirectoryPrefix%><%servantProviderClassname%>.cpp
<%}%>




<%--
  -- Generation template  
  -- This template is not model-based (idlmm.Repository is just specified
  -- to access InterfaceDef data)
  -- All is based on LifeCycleServices which provides access to loaded data
  -- from XML file.
  --%>
<%script type="idlmm.Repository" name="ServantProvider_cpp" file="<%cppFilePath%>"%>
<%copyrightHeader%>

#include "<%servantProviderHppFilePath%>"

<%openNamespace(servantProviderClassnameScope.withCppScope)%>

    <%servantProviderClassname%>::<%servantProviderClassname%>()
        throw()
    {
    }

    <%servantProviderClassname%>::~<%servantProviderClassname%>()
        throw()
    {
    }

    const char**
    <%servantProviderClassname%>::get_ids() const throw()
    {
        static const char* ids[] = {
            <%idlInterface.genReturnObjectsIds%>
            0
        };
        return ids;
    }

    CORBA::Long
    <%servantProviderClassname%>::get_number_of_ids() const throw()
    {
        static const CORBA::Long nb = <%idlInterface.genReturnObjectsCount%>;
        return nb;
    }

<%closeNamespace(servantProviderClassnameScope.withCppScope)%>



<%script type="idlmm.InterfaceDef" name="genReturnObjectsIds"%>
<%-- get all operations return types which are InterfaceDef,
     add all inherited interfaces of those interfaces,
     remove duplicates (nMinimize)
     and print RepositoryId for each interface.
 --%>
<%for ((allOperations.type.filter("InterfaceDef") +
        allOperations.type.filter("InterfaceDef").allBaseInterfaces).nMinimize
){%>
"<%ID%>", 
<%}%>


<%script type="idlmm.InterfaceDef" name="genReturnObjectsCount"%>
<%-- get all operations return types which are InterfaceDef,
     add all inherited interfaces of those interfaces,
     remove duplicates (nMinimize)
     and return list size.
 --%>
<%(allOperations.type.filter("InterfaceDef") +
   allOperations.type.filter("InterfaceDef").allBaseInterfaces).nMinimize.nSize%>
   
   