<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.lifecycle.LifeCycleServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.ModelServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.Utils
import com.thalesgroup.cdmw.codegenerator.lifecycle.cpp.Utils
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.container.Utils
%>


<%--
  -- Generation template  
  -- This template is not model-based (idlmm.Repository is just specified
  -- to access InterfaceDef data)
  -- All is based on LifeCycleServices which provides access to loaded data
  -- from XML file.
  --%>
<%script type="idlmm.Repository" name="SessionFactoryAllocator_hpp" file="<%factoryAllocatorHppFilePath%>"%>
<%copyrightHeader%>

<%openIfndefMacro("RESOURCES_"+factoryAllocatorClassname)%>

#include <LifeCycle/lifecycle/FactoryAllocator.hpp>

#include "<%factoryHppFilePath%>"

<%openNamespace(factoryImplClassnameScope.withCppScope)%>

    // TODO: Use a user-provided name rather than a naming convention!
    typedef Cdmw::LifeCycle::AnonymousObjectsFactoryAllocator< <%factoryImplClassname%> >
        <%factoryImplClassname%>_Allocator;

<%closeNamespace(factoryImplClassnameScope.withCppScope)%>

<%closeIfndefMacro("RESOURCES_"+factoryAllocatorClassname)%>
