<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.lifecycle.LifeCycleServices
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
%>


<%--
  -- If directory attribute is specified for the <program>,
  -- this script returns the directory +"/"
  --%>
<%script type="idlmm.Repository" name="servantProviderDirectoryPrefix" post="trim()"%>
<%if (servantProviderDirectory.length > 0){%>
<%servantProviderDirectory%>/
<%}%>



<%--
  -- If directory attribute is specified for the <program>,
  -- this script returns the directory +"/"
  --%>
<%script type="idlmm.Repository" name="factoryImplDirectoryPrefix" post="trim()"%>
<%if (factoryImplDirectory.length > 0){%>
<%factoryImplDirectory%>/
<%}%>


<%script type="idlmm.Repository" name="factoryHppFilePath" post="trim()"%>
<%if (factoryImplFilename.length() > 0){%>
<%factoryImplDirectoryPrefix%><%factoryImplFilename%>
<%}else{%>
<%factoryImplDirectoryPrefix%><%factoryImplClassname%>.hpp
<%}%>

<%script type="idlmm.Repository" name="factoryCppFilePath" post="trim()"%>
<%if (factoryImplFilename.length() > 0){%>
<%factoryImplDirectoryPrefix%><%factoryImplFilename%>
<%}else{%>
<%factoryImplDirectoryPrefix%><%factoryImplClassname%>.cpp
<%}%>


<%script type="idlmm.Repository" name="factoryAllocatorClassname"%>
<%factoryImplClassname%>_allocator

<%script type="idlmm.Repository" name="factoryAllocatorHppFilePath" post="trim()"%>
<%if (factoryImplFilename.length() > 0){%>
<%factoryImplDirectoryPrefix%><%factoryImplFilename%>
<%}else{%>
<%factoryImplDirectoryPrefix%><%factoryAllocatorClassname%>.hpp
<%}%>




<%script type="idlmm.Repository" name="servantProviderFullClassname" post="trim()"%>
::<%servantProviderClassnameScope.withCppScope%>::<%servantProviderClassname%>


<%script type="idlmm.Repository" name="factoryImplFullClassname" post="trim()"%>
::<%factoryImplClassnameScope.withCppScope%>::<%factoryImplClassname%>






<%script type="idlmm.Repository" name="userServantProviderAllocatorFilename" post="trim()"%>
<%if (servantProviderAllocatorFilename.length() > 0){%>
<%servantProviderAllocatorFilename%>
<%}else{%>
<%servantProviderAllocatorClassname%>.hpp
<%}%>
