<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.lifecycle.LifeCycleServices
import com.thalesgroup.ccm.codegenerator.container.Utils
%>


<%script type="idlmm.Repository" name="classname" post="trim()"%>
<%-- Allocator classname is <factory-impl> classname + "Allocator" --%>
<%factoryImplClassname%>Allocator

<%script type="idlmm.Repository" name="package" post="trim()"%>
<%-- Allocator package is the same than <factory-impl> --%>
<%factoryImplClassnameScope%>


<%script type="idlmm.Repository" name="javaFilePath" post="trim()"%>
<%if (package.length() > 0){%>
<%directoryPrefix%><%package.replaceAll("\.", "/")%>/<%classname%>.java
<%}else{%>
<%directoryPrefix%><%classname%>.java
<%}%>



<%--
  -- If directory attribute is specified for the <program>,
  -- this script returns the directory +"/"
  --%>
<%script type="idlmm.Repository" name="directoryPrefix" post="trim()"%>
<%if (factoryImplDirectory.length > 0){%>
<%factoryImplDirectory%>/
<%}%>



<%--
  -- Generation template  
  -- This template is not model-based (idlmm.Repository is just specified
  -- to access InterfaceDef data)
  -- All is based on LifeCycleServices which provides access to loaded data
  -- from XML file.
  --%>
<%script type="idlmm.Repository" name="UnmanagedEntityFactoryAllocator" file="<%javaFilePath%>"%>
<%copyrightHeader%>

<%if (package.length() > 0){%>
package <%package%>;
<%}%>

import cdmw.lifecycle.NamedObjectsFactoryAllocator;

public class <%classname%>
    extends NamedObjectsFactoryAllocator
{

    public <%classname%>() {
        super("<%factoryImplClassnameScope%>.<%factoryImplClassname%>");
    }

    public static final <%classname%> theAllocator =
        new <%classname%>();

}