/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine;

import java.util.List;

import org.eclipse.emf.ecore.EObject;

/**
 * Model interface.
 * 
 * @author www.obeo.fr
 * 
 */
public interface IModel {

	/**
	 * Returns the namespace URI.
	 * 
	 * @return the namespace URI
	 */
	String getNsURI();

	/**
	 * Returns the roots.
	 * 
	 * @return the roots
	 */
	List<EObject> getRoots();
}
