/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.core.impl.spec;

import fr.obeo.acceleo.gen.template.eval.ENode;
import fr.obeo.acceleo.gen.template.eval.ENodeException;

import org.acceleo.engine.context.EvalContext;
import org.acceleo.engine.template.impl.spec.EvaluableTools;
import org.acceleo.engine.template.impl.spec.IEvaluable;
import org.acceleo.template.core.impl.FilePathImpl;
import org.acceleo.tools.factory.FactoryException;

/**
 * A representation of the model object '<em><b>Script</b></em>'.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public class TFilePath extends FilePathImpl implements IEvaluable {
	/**
	 * {@inheritDoc}
	 */
	public ENode gen(ENode root, EvalContext evalContext) throws ENodeException, FactoryException {
		return EvaluableTools.genStatements(this, root, getStatements(), evalContext);
	}
	// TODO YLU add toString()
}
