/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.impl.spec;

import org.acceleo.template.ResourceSet;
import org.acceleo.template.impl.TemplateFactoryImpl;

/**
 * Specific implementation of the factory.
 * 
 * @author Yvan LUSSAUD <a
 *         href="mailto:yvan.lussaud@obeo.fr">yvan.lussaud@obeo.fr</a>
 * 
 */
public class TTemplateFactory extends TemplateFactoryImpl {

	/**
	 * Constructor.
	 */
	public TTemplateFactory() {
		super();
	}

	/**
	 * {@inheritDoc}
	 */
	public ResourceSet createResourceSet() {
		return new TResourceSet();
	}
} // TTemplateFactory
