/**
 * <copyright>
 * </copyright>
 *
 * $Id: AttributeDefImpl.java,v 1.33 2008/08/22 11:55:33 je Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.AttributeDef;
import com.prismtech.idt.idlmm.AttributeMode;
import com.prismtech.idt.idlmm.ComponentContained;
import com.prismtech.idt.idlmm.ComponentDef;
import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.ExceptionDef;
import com.prismtech.idt.idlmm.HomeContained;
import com.prismtech.idt.idlmm.HomeDef;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.InterfaceContained;
import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.Named;
import com.prismtech.idt.idlmm.ValueContained;
import com.prismtech.idt.idlmm.ValueDef;
import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Attribute Def</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getKey <em>Key</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getContainer <em>Container</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getAbsoluteName <em>Absolute Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getPrefix <em>Prefix</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getID <em>ID</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getVersion <em>Version</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getContainingInterface <em>Containing Interface</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getContainingValue <em>Containing Value</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getContainingComponent <em>Containing Component</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getContainingHome <em>Containing Home</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getMode <em>Mode</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getGetExceptions <em>Get Exceptions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.AttributeDefImpl#getSetExceptions <em>Set Exceptions</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AttributeDefImpl extends TypedImpl implements AttributeDef
{
   /**
    * The default value of the '{@link #getName() <em>Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getName()
    * @generated
    * @ordered
    */
   protected static final String NAME_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getName()
    * @generated
    * @ordered
    */
   protected String name = NAME_EDEFAULT;

   /**
    * The default value of the '{@link #getKey() <em>Key</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getKey()
    * @generated
    * @ordered
    */
   protected static final String KEY_EDEFAULT = null;

   /**
    * The default value of the '{@link #getAbsoluteName() <em>Absolute Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getAbsoluteName()
    * @generated
    * @ordered
    */
   protected static final String ABSOLUTE_NAME_EDEFAULT = null;

   /**
    * The default value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected static final String PREFIX_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected String prefix = PREFIX_EDEFAULT;

   /**
    * The default value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected static final String ID_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected String id = ID_EDEFAULT;

   /**
    * The default value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected static final String VERSION_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected String version = VERSION_EDEFAULT;

   /**
    * The default value of the '{@link #getMode() <em>Mode</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getMode()
    * @generated
    * @ordered
    */
   protected static final AttributeMode MODE_EDEFAULT = AttributeMode.ATTR_NORMAL;

   /**
    * The cached value of the '{@link #getMode() <em>Mode</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getMode()
    * @generated
    * @ordered
    */
   protected AttributeMode mode = MODE_EDEFAULT;

   /**
    * The cached value of the '{@link #getGetExceptions() <em>Get Exceptions</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getGetExceptions()
    * @generated
    * @ordered
    */
   protected EList<ExceptionDef> getExceptions;

   /**
    * The cached value of the '{@link #getSetExceptions() <em>Set Exceptions</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getSetExceptions()
    * @generated
    * @ordered
    */
   protected EList<ExceptionDef> setExceptions;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected AttributeDefImpl ()
   {
      super ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.ATTRIBUTE_DEF;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getName ()
   {
      return name;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setName (String newName)
   {
      String oldName = name;
      name = newName;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ATTRIBUTE_DEF__NAME, oldName, name));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getKey ()
   {
      return NamedExt.getKey (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public AttributeMode getMode ()
   {
      return mode;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setMode (AttributeMode newMode)
   {
      AttributeMode oldMode = mode;
      mode = newMode == null ? MODE_EDEFAULT : newMode;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ATTRIBUTE_DEF__MODE, oldMode, mode));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<ExceptionDef> getGetExceptions ()
   {
      if (getExceptions == null)
      {
         getExceptions = new EObjectResolvingEList<ExceptionDef> (ExceptionDef.class, this,
               IdlmmPackage.ATTRIBUTE_DEF__GET_EXCEPTIONS);
      }
      return getExceptions;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<ExceptionDef> getSetExceptions ()
   {
      if (setExceptions == null)
      {
         setExceptions = new EObjectResolvingEList<ExceptionDef> (ExceptionDef.class, this,
               IdlmmPackage.ATTRIBUTE_DEF__SET_EXCEPTIONS);
      }
      return setExceptions;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public void setContainer (Container newContainer)
   {
      ContainedExt.setContainer (this, newContainer);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Container getContainer ()
   {
      Container container = basicGetContainer ();
      return container != null && container.eIsProxy () ? (Container) eResolveProxy ((InternalEObject) container) : container;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Container basicGetContainer ()
   {
      InterfaceDef containingInterface = getContainingInterface ();
      if (containingInterface != null)
      {
         return containingInterface;
      }
      ValueDef containingValue = getContainingValue ();
      if (containingValue != null)
      {
         return containingValue;
      }
      ComponentDef containingComponent = getContainingComponent ();
      if (containingComponent != null)
      {
         return containingComponent;
      }
      HomeDef containingHome = getContainingHome ();
      if (containingHome != null)
      {
         return containingHome;
      }
      return null;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getAbsoluteName ()
   {
      return ContainedExt.getAbsoluteName (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getPrefix ()
   {
      return prefix;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setPrefix (String newPrefix)
   {
      String oldPrefix = prefix;
      prefix = newPrefix;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ATTRIBUTE_DEF__PREFIX, oldPrefix, prefix));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getID ()
   {
      return ContainedExt.getID (this, id);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setID (String newID)
   {
      String oldID = id;
      id = newID;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ATTRIBUTE_DEF__ID, oldID, id));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getVersion ()
   {
      return version;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setVersion (String newVersion)
   {
      String oldVersion = version;
      version = newVersion;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ATTRIBUTE_DEF__VERSION, oldVersion, version));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public InterfaceDef getContainingInterface ()
   {
      if (eContainerFeatureID != IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE)
         return null;
      return (InterfaceDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingInterface (InterfaceDef newContainingInterface, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingInterface, IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingInterface (InterfaceDef newContainingInterface)
   {
      if (newContainingInterface != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE && newContainingInterface != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingInterface))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingInterface != null)
            msgs = ((InternalEObject) newContainingInterface).eInverseAdd (this, IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS,
                  InterfaceDef.class, msgs);
         msgs = basicSetContainingInterface (newContainingInterface, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE,
               newContainingInterface, newContainingInterface));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ValueDef getContainingValue ()
   {
      if (eContainerFeatureID != IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE)
         return null;
      return (ValueDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingValue (ValueDef newContainingValue, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingValue, IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingValue (ValueDef newContainingValue)
   {
      if (newContainingValue != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE && newContainingValue != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingValue))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingValue != null)
            msgs = ((InternalEObject) newContainingValue).eInverseAdd (this, IdlmmPackage.VALUE_DEF__VALUE_CONTENTS,
                  ValueDef.class, msgs);
         msgs = basicSetContainingValue (newContainingValue, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE, newContainingValue,
               newContainingValue));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ComponentDef getContainingComponent ()
   {
      if (eContainerFeatureID != IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT)
         return null;
      return (ComponentDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingComponent (ComponentDef newContainingComponent, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingComponent, IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingComponent (ComponentDef newContainingComponent)
   {
      if (newContainingComponent != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT && newContainingComponent != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingComponent))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingComponent != null)
            msgs = ((InternalEObject) newContainingComponent).eInverseAdd (this, IdlmmPackage.COMPONENT_DEF__COMPONENT_CONTENTS,
                  ComponentDef.class, msgs);
         msgs = basicSetContainingComponent (newContainingComponent, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT,
               newContainingComponent, newContainingComponent));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public HomeDef getContainingHome ()
   {
      if (eContainerFeatureID != IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME)
         return null;
      return (HomeDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingHome (HomeDef newContainingHome, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingHome, IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingHome (HomeDef newContainingHome)
   {
      if (newContainingHome != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME && newContainingHome != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingHome))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingHome != null)
            msgs = ((InternalEObject) newContainingHome).eInverseAdd (this, IdlmmPackage.HOME_DEF__HOME_CONTENTS, HomeDef.class,
                  msgs);
         msgs = basicSetContainingHome (newContainingHome, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME, newContainingHome,
               newContainingHome));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<IRObject> getPrerequisites ()
   {
      return AttributeDefExt.getPrerequisites (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingInterface ((InterfaceDef) otherEnd, msgs);
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingValue ((ValueDef) otherEnd, msgs);
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingComponent ((ComponentDef) otherEnd, msgs);
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingHome ((HomeDef) otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE:
            return basicSetContainingInterface (null, msgs);
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE:
            return basicSetContainingValue (null, msgs);
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT:
            return basicSetContainingComponent (null, msgs);
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME:
            return basicSetContainingHome (null, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature (NotificationChain msgs)
   {
      switch (eContainerFeatureID)
      {
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS, InterfaceDef.class,
                  msgs);
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.VALUE_DEF__VALUE_CONTENTS, ValueDef.class, msgs);
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.COMPONENT_DEF__COMPONENT_CONTENTS, ComponentDef.class,
                  msgs);
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.HOME_DEF__HOME_CONTENTS, HomeDef.class, msgs);
      }
      return super.eBasicRemoveFromContainerFeature (msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.ATTRIBUTE_DEF__NAME:
            return getName ();
         case IdlmmPackage.ATTRIBUTE_DEF__KEY:
            return getKey ();
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINER:
            if (resolve)
               return getContainer ();
            return basicGetContainer ();
         case IdlmmPackage.ATTRIBUTE_DEF__ABSOLUTE_NAME:
            return getAbsoluteName ();
         case IdlmmPackage.ATTRIBUTE_DEF__PREFIX:
            return getPrefix ();
         case IdlmmPackage.ATTRIBUTE_DEF__ID:
            return getID ();
         case IdlmmPackage.ATTRIBUTE_DEF__VERSION:
            return getVersion ();
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE:
            return getContainingInterface ();
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE:
            return getContainingValue ();
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT:
            return getContainingComponent ();
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME:
            return getContainingHome ();
         case IdlmmPackage.ATTRIBUTE_DEF__MODE:
            return getMode ();
         case IdlmmPackage.ATTRIBUTE_DEF__GET_EXCEPTIONS:
            return getGetExceptions ();
         case IdlmmPackage.ATTRIBUTE_DEF__SET_EXCEPTIONS:
            return getSetExceptions ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.ATTRIBUTE_DEF__NAME:
            setName ((String) newValue);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINER:
            setContainer ((Container) newValue);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__PREFIX:
            setPrefix ((String) newValue);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__ID:
            setID ((String) newValue);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__VERSION:
            setVersion ((String) newValue);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE:
            setContainingInterface ((InterfaceDef) newValue);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE:
            setContainingValue ((ValueDef) newValue);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT:
            setContainingComponent ((ComponentDef) newValue);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME:
            setContainingHome ((HomeDef) newValue);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__MODE:
            setMode ((AttributeMode) newValue);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__GET_EXCEPTIONS:
            getGetExceptions ().clear ();
            getGetExceptions ().addAll ((Collection<? extends ExceptionDef>) newValue);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__SET_EXCEPTIONS:
            getSetExceptions ().clear ();
            getSetExceptions ().addAll ((Collection<? extends ExceptionDef>) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.ATTRIBUTE_DEF__NAME:
            setName (NAME_EDEFAULT);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINER:
            setContainer ((Container) null);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__PREFIX:
            setPrefix (PREFIX_EDEFAULT);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__ID:
            setID (ID_EDEFAULT);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__VERSION:
            setVersion (VERSION_EDEFAULT);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE:
            setContainingInterface ((InterfaceDef) null);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE:
            setContainingValue ((ValueDef) null);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT:
            setContainingComponent ((ComponentDef) null);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME:
            setContainingHome ((HomeDef) null);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__MODE:
            setMode (MODE_EDEFAULT);
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__GET_EXCEPTIONS:
            getGetExceptions ().clear ();
            return;
         case IdlmmPackage.ATTRIBUTE_DEF__SET_EXCEPTIONS:
            getSetExceptions ().clear ();
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.ATTRIBUTE_DEF__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals (name);
         case IdlmmPackage.ATTRIBUTE_DEF__KEY:
            return KEY_EDEFAULT == null ? getKey () != null : !KEY_EDEFAULT.equals (getKey ());
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINER:
            return isSetContainer ();
         case IdlmmPackage.ATTRIBUTE_DEF__ABSOLUTE_NAME:
            return ABSOLUTE_NAME_EDEFAULT == null ? getAbsoluteName () != null : !ABSOLUTE_NAME_EDEFAULT
                  .equals (getAbsoluteName ());
         case IdlmmPackage.ATTRIBUTE_DEF__PREFIX:
            return PREFIX_EDEFAULT == null ? prefix != null : !PREFIX_EDEFAULT.equals (prefix);
         case IdlmmPackage.ATTRIBUTE_DEF__ID:
            return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals (id);
         case IdlmmPackage.ATTRIBUTE_DEF__VERSION:
            return VERSION_EDEFAULT == null ? version != null : !VERSION_EDEFAULT.equals (version);
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE:
            return getContainingInterface () != null;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE:
            return getContainingValue () != null;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT:
            return getContainingComponent () != null;
         case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME:
            return getContainingHome () != null;
         case IdlmmPackage.ATTRIBUTE_DEF__MODE:
            return mode != MODE_EDEFAULT;
         case IdlmmPackage.ATTRIBUTE_DEF__GET_EXCEPTIONS:
            return getExceptions != null && !getExceptions.isEmpty ();
         case IdlmmPackage.ATTRIBUTE_DEF__SET_EXCEPTIONS:
            return setExceptions != null && !setExceptions.isEmpty ();
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == Named.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ATTRIBUTE_DEF__NAME:
               return IdlmmPackage.NAMED__NAME;
            case IdlmmPackage.ATTRIBUTE_DEF__KEY:
               return IdlmmPackage.NAMED__KEY;
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ATTRIBUTE_DEF__ABSOLUTE_NAME:
               return IdlmmPackage.CONTAINED__ABSOLUTE_NAME;
            case IdlmmPackage.ATTRIBUTE_DEF__PREFIX:
               return IdlmmPackage.CONTAINED__PREFIX;
            case IdlmmPackage.ATTRIBUTE_DEF__ID:
               return IdlmmPackage.CONTAINED__ID;
            case IdlmmPackage.ATTRIBUTE_DEF__VERSION:
               return IdlmmPackage.CONTAINED__VERSION;
            case IdlmmPackage.ATTRIBUTE_DEF__CONTAINER:
               return IdlmmPackage.CONTAINED__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == InterfaceContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE:
               return IdlmmPackage.INTERFACE_CONTAINED__CONTAINING_INTERFACE;
            default:
               return -1;
         }
      }
      if (baseClass == ValueContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE:
               return IdlmmPackage.VALUE_CONTAINED__CONTAINING_VALUE;
            default:
               return -1;
         }
      }
      if (baseClass == ComponentContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT:
               return IdlmmPackage.COMPONENT_CONTAINED__CONTAINING_COMPONENT;
            default:
               return -1;
         }
      }
      if (baseClass == HomeContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME:
               return IdlmmPackage.HOME_CONTAINED__CONTAINING_HOME;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == Named.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.NAMED__NAME:
               return IdlmmPackage.ATTRIBUTE_DEF__NAME;
            case IdlmmPackage.NAMED__KEY:
               return IdlmmPackage.ATTRIBUTE_DEF__KEY;
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINED__ABSOLUTE_NAME:
               return IdlmmPackage.ATTRIBUTE_DEF__ABSOLUTE_NAME;
            case IdlmmPackage.CONTAINED__PREFIX:
               return IdlmmPackage.ATTRIBUTE_DEF__PREFIX;
            case IdlmmPackage.CONTAINED__ID:
               return IdlmmPackage.ATTRIBUTE_DEF__ID;
            case IdlmmPackage.CONTAINED__VERSION:
               return IdlmmPackage.ATTRIBUTE_DEF__VERSION;
            case IdlmmPackage.CONTAINED__CONTAINER:
               return IdlmmPackage.ATTRIBUTE_DEF__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == InterfaceContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.INTERFACE_CONTAINED__CONTAINING_INTERFACE:
               return IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE;
            default:
               return -1;
         }
      }
      if (baseClass == ValueContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.VALUE_CONTAINED__CONTAINING_VALUE:
               return IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE;
            default:
               return -1;
         }
      }
      if (baseClass == ComponentContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.COMPONENT_CONTAINED__CONTAINING_COMPONENT:
               return IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT;
            default:
               return -1;
         }
      }
      if (baseClass == HomeContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.HOME_CONTAINED__CONTAINING_HOME:
               return IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String toString ()
   {
      if (eIsProxy ())
         return super.toString ();

      StringBuffer result = new StringBuffer (super.toString ());
      result.append (" (name: ");
      result.append (name);
      result.append (", prefix: ");
      result.append (prefix);
      result.append (", ID: ");
      result.append (id);
      result.append (", version: ");
      result.append (version);
      result.append (", mode: ");
      result.append (mode);
      result.append (')');
      return result.toString ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContainer ()
   {
      return eIsSet (IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_INTERFACE) || eIsSet (IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_VALUE)
            || eIsSet (IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_COMPONENT) || eIsSet (IdlmmPackage.ATTRIBUTE_DEF__CONTAINING_HOME);
   }

} //AttributeDefImpl
