/**
 * <copyright>
 * </copyright>
 *
 * $Id: EventDefImpl.java,v 1.1 2008/08/22 11:55:34 je Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.AttributeContainer;
import com.prismtech.idt.idlmm.AttributeDef;
import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.EventDef;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.Initializer;
import com.prismtech.idt.idlmm.Interface;
import com.prismtech.idt.idlmm.OperationContainer;
import com.prismtech.idt.idlmm.OperationDef;
import com.prismtech.idt.idlmm.ValueContained;
import com.prismtech.idt.idlmm.ValueDef;
import com.prismtech.idt.idlmm.ValueMemberDef;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.uml2.common.util.DerivedUnionEObjectEList;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Event Def</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getContents <em>Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getOperations <em>Operations</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getAllOperations <em>All Operations</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getAllAttributes <em>All Attributes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#isCustom <em>Custom</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#isTruncatable <em>Truncatable</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getBaseValues <em>Base Values</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getValueContents <em>Value Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getSupportedInterfaces <em>Supported Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getMembers <em>Members</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getInitializers <em>Initializers</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getAllContents <em>All Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getAllBaseValues <em>All Base Values</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getAllSupportedInterfaces <em>All Supported Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.EventDefImpl#getEventContents <em>Event Contents</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class EventDefImpl extends EventImpl implements EventDef
{
   /**
    * The default value of the '{@link #isCustom() <em>Custom</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #isCustom()
    * @generated
    * @ordered
    */
   protected static final boolean CUSTOM_EDEFAULT = false;

   /**
    * The cached value of the '{@link #isCustom() <em>Custom</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #isCustom()
    * @generated
    * @ordered
    */
   protected boolean custom = CUSTOM_EDEFAULT;

   /**
    * The default value of the '{@link #isTruncatable() <em>Truncatable</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #isTruncatable()
    * @generated
    * @ordered
    */
   protected static final boolean TRUNCATABLE_EDEFAULT = false;

   /**
    * The cached value of the '{@link #isTruncatable() <em>Truncatable</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #isTruncatable()
    * @generated
    * @ordered
    */
   protected boolean truncatable = TRUNCATABLE_EDEFAULT;

   /**
    * The cached value of the '{@link #getBaseValues() <em>Base Values</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getBaseValues()
    * @generated
    * @ordered
    */
   protected EList<ValueDef> baseValues;

   /**
    * The cached value of the '{@link #getValueContents() <em>Value Contents</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getValueContents()
    * @generated
    * @ordered
    */
   protected EList<ValueContained> valueContents;

   /**
    * The cached value of the '{@link #getSupportedInterfaces() <em>Supported Interfaces</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getSupportedInterfaces()
    * @generated
    * @ordered
    */
   protected EList<Interface> supportedInterfaces;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected EventDefImpl ()
   {
      super ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.EVENT_DEF;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<Contained> getContents ()
   {
      return new DerivedUnionEObjectEList<Contained> (Contained.class, this, IdlmmPackage.EVENT_DEF__CONTENTS, CONTENTS_ESUBSETS);
   }

   /**
    * The array of subset feature identifiers for the '{@link #getContents() <em>Contents</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getContents()
    * @generated
    * @ordered
    */
   protected static final int[] CONTENTS_ESUBSETS = new int[]
   {
      IdlmmPackage.EVENT_DEF__VALUE_CONTENTS
   };

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<OperationDef> getOperations ()
   {
      return EventDefExt.getOperations (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<OperationDef> getAllOperations ()
   {
      return EventDefExt.getAllOperations (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AttributeDef> getAttributes ()
   {
      return EventDefExt.getAttributes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AttributeDef> getAllAttributes ()
   {
      return EventDefExt.getAllAttributes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isCustom ()
   {
      return custom;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setCustom (boolean newCustom)
   {
      boolean oldCustom = custom;
      custom = newCustom;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.EVENT_DEF__CUSTOM, oldCustom, custom));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isTruncatable ()
   {
      return truncatable;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setTruncatable (boolean newTruncatable)
   {
      boolean oldTruncatable = truncatable;
      truncatable = newTruncatable;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.EVENT_DEF__TRUNCATABLE, oldTruncatable, truncatable));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<ValueDef> getBaseValues ()
   {
      if (baseValues == null)
      {
         baseValues = new EObjectResolvingEList<ValueDef> (ValueDef.class, this, IdlmmPackage.EVENT_DEF__BASE_VALUES);
      }
      return baseValues;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<ValueContained> getValueContents ()
   {
      if (valueContents == null)
      {
         valueContents = new EObjectContainmentWithInverseEList<ValueContained> (ValueContained.class, this,
               IdlmmPackage.EVENT_DEF__VALUE_CONTENTS, IdlmmPackage.VALUE_CONTAINED__CONTAINING_VALUE);
      }
      return valueContents;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<Interface> getSupportedInterfaces ()
   {
      if (supportedInterfaces == null)
      {
         supportedInterfaces = new EObjectResolvingEList<Interface> (Interface.class, this,
               IdlmmPackage.EVENT_DEF__SUPPORTED_INTERFACES);
      }
      return supportedInterfaces;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ValueMemberDef> getMembers ()
   {
      return EventDefExt.getMembers (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<Initializer> getInitializers ()
   {
      return EventDefExt.getInitializers (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<Contained> getAllContents ()
   {
      return EventDefExt.getAllContents (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ValueDef> getAllBaseValues ()
   {
      return EventDefExt.getAllBaseValues (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<Interface> getAllSupportedInterfaces ()
   {
      return EventDefExt.getAllSupportedInterfaces (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ValueContained> getEventContents ()
   {
      return EventDefExt.getEventContents (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Contained lookup (String name)
   {
      return ContainerExt.lookup (this, name);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<IRObject> getPrerequisites ()
   {
      return EventDefExt.getPrerequisites (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Contained lookup (String name, boolean inherited, boolean global)
   {
      return ContainerExt.lookup (this, name, inherited, global);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.EVENT_DEF__VALUE_CONTENTS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getValueContents ()).basicAdd (otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.EVENT_DEF__VALUE_CONTENTS:
            return ((InternalEList<?>) getValueContents ()).basicRemove (otherEnd, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.EVENT_DEF__CONTENTS:
            return getContents ();
         case IdlmmPackage.EVENT_DEF__OPERATIONS:
            return getOperations ();
         case IdlmmPackage.EVENT_DEF__ALL_OPERATIONS:
            return getAllOperations ();
         case IdlmmPackage.EVENT_DEF__ATTRIBUTES:
            return getAttributes ();
         case IdlmmPackage.EVENT_DEF__ALL_ATTRIBUTES:
            return getAllAttributes ();
         case IdlmmPackage.EVENT_DEF__CUSTOM:
            return isCustom () ? Boolean.TRUE : Boolean.FALSE;
         case IdlmmPackage.EVENT_DEF__TRUNCATABLE:
            return isTruncatable () ? Boolean.TRUE : Boolean.FALSE;
         case IdlmmPackage.EVENT_DEF__BASE_VALUES:
            return getBaseValues ();
         case IdlmmPackage.EVENT_DEF__VALUE_CONTENTS:
            return getValueContents ();
         case IdlmmPackage.EVENT_DEF__SUPPORTED_INTERFACES:
            return getSupportedInterfaces ();
         case IdlmmPackage.EVENT_DEF__MEMBERS:
            return getMembers ();
         case IdlmmPackage.EVENT_DEF__INITIALIZERS:
            return getInitializers ();
         case IdlmmPackage.EVENT_DEF__ALL_CONTENTS:
            return getAllContents ();
         case IdlmmPackage.EVENT_DEF__ALL_BASE_VALUES:
            return getAllBaseValues ();
         case IdlmmPackage.EVENT_DEF__ALL_SUPPORTED_INTERFACES:
            return getAllSupportedInterfaces ();
         case IdlmmPackage.EVENT_DEF__EVENT_CONTENTS:
            return getEventContents ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.EVENT_DEF__CUSTOM:
            setCustom ( ((Boolean) newValue).booleanValue ());
            return;
         case IdlmmPackage.EVENT_DEF__TRUNCATABLE:
            setTruncatable ( ((Boolean) newValue).booleanValue ());
            return;
         case IdlmmPackage.EVENT_DEF__BASE_VALUES:
            getBaseValues ().clear ();
            getBaseValues ().addAll ((Collection<? extends ValueDef>) newValue);
            return;
         case IdlmmPackage.EVENT_DEF__VALUE_CONTENTS:
            getValueContents ().clear ();
            getValueContents ().addAll ((Collection<? extends ValueContained>) newValue);
            return;
         case IdlmmPackage.EVENT_DEF__SUPPORTED_INTERFACES:
            getSupportedInterfaces ().clear ();
            getSupportedInterfaces ().addAll ((Collection<? extends Interface>) newValue);
            return;
         case IdlmmPackage.EVENT_DEF__ALL_SUPPORTED_INTERFACES:
            getAllSupportedInterfaces ().clear ();
            getAllSupportedInterfaces ().addAll ((Collection<? extends Interface>) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.EVENT_DEF__CUSTOM:
            setCustom (CUSTOM_EDEFAULT);
            return;
         case IdlmmPackage.EVENT_DEF__TRUNCATABLE:
            setTruncatable (TRUNCATABLE_EDEFAULT);
            return;
         case IdlmmPackage.EVENT_DEF__BASE_VALUES:
            getBaseValues ().clear ();
            return;
         case IdlmmPackage.EVENT_DEF__VALUE_CONTENTS:
            getValueContents ().clear ();
            return;
         case IdlmmPackage.EVENT_DEF__SUPPORTED_INTERFACES:
            getSupportedInterfaces ().clear ();
            return;
         case IdlmmPackage.EVENT_DEF__ALL_SUPPORTED_INTERFACES:
            getAllSupportedInterfaces ().clear ();
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.EVENT_DEF__CONTENTS:
            return isSetContents ();
         case IdlmmPackage.EVENT_DEF__OPERATIONS:
            return !getOperations ().isEmpty ();
         case IdlmmPackage.EVENT_DEF__ALL_OPERATIONS:
            return !getAllOperations ().isEmpty ();
         case IdlmmPackage.EVENT_DEF__ATTRIBUTES:
            return !getAttributes ().isEmpty ();
         case IdlmmPackage.EVENT_DEF__ALL_ATTRIBUTES:
            return !getAllAttributes ().isEmpty ();
         case IdlmmPackage.EVENT_DEF__CUSTOM:
            return custom != CUSTOM_EDEFAULT;
         case IdlmmPackage.EVENT_DEF__TRUNCATABLE:
            return truncatable != TRUNCATABLE_EDEFAULT;
         case IdlmmPackage.EVENT_DEF__BASE_VALUES:
            return baseValues != null && !baseValues.isEmpty ();
         case IdlmmPackage.EVENT_DEF__VALUE_CONTENTS:
            return valueContents != null && !valueContents.isEmpty ();
         case IdlmmPackage.EVENT_DEF__SUPPORTED_INTERFACES:
            return supportedInterfaces != null && !supportedInterfaces.isEmpty ();
         case IdlmmPackage.EVENT_DEF__MEMBERS:
            return !getMembers ().isEmpty ();
         case IdlmmPackage.EVENT_DEF__INITIALIZERS:
            return !getInitializers ().isEmpty ();
         case IdlmmPackage.EVENT_DEF__ALL_CONTENTS:
            return !getAllContents ().isEmpty ();
         case IdlmmPackage.EVENT_DEF__ALL_BASE_VALUES:
            return !getAllBaseValues ().isEmpty ();
         case IdlmmPackage.EVENT_DEF__ALL_SUPPORTED_INTERFACES:
            return !getAllSupportedInterfaces ().isEmpty ();
         case IdlmmPackage.EVENT_DEF__EVENT_CONTENTS:
            return !getEventContents ().isEmpty ();
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == Container.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EVENT_DEF__CONTENTS:
               return IdlmmPackage.CONTAINER__CONTENTS;
            default:
               return -1;
         }
      }
      if (baseClass == OperationContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EVENT_DEF__OPERATIONS:
               return IdlmmPackage.OPERATION_CONTAINER__OPERATIONS;
            case IdlmmPackage.EVENT_DEF__ALL_OPERATIONS:
               return IdlmmPackage.OPERATION_CONTAINER__ALL_OPERATIONS;
            default:
               return -1;
         }
      }
      if (baseClass == AttributeContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EVENT_DEF__ATTRIBUTES:
               return IdlmmPackage.ATTRIBUTE_CONTAINER__ATTRIBUTES;
            case IdlmmPackage.EVENT_DEF__ALL_ATTRIBUTES:
               return IdlmmPackage.ATTRIBUTE_CONTAINER__ALL_ATTRIBUTES;
            default:
               return -1;
         }
      }
      if (baseClass == ValueDef.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.EVENT_DEF__CUSTOM:
               return IdlmmPackage.VALUE_DEF__CUSTOM;
            case IdlmmPackage.EVENT_DEF__TRUNCATABLE:
               return IdlmmPackage.VALUE_DEF__TRUNCATABLE;
            case IdlmmPackage.EVENT_DEF__BASE_VALUES:
               return IdlmmPackage.VALUE_DEF__BASE_VALUES;
            case IdlmmPackage.EVENT_DEF__VALUE_CONTENTS:
               return IdlmmPackage.VALUE_DEF__VALUE_CONTENTS;
            case IdlmmPackage.EVENT_DEF__SUPPORTED_INTERFACES:
               return IdlmmPackage.VALUE_DEF__SUPPORTED_INTERFACES;
            case IdlmmPackage.EVENT_DEF__MEMBERS:
               return IdlmmPackage.VALUE_DEF__MEMBERS;
            case IdlmmPackage.EVENT_DEF__INITIALIZERS:
               return IdlmmPackage.VALUE_DEF__INITIALIZERS;
            case IdlmmPackage.EVENT_DEF__ALL_CONTENTS:
               return IdlmmPackage.VALUE_DEF__ALL_CONTENTS;
            case IdlmmPackage.EVENT_DEF__ALL_BASE_VALUES:
               return IdlmmPackage.VALUE_DEF__ALL_BASE_VALUES;
            case IdlmmPackage.EVENT_DEF__ALL_SUPPORTED_INTERFACES:
               return IdlmmPackage.VALUE_DEF__ALL_SUPPORTED_INTERFACES;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == Container.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINER__CONTENTS:
               return IdlmmPackage.EVENT_DEF__CONTENTS;
            default:
               return -1;
         }
      }
      if (baseClass == OperationContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.OPERATION_CONTAINER__OPERATIONS:
               return IdlmmPackage.EVENT_DEF__OPERATIONS;
            case IdlmmPackage.OPERATION_CONTAINER__ALL_OPERATIONS:
               return IdlmmPackage.EVENT_DEF__ALL_OPERATIONS;
            default:
               return -1;
         }
      }
      if (baseClass == AttributeContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ATTRIBUTE_CONTAINER__ATTRIBUTES:
               return IdlmmPackage.EVENT_DEF__ATTRIBUTES;
            case IdlmmPackage.ATTRIBUTE_CONTAINER__ALL_ATTRIBUTES:
               return IdlmmPackage.EVENT_DEF__ALL_ATTRIBUTES;
            default:
               return -1;
         }
      }
      if (baseClass == ValueDef.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.VALUE_DEF__CUSTOM:
               return IdlmmPackage.EVENT_DEF__CUSTOM;
            case IdlmmPackage.VALUE_DEF__TRUNCATABLE:
               return IdlmmPackage.EVENT_DEF__TRUNCATABLE;
            case IdlmmPackage.VALUE_DEF__BASE_VALUES:
               return IdlmmPackage.EVENT_DEF__BASE_VALUES;
            case IdlmmPackage.VALUE_DEF__VALUE_CONTENTS:
               return IdlmmPackage.EVENT_DEF__VALUE_CONTENTS;
            case IdlmmPackage.VALUE_DEF__SUPPORTED_INTERFACES:
               return IdlmmPackage.EVENT_DEF__SUPPORTED_INTERFACES;
            case IdlmmPackage.VALUE_DEF__MEMBERS:
               return IdlmmPackage.EVENT_DEF__MEMBERS;
            case IdlmmPackage.VALUE_DEF__INITIALIZERS:
               return IdlmmPackage.EVENT_DEF__INITIALIZERS;
            case IdlmmPackage.VALUE_DEF__ALL_CONTENTS:
               return IdlmmPackage.EVENT_DEF__ALL_CONTENTS;
            case IdlmmPackage.VALUE_DEF__ALL_BASE_VALUES:
               return IdlmmPackage.EVENT_DEF__ALL_BASE_VALUES;
            case IdlmmPackage.VALUE_DEF__ALL_SUPPORTED_INTERFACES:
               return IdlmmPackage.EVENT_DEF__ALL_SUPPORTED_INTERFACES;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String toString ()
   {
      if (eIsProxy ())
         return super.toString ();

      StringBuffer result = new StringBuffer (super.toString ());
      result.append (" (custom: ");
      result.append (custom);
      result.append (", truncatable: ");
      result.append (truncatable);
      result.append (')');
      return result.toString ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContents ()
   {
      return eIsSet (IdlmmPackage.EVENT_DEF__VALUE_CONTENTS);
   }

} //EventDefImpl
