/**
 * <copyright>
 * </copyright>
 *
 * $Id: RepositoryImpl.java,v 1.39 2008/02/19 20:46:36 dpalmer Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.AliasDef;
import com.prismtech.idt.idlmm.ArrayDef;
import com.prismtech.idt.idlmm.ConstantDef;
import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.ExceptionDef;
import com.prismtech.idt.idlmm.FixedDef;
import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.ModuleDef;
import com.prismtech.idt.idlmm.NativeDef;
import com.prismtech.idt.idlmm.Pragma;
import com.prismtech.idt.idlmm.PrimitiveDef;
import com.prismtech.idt.idlmm.PrimitiveKind;
import com.prismtech.idt.idlmm.Repository;
import com.prismtech.idt.idlmm.RepositoryContained;
import com.prismtech.idt.idlmm.SequenceDef;
import com.prismtech.idt.idlmm.StringDef;
import com.prismtech.idt.idlmm.StructDef;
import com.prismtech.idt.idlmm.UnionDef;
import com.prismtech.idt.idlmm.ValueBoxDef;
import com.prismtech.idt.idlmm.ValueDef;
import com.prismtech.idt.idlmm.WStringDef;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.uml2.common.util.DerivedUnionEObjectEList;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Repository</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getContents <em>Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getRepositoryContents <em>Repository Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getIncludes <em>Includes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getEnums <em>Enums</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getAliases <em>Aliases</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getConstants <em>Constants</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getExceptions <em>Exceptions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getInterfaces <em>Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getModules <em>Modules</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getNatives <em>Natives</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getStructs <em>Structs</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getUnions <em>Unions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.RepositoryImpl#getValueTypes <em>Value Types</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RepositoryImpl extends ContainerImpl implements Repository
{
   /**
    * The cached value of the '{@link #getRepositoryContents() <em>Repository Contents</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getRepositoryContents()
    * @generated
    * @ordered
    */
   protected EList<RepositoryContained> repositoryContents;

   /**
    * The cached value of the '{@link #getIncludes() <em>Includes</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getIncludes()
    * @generated
    * @ordered
    */
   protected EList<Repository> includes;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected RepositoryImpl ()
   {
      super ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.REPOSITORY;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<Contained> getContents ()
   {
      return new DerivedUnionEObjectEList<Contained> (Contained.class, this, IdlmmPackage.REPOSITORY__CONTENTS, CONTENTS_ESUBSETS);
   }

   /**
    * The array of subset feature identifiers for the '{@link #getContents() <em>Contents</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getContents()
    * @generated
    * @ordered
    */
   protected static final int[] CONTENTS_ESUBSETS = new int[]
   {
      IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS
   };

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<RepositoryContained> getRepositoryContents ()
   {
      if (repositoryContents == null)
      {
         repositoryContents = new EObjectContainmentWithInverseEList<RepositoryContained> (RepositoryContained.class, this,
               IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS, IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY);
      }
      return repositoryContents;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<Repository> getIncludes ()
   {
      if (includes == null)
      {
         includes = new EObjectResolvingEList<Repository> (Repository.class, this, IdlmmPackage.REPOSITORY__INCLUDES);
      }
      return includes;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public PrimitiveDef createPrimitive (PrimitiveKind kind)
   {
      return RepositoryExt.createPrimitive (this, kind);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public StringDef createString (int bound)
   {
      return RepositoryExt.createString (this, bound);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public WStringDef createWString (int bound)
   {
      return RepositoryExt.createWString (this, bound);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public SequenceDef createSequence (int bound, IDLType elementType)
   {
      return RepositoryExt.createSequence (this, bound, elementType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ArrayDef createArray (int length, IDLType elementType)
   {
      return RepositoryExt.createArray (this, length, elementType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public FixedDef createFixed (int digits, int scale)
   {
      return RepositoryExt.createFixed (this, digits, scale);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AliasDef> getAliases ()
   {
      return RepositoryExt.getAliases (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ConstantDef> getConstants ()
   {
      return RepositoryExt.getConstants (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EnumDef> getEnums ()
   {
      return RepositoryExt.getEnums (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ExceptionDef> getExceptions ()
   {
      return RepositoryExt.getExceptions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<InterfaceDef> getInterfaces ()
   {
      return RepositoryExt.getInterfaces (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ModuleDef> getModules ()
   {
      return RepositoryExt.getModules (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<NativeDef> getNatives ()
   {
      return RepositoryExt.getNatives (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<StructDef> getStructs ()
   {
      return RepositoryExt.getStructs (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UnionDef> getUnions ()
   {
      return RepositoryExt.getUnions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<ValueBoxDef> getValueBoxes ()
   {
      return RepositoryExt.getValueBoxes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ValueDef> getValueTypes ()
   {
      return RepositoryExt.getValueTypes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<Repository> getAllIncludes (boolean inclusive)
   {
      return RepositoryExt.getAllIncludes (this, inclusive);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getRepositoryContents ()).basicAdd (otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS:
            return ((InternalEList<?>) getRepositoryContents ()).basicRemove (otherEnd, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS:
            return getRepositoryContents ();
         case IdlmmPackage.REPOSITORY__INCLUDES:
            return getIncludes ();
         case IdlmmPackage.REPOSITORY__ENUMS:
            return getEnums ();
         case IdlmmPackage.REPOSITORY__ALIASES:
            return getAliases ();
         case IdlmmPackage.REPOSITORY__CONSTANTS:
            return getConstants ();
         case IdlmmPackage.REPOSITORY__EXCEPTIONS:
            return getExceptions ();
         case IdlmmPackage.REPOSITORY__INTERFACES:
            return getInterfaces ();
         case IdlmmPackage.REPOSITORY__MODULES:
            return getModules ();
         case IdlmmPackage.REPOSITORY__NATIVES:
            return getNatives ();
         case IdlmmPackage.REPOSITORY__STRUCTS:
            return getStructs ();
         case IdlmmPackage.REPOSITORY__UNIONS:
            return getUnions ();
         case IdlmmPackage.REPOSITORY__VALUE_TYPES:
            return getValueTypes ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS:
            getRepositoryContents ().clear ();
            getRepositoryContents ().addAll ((Collection<? extends RepositoryContained>) newValue);
            return;
         case IdlmmPackage.REPOSITORY__INCLUDES:
            getIncludes ().clear ();
            getIncludes ().addAll ((Collection<? extends Repository>) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS:
            getRepositoryContents ().clear ();
            return;
         case IdlmmPackage.REPOSITORY__INCLUDES:
            getIncludes ().clear ();
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS:
            return repositoryContents != null && !repositoryContents.isEmpty ();
         case IdlmmPackage.REPOSITORY__INCLUDES:
            return includes != null && !includes.isEmpty ();
         case IdlmmPackage.REPOSITORY__ENUMS:
            return !getEnums ().isEmpty ();
         case IdlmmPackage.REPOSITORY__ALIASES:
            return !getAliases ().isEmpty ();
         case IdlmmPackage.REPOSITORY__CONSTANTS:
            return !getConstants ().isEmpty ();
         case IdlmmPackage.REPOSITORY__EXCEPTIONS:
            return !getExceptions ().isEmpty ();
         case IdlmmPackage.REPOSITORY__INTERFACES:
            return !getInterfaces ().isEmpty ();
         case IdlmmPackage.REPOSITORY__MODULES:
            return !getModules ().isEmpty ();
         case IdlmmPackage.REPOSITORY__NATIVES:
            return !getNatives ().isEmpty ();
         case IdlmmPackage.REPOSITORY__STRUCTS:
            return !getStructs ().isEmpty ();
         case IdlmmPackage.REPOSITORY__UNIONS:
            return !getUnions ().isEmpty ();
         case IdlmmPackage.REPOSITORY__VALUE_TYPES:
            return !getValueTypes ().isEmpty ();
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean isSetContents ()
   {
      return super.isSetContents () || eIsSet (IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS);
   }

} //RepositoryImpl
