/**
 * <copyright> </copyright>
 * 
 * $Id: ValueDefImpl.java,v 1.22 2008/08/22 11:55:34 je Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.AttributeContainer;
import com.prismtech.idt.idlmm.AttributeDef;
import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.Initializer;
import com.prismtech.idt.idlmm.Interface;
import com.prismtech.idt.idlmm.ModuleContained;
import com.prismtech.idt.idlmm.ModuleDef;
import com.prismtech.idt.idlmm.Named;
import com.prismtech.idt.idlmm.OperationContainer;
import com.prismtech.idt.idlmm.OperationDef;
import com.prismtech.idt.idlmm.Repository;
import com.prismtech.idt.idlmm.RepositoryContained;
import com.prismtech.idt.idlmm.SharedIDLType;
import com.prismtech.idt.idlmm.Value;
import com.prismtech.idt.idlmm.ValueContained;
import com.prismtech.idt.idlmm.ValueDef;

import com.prismtech.idt.idlmm.ValueMemberDef;
import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.uml2.common.util.DerivedUnionEObjectEList;


/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Value Def</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getKey <em>Key</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getContainer <em>Container</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getAbsoluteName <em>Absolute Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getPrefix <em>Prefix</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getID <em>ID</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getVersion <em>Version</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getContainingModule <em>Containing Module</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getContainingRepository <em>Containing Repository</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#isAbstract <em>Abstract</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getOperations <em>Operations</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getAllOperations <em>All Operations</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getAllAttributes <em>All Attributes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getContents <em>Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#isCustom <em>Custom</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#isTruncatable <em>Truncatable</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getBaseValues <em>Base Values</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getValueContents <em>Value Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getSupportedInterfaces <em>Supported Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getMembers <em>Members</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getInitializers <em>Initializers</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getAllContents <em>All Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getAllBaseValues <em>All Base Values</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.ValueDefImpl#getAllSupportedInterfaces <em>All Supported Interfaces</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ValueDefImpl extends ContainerImpl implements ValueDef
{
   /**
    * The default value of the '{@link #getName() <em>Name</em>}' attribute.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #getName()
    * @generated
    * @ordered
    */
   protected static final String NAME_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #getName()
    * @generated
    * @ordered
    */
   protected String name = NAME_EDEFAULT;

   /**
    * The default value of the '{@link #getKey() <em>Key</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getKey()
    * @generated
    * @ordered
    */
   protected static final String KEY_EDEFAULT = null;

   /**
    * The default value of the '{@link #getAbsoluteName() <em>Absolute Name</em>}' attribute.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #getAbsoluteName()
    * @generated
    * @ordered
    */
   protected static final String ABSOLUTE_NAME_EDEFAULT = null;

   /**
    * The default value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected static final String PREFIX_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected String prefix = PREFIX_EDEFAULT;

   /**
    * The default value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected static final String ID_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected String id = ID_EDEFAULT;

   /**
    * The default value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected static final String VERSION_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected String version = VERSION_EDEFAULT;

   /**
    * The default value of the '{@link #isAbstract() <em>Abstract</em>}' attribute.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #isAbstract()
    * @generated
    * @ordered
    */
   protected static final boolean ABSTRACT_EDEFAULT = false;

   /**
    * The cached value of the '{@link #isAbstract() <em>Abstract</em>}' attribute.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #isAbstract()
    * @generated
    * @ordered
    */
   protected boolean abstract_ = ABSTRACT_EDEFAULT;

   /**
    * The default value of the '{@link #isCustom() <em>Custom</em>}' attribute.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #isCustom()
    * @generated
    * @ordered
    */
   protected static final boolean CUSTOM_EDEFAULT = false;

   /**
    * The cached value of the '{@link #isCustom() <em>Custom</em>}' attribute.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #isCustom()
    * @generated
    * @ordered
    */
   protected boolean custom = CUSTOM_EDEFAULT;

   /**
    * The default value of the '{@link #isTruncatable() <em>Truncatable</em>}' attribute.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #isTruncatable()
    * @generated
    * @ordered
    */
   protected static final boolean TRUNCATABLE_EDEFAULT = false;

   /**
    * The cached value of the '{@link #isTruncatable() <em>Truncatable</em>}' attribute.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #isTruncatable()
    * @generated
    * @ordered
    */
   protected boolean truncatable = TRUNCATABLE_EDEFAULT;

   /**
    * The cached value of the '{@link #getBaseValues() <em>Base Values</em>}' reference list.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #getBaseValues()
    * @generated
    * @ordered
    */
   protected EList<ValueDef> baseValues;

   /**
    * The cached value of the '{@link #getValueContents() <em>Value Contents</em>}' containment reference list.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #getValueContents()
    * @generated
    * @ordered
    */
   protected EList<ValueContained> valueContents;

   /**
    * The cached value of the '{@link #getSupportedInterfaces() <em>Supported Interfaces</em>}' reference list.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #getSupportedInterfaces()
    * @generated
    * @ordered
    */
   protected EList<Interface> supportedInterfaces;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   protected ValueDefImpl ()
   {
      super ();
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.VALUE_DEF;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public String getName ()
   {
      return name;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public void setName (String newName)
   {
      String oldName = name;
      name = newName;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.VALUE_DEF__NAME, oldName, name));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getKey ()
   {
      return NamedExt.getKey (this);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public Container getContainer ()
   {
      Container container = basicGetContainer ();
      return container != null && container.eIsProxy () ? (Container) eResolveProxy ((InternalEObject) container) : container;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public Container basicGetContainer ()
   {
      ModuleDef containingModule = getContainingModule ();
      if (containingModule != null)
      {
         return containingModule;
      }
      Repository containingRepository = getContainingRepository ();
      if (containingRepository != null)
      {
         return containingRepository;
      }
      return null;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated NOT
    */
   public void setContainer (Container newContainer)
   {
      ContainedExt.setContainer (this, newContainer);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated NOT
    */
   public String getAbsoluteName ()
   {
      return ContainedExt.getAbsoluteName (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getPrefix ()
   {
      return prefix;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setPrefix (String newPrefix)
   {
      String oldPrefix = prefix;
      prefix = newPrefix;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.VALUE_DEF__PREFIX, oldPrefix, prefix));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getID ()
   {
      return ContainedExt.getID (this, id);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setID (String newID)
   {
      String oldID = id;
      id = newID;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.VALUE_DEF__ID, oldID, id));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getVersion ()
   {
      return version;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setVersion (String newVersion)
   {
      String oldVersion = version;
      version = newVersion;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.VALUE_DEF__VERSION, oldVersion, version));
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public Repository getContainingRepository ()
   {
      if (eContainerFeatureID != IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY)
         return null;
      return (Repository) eContainer ();
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingRepository (Repository newContainingRepository, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingRepository, IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public void setContainingRepository (Repository newContainingRepository)
   {
      if (newContainingRepository != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY && newContainingRepository != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingRepository))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingRepository != null)
            msgs = ((InternalEObject) newContainingRepository).eInverseAdd (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS,
                  Repository.class, msgs);
         msgs = basicSetContainingRepository (newContainingRepository, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY,
               newContainingRepository, newContainingRepository));
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public ModuleDef getContainingModule ()
   {
      if (eContainerFeatureID != IdlmmPackage.VALUE_DEF__CONTAINING_MODULE)
         return null;
      return (ModuleDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingModule (ModuleDef newContainingModule, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingModule, IdlmmPackage.VALUE_DEF__CONTAINING_MODULE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public void setContainingModule (ModuleDef newContainingModule)
   {
      if (newContainingModule != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.VALUE_DEF__CONTAINING_MODULE && newContainingModule != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingModule))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingModule != null)
            msgs = ((InternalEObject) newContainingModule).eInverseAdd (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS,
                  ModuleDef.class, msgs);
         msgs = basicSetContainingModule (newContainingModule, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.VALUE_DEF__CONTAINING_MODULE, newContainingModule,
               newContainingModule));
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public boolean isAbstract ()
   {
      return abstract_;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public void setAbstract (boolean newAbstract)
   {
      boolean oldAbstract = abstract_;
      abstract_ = newAbstract;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.VALUE_DEF__ABSTRACT, oldAbstract, abstract_));
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<Contained> getContents ()
   {
      return new DerivedUnionEObjectEList<Contained> (Contained.class, this, IdlmmPackage.VALUE_DEF__CONTENTS, CONTENTS_ESUBSETS);
   }

   /**
    * The array of subset feature identifiers for the '{@link #getContents() <em>Contents</em>}' reference list.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #getContents()
    * @generated
    * @ordered
    */
   protected static final int[] CONTENTS_ESUBSETS = new int[]
   {
      IdlmmPackage.VALUE_DEF__VALUE_CONTENTS
   };

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public boolean isCustom ()
   {
      return custom;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public void setCustom (boolean newCustom)
   {
      boolean oldCustom = custom;
      custom = newCustom;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.VALUE_DEF__CUSTOM, oldCustom, custom));
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public boolean isTruncatable ()
   {
      return truncatable;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public void setTruncatable (boolean newTruncatable)
   {
      boolean oldTruncatable = truncatable;
      truncatable = newTruncatable;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.VALUE_DEF__TRUNCATABLE, oldTruncatable, truncatable));
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated NOT
    */
   public EList<ValueMemberDef> getMembers ()
   {
      return ValueExt.getMembers (this);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated NOT
    */
   public EList<AttributeDef> getAttributes ()
   {
      return ValueExt.getAttributes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AttributeDef> getAllAttributes ()
   {
      return ValueExt.getAllAttributes (this);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated NOT
    */
   public EList<OperationDef> getOperations ()
   {
      return ValueExt.getOperations (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<OperationDef> getAllOperations ()
   {
      return ValueExt.getAllOperations (this);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated NOT
    */
   public EList<Initializer> getInitializers ()
   {
      return ValueExt.getInitializers (this);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<Contained> getAllContents ()
   {
      return ValueExt.getAllContents (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ValueDef> getAllBaseValues ()
   {
      return ValueExt.getAllBaseValues (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<Interface> getAllSupportedInterfaces ()
   {
      return ValueExt.getAllSupportedInterfaces (this);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated NOT
    */
   public EList<IRObject> getPrerequisites ()
   {
      return ValueExt.getPrerequisites (this);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EList<ValueDef> getBaseValues ()
   {
      if (baseValues == null)
      {
         baseValues = new EObjectResolvingEList<ValueDef> (ValueDef.class, this, IdlmmPackage.VALUE_DEF__BASE_VALUES);
      }
      return baseValues;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EList<ValueContained> getValueContents ()
   {
      if (valueContents == null)
      {
         valueContents = new EObjectContainmentWithInverseEList<ValueContained> (ValueContained.class, this,
               IdlmmPackage.VALUE_DEF__VALUE_CONTENTS, IdlmmPackage.VALUE_CONTAINED__CONTAINING_VALUE);
      }
      return valueContents;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EList<Interface> getSupportedInterfaces ()
   {
      if (supportedInterfaces == null)
      {
         supportedInterfaces = new EObjectResolvingEList<Interface> (Interface.class, this,
               IdlmmPackage.VALUE_DEF__SUPPORTED_INTERFACES);
      }
      return supportedInterfaces;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.VALUE_DEF__CONTAINING_MODULE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingModule ((ModuleDef) otherEnd, msgs);
         case IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingRepository ((Repository) otherEnd, msgs);
         case IdlmmPackage.VALUE_DEF__VALUE_CONTENTS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getValueContents ()).basicAdd (otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.VALUE_DEF__CONTAINING_MODULE:
            return basicSetContainingModule (null, msgs);
         case IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY:
            return basicSetContainingRepository (null, msgs);
         case IdlmmPackage.VALUE_DEF__VALUE_CONTENTS:
            return ((InternalEList<?>) getValueContents ()).basicRemove (otherEnd, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature (NotificationChain msgs)
   {
      switch (eContainerFeatureID)
      {
         case IdlmmPackage.VALUE_DEF__CONTAINING_MODULE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS, ModuleDef.class, msgs);
         case IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY:
            return eInternalContainer ()
                  .eInverseRemove (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS, Repository.class, msgs);
      }
      return super.eBasicRemoveFromContainerFeature (msgs);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.VALUE_DEF__NAME:
            return getName ();
         case IdlmmPackage.VALUE_DEF__KEY:
            return getKey ();
         case IdlmmPackage.VALUE_DEF__CONTAINER:
            if (resolve)
               return getContainer ();
            return basicGetContainer ();
         case IdlmmPackage.VALUE_DEF__ABSOLUTE_NAME:
            return getAbsoluteName ();
         case IdlmmPackage.VALUE_DEF__PREFIX:
            return getPrefix ();
         case IdlmmPackage.VALUE_DEF__ID:
            return getID ();
         case IdlmmPackage.VALUE_DEF__VERSION:
            return getVersion ();
         case IdlmmPackage.VALUE_DEF__CONTAINING_MODULE:
            return getContainingModule ();
         case IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY:
            return getContainingRepository ();
         case IdlmmPackage.VALUE_DEF__ABSTRACT:
            return isAbstract () ? Boolean.TRUE : Boolean.FALSE;
         case IdlmmPackage.VALUE_DEF__OPERATIONS:
            return getOperations ();
         case IdlmmPackage.VALUE_DEF__ALL_OPERATIONS:
            return getAllOperations ();
         case IdlmmPackage.VALUE_DEF__ATTRIBUTES:
            return getAttributes ();
         case IdlmmPackage.VALUE_DEF__ALL_ATTRIBUTES:
            return getAllAttributes ();
         case IdlmmPackage.VALUE_DEF__CUSTOM:
            return isCustom () ? Boolean.TRUE : Boolean.FALSE;
         case IdlmmPackage.VALUE_DEF__TRUNCATABLE:
            return isTruncatable () ? Boolean.TRUE : Boolean.FALSE;
         case IdlmmPackage.VALUE_DEF__BASE_VALUES:
            return getBaseValues ();
         case IdlmmPackage.VALUE_DEF__VALUE_CONTENTS:
            return getValueContents ();
         case IdlmmPackage.VALUE_DEF__SUPPORTED_INTERFACES:
            return getSupportedInterfaces ();
         case IdlmmPackage.VALUE_DEF__MEMBERS:
            return getMembers ();
         case IdlmmPackage.VALUE_DEF__INITIALIZERS:
            return getInitializers ();
         case IdlmmPackage.VALUE_DEF__ALL_CONTENTS:
            return getAllContents ();
         case IdlmmPackage.VALUE_DEF__ALL_BASE_VALUES:
            return getAllBaseValues ();
         case IdlmmPackage.VALUE_DEF__ALL_SUPPORTED_INTERFACES:
            return getAllSupportedInterfaces ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.VALUE_DEF__NAME:
            setName ((String) newValue);
            return;
         case IdlmmPackage.VALUE_DEF__CONTAINER:
            setContainer ((Container) newValue);
            return;
         case IdlmmPackage.VALUE_DEF__PREFIX:
            setPrefix ((String) newValue);
            return;
         case IdlmmPackage.VALUE_DEF__ID:
            setID ((String) newValue);
            return;
         case IdlmmPackage.VALUE_DEF__VERSION:
            setVersion ((String) newValue);
            return;
         case IdlmmPackage.VALUE_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) newValue);
            return;
         case IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) newValue);
            return;
         case IdlmmPackage.VALUE_DEF__ABSTRACT:
            setAbstract ( ((Boolean) newValue).booleanValue ());
            return;
         case IdlmmPackage.VALUE_DEF__CUSTOM:
            setCustom ( ((Boolean) newValue).booleanValue ());
            return;
         case IdlmmPackage.VALUE_DEF__TRUNCATABLE:
            setTruncatable ( ((Boolean) newValue).booleanValue ());
            return;
         case IdlmmPackage.VALUE_DEF__BASE_VALUES:
            getBaseValues ().clear ();
            getBaseValues ().addAll ((Collection<? extends ValueDef>) newValue);
            return;
         case IdlmmPackage.VALUE_DEF__VALUE_CONTENTS:
            getValueContents ().clear ();
            getValueContents ().addAll ((Collection<? extends ValueContained>) newValue);
            return;
         case IdlmmPackage.VALUE_DEF__SUPPORTED_INTERFACES:
            getSupportedInterfaces ().clear ();
            getSupportedInterfaces ().addAll ((Collection<? extends Interface>) newValue);
            return;
         case IdlmmPackage.VALUE_DEF__ALL_SUPPORTED_INTERFACES:
            getAllSupportedInterfaces ().clear ();
            getAllSupportedInterfaces ().addAll ((Collection<? extends Interface>) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.VALUE_DEF__NAME:
            setName (NAME_EDEFAULT);
            return;
         case IdlmmPackage.VALUE_DEF__CONTAINER:
            setContainer ((Container) null);
            return;
         case IdlmmPackage.VALUE_DEF__PREFIX:
            setPrefix (PREFIX_EDEFAULT);
            return;
         case IdlmmPackage.VALUE_DEF__ID:
            setID (ID_EDEFAULT);
            return;
         case IdlmmPackage.VALUE_DEF__VERSION:
            setVersion (VERSION_EDEFAULT);
            return;
         case IdlmmPackage.VALUE_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) null);
            return;
         case IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) null);
            return;
         case IdlmmPackage.VALUE_DEF__ABSTRACT:
            setAbstract (ABSTRACT_EDEFAULT);
            return;
         case IdlmmPackage.VALUE_DEF__CUSTOM:
            setCustom (CUSTOM_EDEFAULT);
            return;
         case IdlmmPackage.VALUE_DEF__TRUNCATABLE:
            setTruncatable (TRUNCATABLE_EDEFAULT);
            return;
         case IdlmmPackage.VALUE_DEF__BASE_VALUES:
            getBaseValues ().clear ();
            return;
         case IdlmmPackage.VALUE_DEF__VALUE_CONTENTS:
            getValueContents ().clear ();
            return;
         case IdlmmPackage.VALUE_DEF__SUPPORTED_INTERFACES:
            getSupportedInterfaces ().clear ();
            return;
         case IdlmmPackage.VALUE_DEF__ALL_SUPPORTED_INTERFACES:
            getAllSupportedInterfaces ().clear ();
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.VALUE_DEF__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals (name);
         case IdlmmPackage.VALUE_DEF__KEY:
            return KEY_EDEFAULT == null ? getKey () != null : !KEY_EDEFAULT.equals (getKey ());
         case IdlmmPackage.VALUE_DEF__CONTAINER:
            return isSetContainer ();
         case IdlmmPackage.VALUE_DEF__ABSOLUTE_NAME:
            return ABSOLUTE_NAME_EDEFAULT == null ? getAbsoluteName () != null : !ABSOLUTE_NAME_EDEFAULT
                  .equals (getAbsoluteName ());
         case IdlmmPackage.VALUE_DEF__PREFIX:
            return PREFIX_EDEFAULT == null ? prefix != null : !PREFIX_EDEFAULT.equals (prefix);
         case IdlmmPackage.VALUE_DEF__ID:
            return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals (id);
         case IdlmmPackage.VALUE_DEF__VERSION:
            return VERSION_EDEFAULT == null ? version != null : !VERSION_EDEFAULT.equals (version);
         case IdlmmPackage.VALUE_DEF__CONTAINING_MODULE:
            return getContainingModule () != null;
         case IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY:
            return getContainingRepository () != null;
         case IdlmmPackage.VALUE_DEF__ABSTRACT:
            return abstract_ != ABSTRACT_EDEFAULT;
         case IdlmmPackage.VALUE_DEF__OPERATIONS:
            return !getOperations ().isEmpty ();
         case IdlmmPackage.VALUE_DEF__ALL_OPERATIONS:
            return !getAllOperations ().isEmpty ();
         case IdlmmPackage.VALUE_DEF__ATTRIBUTES:
            return !getAttributes ().isEmpty ();
         case IdlmmPackage.VALUE_DEF__ALL_ATTRIBUTES:
            return !getAllAttributes ().isEmpty ();
         case IdlmmPackage.VALUE_DEF__CUSTOM:
            return custom != CUSTOM_EDEFAULT;
         case IdlmmPackage.VALUE_DEF__TRUNCATABLE:
            return truncatable != TRUNCATABLE_EDEFAULT;
         case IdlmmPackage.VALUE_DEF__BASE_VALUES:
            return baseValues != null && !baseValues.isEmpty ();
         case IdlmmPackage.VALUE_DEF__VALUE_CONTENTS:
            return valueContents != null && !valueContents.isEmpty ();
         case IdlmmPackage.VALUE_DEF__SUPPORTED_INTERFACES:
            return supportedInterfaces != null && !supportedInterfaces.isEmpty ();
         case IdlmmPackage.VALUE_DEF__MEMBERS:
            return !getMembers ().isEmpty ();
         case IdlmmPackage.VALUE_DEF__INITIALIZERS:
            return !getInitializers ().isEmpty ();
         case IdlmmPackage.VALUE_DEF__ALL_CONTENTS:
            return !getAllContents ().isEmpty ();
         case IdlmmPackage.VALUE_DEF__ALL_BASE_VALUES:
            return !getAllBaseValues ().isEmpty ();
         case IdlmmPackage.VALUE_DEF__ALL_SUPPORTED_INTERFACES:
            return !getAllSupportedInterfaces ().isEmpty ();
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == Named.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.VALUE_DEF__NAME:
               return IdlmmPackage.NAMED__NAME;
            case IdlmmPackage.VALUE_DEF__KEY:
               return IdlmmPackage.NAMED__KEY;
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.VALUE_DEF__ABSOLUTE_NAME:
               return IdlmmPackage.CONTAINED__ABSOLUTE_NAME;
            case IdlmmPackage.VALUE_DEF__PREFIX:
               return IdlmmPackage.CONTAINED__PREFIX;
            case IdlmmPackage.VALUE_DEF__ID:
               return IdlmmPackage.CONTAINED__ID;
            case IdlmmPackage.VALUE_DEF__VERSION:
               return IdlmmPackage.CONTAINED__VERSION;
            case IdlmmPackage.VALUE_DEF__CONTAINER:
               return IdlmmPackage.CONTAINED__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.VALUE_DEF__CONTAINING_MODULE:
               return IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == RepositoryContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY:
               return IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == IDLType.class)
      {
         switch (derivedFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == SharedIDLType.class)
      {
         switch (derivedFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == Value.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.VALUE_DEF__ABSTRACT:
               return IdlmmPackage.VALUE__ABSTRACT;
            default:
               return -1;
         }
      }
      if (baseClass == OperationContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.VALUE_DEF__OPERATIONS:
               return IdlmmPackage.OPERATION_CONTAINER__OPERATIONS;
            case IdlmmPackage.VALUE_DEF__ALL_OPERATIONS:
               return IdlmmPackage.OPERATION_CONTAINER__ALL_OPERATIONS;
            default:
               return -1;
         }
      }
      if (baseClass == AttributeContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.VALUE_DEF__ATTRIBUTES:
               return IdlmmPackage.ATTRIBUTE_CONTAINER__ATTRIBUTES;
            case IdlmmPackage.VALUE_DEF__ALL_ATTRIBUTES:
               return IdlmmPackage.ATTRIBUTE_CONTAINER__ALL_ATTRIBUTES;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == Named.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.NAMED__NAME:
               return IdlmmPackage.VALUE_DEF__NAME;
            case IdlmmPackage.NAMED__KEY:
               return IdlmmPackage.VALUE_DEF__KEY;
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINED__ABSOLUTE_NAME:
               return IdlmmPackage.VALUE_DEF__ABSOLUTE_NAME;
            case IdlmmPackage.CONTAINED__PREFIX:
               return IdlmmPackage.VALUE_DEF__PREFIX;
            case IdlmmPackage.CONTAINED__ID:
               return IdlmmPackage.VALUE_DEF__ID;
            case IdlmmPackage.CONTAINED__VERSION:
               return IdlmmPackage.VALUE_DEF__VERSION;
            case IdlmmPackage.CONTAINED__CONTAINER:
               return IdlmmPackage.VALUE_DEF__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE:
               return IdlmmPackage.VALUE_DEF__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == RepositoryContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY:
               return IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == IDLType.class)
      {
         switch (baseFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == SharedIDLType.class)
      {
         switch (baseFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == Value.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.VALUE__ABSTRACT:
               return IdlmmPackage.VALUE_DEF__ABSTRACT;
            default:
               return -1;
         }
      }
      if (baseClass == OperationContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.OPERATION_CONTAINER__OPERATIONS:
               return IdlmmPackage.VALUE_DEF__OPERATIONS;
            case IdlmmPackage.OPERATION_CONTAINER__ALL_OPERATIONS:
               return IdlmmPackage.VALUE_DEF__ALL_OPERATIONS;
            default:
               return -1;
         }
      }
      if (baseClass == AttributeContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ATTRIBUTE_CONTAINER__ATTRIBUTES:
               return IdlmmPackage.VALUE_DEF__ATTRIBUTES;
            case IdlmmPackage.ATTRIBUTE_CONTAINER__ALL_ATTRIBUTES:
               return IdlmmPackage.VALUE_DEF__ALL_ATTRIBUTES;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String toString ()
   {
      if (eIsProxy ())
         return super.toString ();

      StringBuffer result = new StringBuffer (super.toString ());
      result.append (" (name: ");
      result.append (name);
      result.append (", prefix: ");
      result.append (prefix);
      result.append (", ID: ");
      result.append (id);
      result.append (", version: ");
      result.append (version);
      result.append (", abstract: ");
      result.append (abstract_);
      result.append (", custom: ");
      result.append (custom);
      result.append (", truncatable: ");
      result.append (truncatable);
      result.append (')');
      return result.toString ();
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContainer ()
   {
      return eIsSet (IdlmmPackage.VALUE_DEF__CONTAINING_MODULE) || eIsSet (IdlmmPackage.VALUE_DEF__CONTAINING_REPOSITORY);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean isSetContents ()
   {
      return super.isSetContents () || eIsSet (IdlmmPackage.VALUE_DEF__VALUE_CONTENTS);
   }

} // ValueDefImpl
