package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.ConstantDef;
import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IRObject;


public class ConstantDefExt
{
   public static Object getExpressionValue (ConstantDef self)
   {
      Expression exp = self.getValue ();
      if(exp!= null)
      {
         return exp.getExpressionValue ();
      }
      return null;
   }

   public static IDLType getExpressionType (ConstantDef self)
   {
      return self.getType ();
   }

   public static EList<IRObject> getPrerequisites (ConstantDef self)
   {
      EList<IRObject> result = new BasicEList<IRObject> (TypedExt.getPrerequisites (self));
      result.add (self.getValue ());
      result.addAll (self.getValue ().getPrerequisites ());
      return result;
   }
}
