package com.prismtech.idt.idlmm.impl;

import java.util.Set;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.Initializer;
import com.prismtech.idt.idlmm.InitializerParameterDef;


public class InitializerExt
{
   public static EList<IRObject> getPrerequisites (Initializer self)
   {
      Set<IRObject> result = new ArraySet<IRObject> ();
      for (InitializerParameterDef parameter : self.getParameters ())
      {
         result.addAll (parameter.getPrerequisites ());
      }
      result.addAll (self.getExceptions ());
      return new BasicEList<IRObject> (result);
   }
}
