package com.prismtech.idt.idlmm.impl;

import java.math.BigDecimal;
import java.math.BigInteger;

import com.prismtech.idt.idlmm.NegativeOperator;


public class NegativeOperatorExt
{
   public static Object getExpressionValue (NegativeOperator self)
   {
      Object operand = UnaryOperatorExt.getOperand (self);
      if (operand instanceof BigInteger)
      {
         return ((BigInteger) operand).negate ();
      }
      else if (operand instanceof BigDecimal)
      {
         return ((BigDecimal) operand).negate ();
      }
      else
      {
         return null;
      }
   }
}
