package com.prismtech.idt.idlmm.impl;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.UnaryOperator;


public abstract class UnaryOperatorExt
{
   static Object getOperand (UnaryOperator self)
   {
      return (self.getOperand ()).getExpressionValue ();
   }

   public static Expression setOperand (UnaryOperator self, Expression operand)
   {
      self.setOperand (operand);
      return operand;
   }

   public static EList<IRObject> getPrerequisites (UnaryOperator self)
   {
      List<IRObject> result = new ArrayList<IRObject>();
      result.add (self.getOperand ());
      result.addAll (self.getOperand ().getPrerequisites ());
      return new BasicEList<IRObject> (result);
   }
}
