package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.UnionDef;
import com.prismtech.idt.idlmm.UnionMember;


public class UnionMemberExt
{
   public static IDLType getExpressionType (UnionMember self)
   {
      return getUnion (self).getType ();
   }

   /**
    * Implementation of {@link UnionMember#getUnion()}
    */
   public static UnionDef getUnion (UnionMember self)
   {
      Container container = self.getContainer ();

      assert ( (container == null) || (container instanceof UnionDef));

      return (UnionDef) container;
   }

   public static boolean isDefault (UnionMember self)
   {
      return (self.getLabels ().size () == 0);
   }
}
