package com.prismtech.idt.imports.idl.driver;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.emf.validation.model.EvaluationMode;
import org.eclipse.emf.validation.service.IBatchValidator;
import org.eclipse.emf.validation.service.ModelValidationService;

import com.prismtech.idt.idlmm.Repository;


public class EMFValidator implements IValidator
{
   public IStatus validate (Repository repository)
   {
      IBatchValidator validator = (IBatchValidator) ModelValidationService.getInstance ().newValidator (EvaluationMode.BATCH);
      validator.setIncludeLiveConstraints (true);
      return validator.validate (repository);
   }
}
