/***************************************************************************************************
 * - COPYRIGHT NOTICE - * * The information contained herein and which follows is proprietary *
 * information and is the property of PrismTech Corporation. This * information is not to be
 * divulged, released, copied, reproduced, or * conveyed to unauthorized personnel, companies, or
 * other institutions * without the direct and expressed approval in writing of PrismTech *
 * Corporation. * * * - DISCLAIMER - * Neither PrismTech Limited nor PrismTech Corporation
 * ("PrismTech") * are under any obligation to support the use of this code which is * provided
 * without warranty of any kind. PrismTech shall (except as * otherwise prohibited by law) have no
 * liability whatsoever in relation * to its use. * *
 **************************************************************************************************/
package com.prismtech.idt.imports.idl.driver;

import com.prismtech.idt.imports.idl.internal.driver.IdlImportDriver;


/**
 * Factory that enables applications to obtain a new <code>{@link IIdlImportDriver}</code> instance.
 */
public abstract class IdlImportDriverFactory
{
   /**
    * Creates a new instance of a <code>{@link IIdlImportDriver}</code>.
    */
   public static IIdlImportDriver create ()
   {
      return new IdlImportDriver ();
   }
}
