/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */
package com.prismtech.idt.imports.idl.importer;

import org.eclipse.core.runtime.Plugin;
import org.osgi.framework.BundleContext;


/**
 * The activator class controls the plug-in life cycle.
 */
public class IdlImporterPlugin extends Plugin
{

   /**
    * <code>{@link String}</code> PLUGIN_ID
    */
   public static final String PLUGIN_ID = "com.prismtech.idt.imports.idl.importer"; //$NON-NLS-1$

   private static IdlImporterPlugin m_plugin;

   /**
    * Construtor <code>Idl2IdlmmPlugin</code><br/>
    */
   public IdlImporterPlugin ()
   {
      //
   }

   /*
    * (non-Javadoc)
    * 
    * @see org.eclipse.core.runtime.Plugin#start(org.osgi.framework.BundleContext)
    */
   @Override
   public void start (BundleContext context) throws Exception
   {
      super.start (context);
      m_plugin = this;
   }

   /*
    * (non-Javadoc)
    * 
    * @see org.eclipse.core.runtime.Plugin#stop(org.osgi.framework.BundleContext)
    */
   @Override
   public void stop (BundleContext context) throws Exception
   {
      super.stop (context);
      m_plugin = null;
   }

   /**
    * Get the current plugin instance.<br/>
    * 
    * @return <code>{@link IdlImporterPlugin}</code>
    */
   public static IdlImporterPlugin getPlugin ()
   {
      return m_plugin;
   }
}
