/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.runtime.IStatus;


/**
 * @author Yuriy Kravchenko
 */
public class StatusHolder
{
   private final List<IStatus> m_statusList = new ArrayList<IStatus> ();

   public void addStatusItem (IStatus status)
   {
      m_statusList.add (status);
   }

   public List<IStatus> getStatus ()
   {
      return m_statusList;
   }

   public void reset ()
   {
      m_statusList.clear ();
   }

}
