/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */
package com.prismtech.idt.imports.idl.internal.importer.builderutil;

import com.prismtech.idt.idlmm.ValueDef;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;


public class EventPropertiesHolder extends ContainerTypeHolder
{
   public EventPropertiesHolder (String name, boolean isAbstract, boolean isCustom, String sourceValue, IdlParserAST... ast)
   {
      super (name, ContainerType.EVENT, sourceValue, ast);
      this.setCustom (isCustom);
      this.setAbstract (isAbstract);
   }

   private void setCustom (boolean isCustom)
   {
      ((ValueDef) this.getDefinition ()).setCustom (isCustom);
   }
   
   private void setAbstract (boolean isAbstract)
   {
      ((ValueDef) this.getDefinition ()).setAbstract (isAbstract);
   }
}
