/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

/**
 * @author Yuriy Kravchenko
 */

import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.InterfaceModifier;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;


public class InterfaceDefPropertiesHolder extends ContainerTypeHolder
{
   public InterfaceDefPropertiesHolder (String name, InterfaceModifier im, String sourceValue, IdlParserAST... asts)
   {
      super (name, ContainerType.INTERFACE, sourceValue, asts);

      this.setInterfaceModifier (im);
   }

   public InterfaceDefPropertiesHolder (InterfaceDef id, String sourceValue)
   {
      super (id, sourceValue);
   }

   private void setInterfaceModifier (InterfaceModifier im)
   {
      ((InterfaceDef) this.getDefinition ()).setModifier (im);
   }
}
