package com.prismtech.idt.imports.idl.internal.importer.builderutil;

import java.util.HashMap;
import java.util.Map;

import com.prismtech.idt.imports.idl.importer.IIdlPragmaHandler.CreateContext;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.Pragma;


public class PragmaContext implements CreateContext
{
   private Map<Object, Object> dataStore = new HashMap<Object, Object> ();

   private IdlParserAST ast;

   private Container parent;

   private String pragmaText;

   private Pragma pragma;

   public Object getData (Object key)
   {
      return dataStore.get (key);
   }

   public void setData (Object key, Object data)
   {
      dataStore.put (key, data);
   }

   public Container getParent ()
   {
      return parent;
   }

   public void setParent (Container parent)
   {
      this.parent = parent;
   }

   public Pragma getPragma ()
   {
      return pragma;
   }

   public void setPragma (Pragma pragma)
   {
      this.pragma = pragma;
   }

   public String getPragmaText ()
   {
      return pragmaText;
   }

   public void setPragmaText (String pragmaText)
   {
      this.pragmaText = pragmaText;
   }

   public IdlParserAST getAst ()
   {
      return ast;
   }

   public void setAst (IdlParserAST ast)
   {
      this.ast = ast;
   }
}
