package com.prismtech.idt.imports.idl.internal.parser;

import com.prismtech.idt.imports.idl.parser.IIdlParserStatus;

import antlr.RecognitionException;


class IdlRecognitionStatus extends IdlParserStatus
{
   public IdlRecognitionStatus (IdlParser parser, RecognitionException cause)
   {
      super (parser, IIdlParserStatus.ERROR, cause.getMessage (), cause, parser.getIdlLexer ().getInputState ().getFilename (), cause
            .getLine (), cause.getColumn ());
   }
}
