// $ANTLR 2.7.7 (2006-11-01): "IdlParser.g" -> "IdlLexer.java"$

  package com.prismtech.idt.imports.idl.internal.parser;
  
  import java.io.*;
  import java.net.URI;
  import java.util.List;
  import java.util.ArrayList;
  import java.util.Vector;
  import java.util.Hashtable;

import com.prismtech.idt.imports.idl.parser.*;
 
public interface IdlTokenTypes {
 int EOF = 1;
 int NULL_TREE_LOOKAHEAD = 3;
 int SPECIFICATION = 4;
 int SEMI = 5;
 int LITERAL_abstract = 6;
 int LITERAL_local = 7;
 int LITERAL_interface = 8;
 int LITERAL_custom = 9;
 int LITERAL_valuetype = 10;
 int LITERAL_eventtype = 11;
 int LITERAL_module = 12;
 int LCURLY = 13;
 int RCURLY = 14;
 int COLON = 15;
 int COMMA = 16;
 int SCOPEOP = 17;
 int IDENT = 18;
 int ESCAPED_IDENT = 19;
 int LITERAL_truncatable = 20;
 int LITERAL_supports = 21;
 int LITERAL_public = 22;
 int LITERAL_private = 23;
 int LITERAL_factory = 24;
 int LPAREN = 25;
 int RPAREN = 26;
 int LITERAL_in = 27;
 int LITERAL_const = 28;
 int ASSIGN = 29;
 int OR = 30;
 int XOR = 31;
 int AND = 32;
 int LSHIFT = 33;
 int RSHIFT = 34;
 int PLUS = 35;
 int MINUS = 36;
 int STAR = 37;
 int DIV = 38;
 int MOD = 39;
 int TILDE = 40;
 int LITERAL_TRUE = 41;
 int LITERAL_FALSE = 42;
 int LITERAL_typedef = 43;
 int LITERAL_native = 44;
 int LITERAL_float = 45;
 int LITERAL_double = 46;
 int LITERAL_long = 47;
 int LITERAL_short = 48;
 int LITERAL_unsigned = 49;
 int LITERAL_char = 50;
 int LITERAL_wchar = 51;
 int LITERAL_boolean = 52;
 int LITERAL_octet = 53;
 int LITERAL_any = 54;
 int LITERAL_Object = 55;
 int LITERAL_struct = 56;
 int LITERAL_union = 57;
 int LITERAL_switch = 58;
 int LITERAL_case = 59;
 int LITERAL_default = 60;
 int LITERAL_enum = 61;
 int LITERAL_sequence = 62;
 int LT = 63;
 int GT = 64;
 int LITERAL_string = 65;
 int LITERAL_wstring = 66;
 int LBRACK = 67;
 int RBRACK = 68;
 int LITERAL_exception = 69;
 int LITERAL_oneway = 70;
 int LITERAL_void = 71;
 int LITERAL_out = 72;
 int LITERAL_inout = 73;
 int LITERAL_raises = 74;
 int LITERAL_context = 75;
 int LITERAL_fixed = 76;
 int LITERAL_ValueBase = 77;
 int LITERAL_import = 78;
 int LITERAL_typeid = 79;
 int LITERAL_typeprefix = 80;
 int LITERAL_readonly = 81;
 int LITERAL_attribute = 82;
 int LITERAL_getraises = 83;
 int LITERAL_setraises = 84;
 int LITERAL_component = 85;
 int LITERAL_provides = 86;
 int LITERAL_uses = 87;
 int LITERAL_multiple = 88;
 int LITERAL_emits = 89;
 int LITERAL_publishes = 90;
 int LITERAL_consumes = 91;
 int LITERAL_home = 92;
 int LITERAL_manages = 93;
 int LITERAL_primarykey = 94;
 int LITERAL_finder = 95;
 int INT = 96;
 int OCTAL = 97;
 int HEX = 98;
 int STRING_LITERAL = 99;
 int WIDE_STRING_LITERAL = 100;
 int CHAR_LITERAL = 101;
 int WIDE_CHAR_LITERAL = 102;
 int FIXED = 103;
 int FLOAT = 104;
 int PRAGMA = 105;
 int LINEMARKER = 106;
 int QUESTION = 107;
 int DOT = 108;
 int NOT = 109;
 int WS = 110;
 int NL = 111;
 int SHARP = 112;
 int COMMENT = 113;
 int ESC = 114;
 int VOCAB = 115;
 int DIGIT = 116;
 int NONZERODIGIT = 117;
 int OCTDIGIT = 118;
 int HEXDIGIT = 119;
}
