// $ANTLR 2.7.7 (2006-11-01): "ExpLexer.g" -> "ExpParser.java"$

  package com.prismtech.idt.imports.idl.internal.preprocessor;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

  import java.io.*;
  import java.util.*;
  import antlr.*;
  import com.prismtech.idt.imports.idl.preprocessor.IIdlPreprocessor;
  import com.prismtech.idt.imports.idl.preprocessor.IIdlPreprocessorStatus;

public class ExpParser extends antlr.LLkParser       implements ExpLexerTokenTypes
 {

  private List<IIdlPreprocessorStatus> m_status = new ArrayList<IIdlPreprocessorStatus> ();
  CppLexer parent;

  public ExpParser(CppLexer parent, ExpLexer expLexer)
  {
   this(expLexer);
   this.parent = parent;
  }
  
  public IIdlPreprocessorStatus parse()
  {
    try
    {
      orExpr();
      if(LA(1) != EOF)
        m_status.add(new PreprocessorStatus(parent, IIdlPreprocessorStatus.ERROR, "Invalid token " + LA(1), null));
    }
    catch (RecognitionException e)
    {
      m_status.add(new PreprocessorStatus(parent, IIdlPreprocessorStatus.ERROR, e.getMessage(), e));
    }
    catch (TokenStreamException e)
    {
      m_status.add(new PreprocessorStatus(parent, IIdlPreprocessorStatus.ERROR, e.getMessage(), e));
    }

    return getStatus ();
  }

  public IIdlPreprocessorStatus getStatus()
  {
    switch (m_status.size())
    {
      case 0 :
      {
        return new PreprocessorStatus(IIdlPreprocessorStatus.OK);
      }
      case 1 :
      {
        return m_status.get(0);
      }
      default :
      {
        PreprocessorStatus status = new PreprocessorStatus();
        for (IIdlPreprocessorStatus s : m_status)
          status.add (s);
        return status;
      }
    }
  } 
  
  @Override
  public void reportError(RecognitionException recex)
  {
   m_status.add(new PreprocessorStatus(parent, IIdlPreprocessorStatus.ERROR, recex.getMessage(), recex));
  }
  
  @Override
  public void reportError(String message)
  {
   m_status.add(new PreprocessorStatus(parent, IIdlPreprocessorStatus.ERROR, message, null));
  }
  
  @Override
  public void reportWarning(String message)
  {
   m_status.add(new PreprocessorStatus(parent, IIdlPreprocessorStatus.WARNING, message, null));
  } 

protected ExpParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public ExpParser(TokenBuffer tokenBuf) {
  this(tokenBuf,4);
}

protected ExpParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public ExpParser(TokenStream lexer) {
  this(lexer,4);
}

public ExpParser(ParserSharedInputState state) {
  super(state,4);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

 public final void value() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  AST value_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case HEX_INT:
   {
    AST tmp1_AST = null;
    tmp1_AST = astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp1_AST);
    match(HEX_INT);
    value_AST = (AST)currentAST.root;
    break;
   }
   case DEC_INT:
   {
    AST tmp2_AST = null;
    tmp2_AST = astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp2_AST);
    match(DEC_INT);
    value_AST = (AST)currentAST.root;
    break;
   }
   case OCT_INT:
   {
    AST tmp3_AST = null;
    tmp3_AST = astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp3_AST);
    match(OCT_INT);
    value_AST = (AST)currentAST.root;
    break;
   }
   case RAW_IDENTIFIER:
   {
    AST tmp4_AST = null;
    tmp4_AST = astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp4_AST);
    match(RAW_IDENTIFIER);
    value_AST = (AST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   reportError(ex);
   recover(ex,_tokenSet_0);
  }
  returnAST = value_AST;
 }
 
 public final void orExpr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  AST orExpr_AST = null;
  
  try {      // for error handling
   andExpr();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop54:
   do {
    if ((LA(1)==OR)) {
     AST tmp5_AST = null;
     tmp5_AST = astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp5_AST);
     match(OR);
     andExpr();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop54;
    }
    
   } while (true);
   }
   orExpr_AST = (AST)currentAST.root;
  }
  catch (RecognitionException ex) {
   reportError(ex);
   recover(ex,_tokenSet_1);
  }
  returnAST = orExpr_AST;
 }
 
 public final void andExpr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  AST andExpr_AST = null;
  
  try {      // for error handling
   bitIncOr();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop57:
   do {
    if ((LA(1)==AND)) {
     AST tmp6_AST = null;
     tmp6_AST = astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp6_AST);
     match(AND);
     bitIncOr();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop57;
    }
    
   } while (true);
   }
   andExpr_AST = (AST)currentAST.root;
  }
  catch (RecognitionException ex) {
   reportError(ex);
   recover(ex,_tokenSet_2);
  }
  returnAST = andExpr_AST;
 }
 
 public final void bitIncOr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  AST bitIncOr_AST = null;
  
  try {      // for error handling
   bitExcOr();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop60:
   do {
    if ((LA(1)==BIT_INC_OR)) {
     AST tmp7_AST = null;
     tmp7_AST = astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp7_AST);
     match(BIT_INC_OR);
     bitExcOr();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop60;
    }
    
   } while (true);
   }
   bitIncOr_AST = (AST)currentAST.root;
  }
  catch (RecognitionException ex) {
   reportError(ex);
   recover(ex,_tokenSet_3);
  }
  returnAST = bitIncOr_AST;
 }
 
 public final void bitExcOr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  AST bitExcOr_AST = null;
  
  try {      // for error handling
   bitAnd();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop63:
   do {
    if ((LA(1)==BIT_EXC_OR)) {
     AST tmp8_AST = null;
     tmp8_AST = astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp8_AST);
     match(BIT_EXC_OR);
     bitAnd();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop63;
    }
    
   } while (true);
   }
   bitExcOr_AST = (AST)currentAST.root;
  }
  catch (RecognitionException ex) {
   reportError(ex);
   recover(ex,_tokenSet_4);
  }
  returnAST = bitExcOr_AST;
 }
 
 public final void bitAnd() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  AST bitAnd_AST = null;
  
  try {      // for error handling
   equal();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop66:
   do {
    if ((LA(1)==BIT_AND)) {
     AST tmp9_AST = null;
     tmp9_AST = astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp9_AST);
     match(BIT_AND);
     equal();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop66;
    }
    
   } while (true);
   }
   bitAnd_AST = (AST)currentAST.root;
  }
  catch (RecognitionException ex) {
   reportError(ex);
   recover(ex,_tokenSet_5);
  }
  returnAST = bitAnd_AST;
 }
 
 public final void equal() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  AST equal_AST = null;
  
  try {      // for error handling
   compare();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop70:
   do {
    if ((LA(1)==EQUAL||LA(1)==NOT_EQUAL)) {
     {
     switch ( LA(1)) {
     case EQUAL:
     {
      AST tmp10_AST = null;
      tmp10_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp10_AST);
      match(EQUAL);
      break;
     }
     case NOT_EQUAL:
     {
      AST tmp11_AST = null;
      tmp11_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp11_AST);
      match(NOT_EQUAL);
      break;
     }
     default:
     {
      throw new NoViableAltException(LT(1), getFilename());
     }
     }
     }
     compare();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop70;
    }
    
   } while (true);
   }
   equal_AST = (AST)currentAST.root;
  }
  catch (RecognitionException ex) {
   reportError(ex);
   recover(ex,_tokenSet_6);
  }
  returnAST = equal_AST;
 }
 
 public final void compare() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  AST compare_AST = null;
  
  try {      // for error handling
   shift();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop74:
   do {
    if (((LA(1) >= LT && LA(1) <= GT))) {
     {
     switch ( LA(1)) {
     case LT:
     {
      AST tmp12_AST = null;
      tmp12_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp12_AST);
      match(LT);
      break;
     }
     case LE:
     {
      AST tmp13_AST = null;
      tmp13_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp13_AST);
      match(LE);
      break;
     }
     case GE:
     {
      AST tmp14_AST = null;
      tmp14_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp14_AST);
      match(GE);
      break;
     }
     case GT:
     {
      AST tmp15_AST = null;
      tmp15_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp15_AST);
      match(GT);
      break;
     }
     default:
     {
      throw new NoViableAltException(LT(1), getFilename());
     }
     }
     }
     shift();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop74;
    }
    
   } while (true);
   }
   compare_AST = (AST)currentAST.root;
  }
  catch (RecognitionException ex) {
   reportError(ex);
   recover(ex,_tokenSet_7);
  }
  returnAST = compare_AST;
 }
 
 public final void shift() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  AST shift_AST = null;
  
  try {      // for error handling
   addition();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop78:
   do {
    if ((LA(1)==LSHIFT||LA(1)==RSHIFT)) {
     {
     switch ( LA(1)) {
     case LSHIFT:
     {
      AST tmp16_AST = null;
      tmp16_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp16_AST);
      match(LSHIFT);
      break;
     }
     case RSHIFT:
     {
      AST tmp17_AST = null;
      tmp17_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp17_AST);
      match(RSHIFT);
      break;
     }
     default:
     {
      throw new NoViableAltException(LT(1), getFilename());
     }
     }
     }
     addition();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop78;
    }
    
   } while (true);
   }
   shift_AST = (AST)currentAST.root;
  }
  catch (RecognitionException ex) {
   reportError(ex);
   recover(ex,_tokenSet_8);
  }
  returnAST = shift_AST;
 }
 
 public final void addition() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  AST addition_AST = null;
  
  try {      // for error handling
   multiplication();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop82:
   do {
    if ((LA(1)==PLUS||LA(1)==MINUS)) {
     {
     switch ( LA(1)) {
     case PLUS:
     {
      AST tmp18_AST = null;
      tmp18_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp18_AST);
      match(PLUS);
      break;
     }
     case MINUS:
     {
      AST tmp19_AST = null;
      tmp19_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp19_AST);
      match(MINUS);
      break;
     }
     default:
     {
      throw new NoViableAltException(LT(1), getFilename());
     }
     }
     }
     multiplication();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop82;
    }
    
   } while (true);
   }
   addition_AST = (AST)currentAST.root;
  }
  catch (RecognitionException ex) {
   reportError(ex);
   recover(ex,_tokenSet_9);
  }
  returnAST = addition_AST;
 }
 
 public final void multiplication() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  AST multiplication_AST = null;
  
  try {      // for error handling
   unary();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop86:
   do {
    if (((LA(1) >= MULTIPLY && LA(1) <= REMAINDER))) {
     {
     switch ( LA(1)) {
     case MULTIPLY:
     {
      AST tmp20_AST = null;
      tmp20_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp20_AST);
      match(MULTIPLY);
      break;
     }
     case DIVIDE:
     {
      AST tmp21_AST = null;
      tmp21_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp21_AST);
      match(DIVIDE);
      break;
     }
     case REMAINDER:
     {
      AST tmp22_AST = null;
      tmp22_AST = astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp22_AST);
      match(REMAINDER);
      break;
     }
     default:
     {
      throw new NoViableAltException(LT(1), getFilename());
     }
     }
     }
     unary();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop86;
    }
    
   } while (true);
   }
   multiplication_AST = (AST)currentAST.root;
  }
  catch (RecognitionException ex) {
   reportError(ex);
   recover(ex,_tokenSet_10);
  }
  returnAST = multiplication_AST;
 }
 
 public final void unary() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  AST unary_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case RAW_IDENTIFIER:
   case DEC_INT:
   case HEX_INT:
   case OCT_INT:
   case PLUS:
   case MINUS:
   case COMPLIMENT:
   {
    {
    switch ( LA(1)) {
    case PLUS:
    {
     AST tmp23_AST = null;
     tmp23_AST = astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp23_AST);
     match(PLUS);
     break;
    }
    case MINUS:
    {
     AST tmp24_AST = null;
     tmp24_AST = astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp24_AST);
     match(MINUS);
     break;
    }
    case COMPLIMENT:
    {
     AST tmp25_AST = null;
     tmp25_AST = astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp25_AST);
     match(COMPLIMENT);
     break;
    }
    case RAW_IDENTIFIER:
    case DEC_INT:
    case HEX_INT:
    case OCT_INT:
    {
     break;
    }
    default:
    {
     throw new NoViableAltException(LT(1), getFilename());
    }
    }
    }
    value();
    astFactory.addASTChild(currentAST, returnAST);
    unary_AST = (AST)currentAST.root;
    break;
   }
   case NOT:
   {
    AST tmp26_AST = null;
    tmp26_AST = astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp26_AST);
    match(NOT);
    unary();
    astFactory.addASTChild(currentAST, returnAST);
    unary_AST = (AST)currentAST.root;
    break;
   }
   case LPAREN:
   {
    match(LPAREN);
    orExpr();
    astFactory.addASTChild(currentAST, returnAST);
    match(RPAREN);
    unary_AST = (AST)currentAST.root;
    break;
   }
   default:
    if ((LA(1)==DEFINED) && (LA(2)==LPAREN)) {
     AST tmp29_AST = null;
     tmp29_AST = astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp29_AST);
     match(DEFINED);
     match(LPAREN);
     AST tmp31_AST = null;
     tmp31_AST = astFactory.create(LT(1));
     astFactory.addASTChild(currentAST, tmp31_AST);
     match(RAW_IDENTIFIER);
     match(RPAREN);
     unary_AST = (AST)currentAST.root;
    }
    else if ((LA(1)==DEFINED) && (LA(2)==RAW_IDENTIFIER)) {
     AST tmp33_AST = null;
     tmp33_AST = astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp33_AST);
     match(DEFINED);
     AST tmp34_AST = null;
     tmp34_AST = astFactory.create(LT(1));
     astFactory.addASTChild(currentAST, tmp34_AST);
     match(RAW_IDENTIFIER);
     unary_AST = (AST)currentAST.root;
    }
   else {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   reportError(ex);
   recover(ex,_tokenSet_0);
  }
  returnAST = unary_AST;
 }
 
 
 public static final String[] _tokenNames = {
  "<0>",
  "EOF",
  "<2>",
  "NULL_TREE_LOOKAHEAD",
  "RAW_IDENTIFIER",
  "INT_SUFFIX",
  "DEC_DIGITS",
  "HEX_PREFIX",
  "HEX_DIGITS",
  "OCT_PREFIX",
  "OCT_DIGITS",
  "DEC_INT",
  "HEX_INT",
  "OCT_INT",
  "WS",
  "LPAREN",
  "RPAREN",
  "PLUS",
  "MINUS",
  "MULTIPLY",
  "DIVIDE",
  "REMAINDER",
  "COMPLIMENT",
  "LSHIFT",
  "RSHIFT",
  "BIT_AND",
  "BIT_INC_OR",
  "BIT_EXC_OR",
  "OR",
  "AND",
  "EQUAL",
  "NOT_EQUAL",
  "NOT",
  "LT",
  "LE",
  "GE",
  "GT",
  "DEFINED",
  "BAND",
  "BOR"
 };
 
 protected void buildTokenTypeASTClassMap() {
  tokenTypeToASTClassMap=null;
 };
 
 private static final long[] mk_tokenSet_0() {
  long[] data = { 133139726336L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
 private static final long[] mk_tokenSet_1() {
  long[] data = { 65536L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
 private static final long[] mk_tokenSet_2() {
  long[] data = { 268500992L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
 private static final long[] mk_tokenSet_3() {
  long[] data = { 805371904L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
 private static final long[] mk_tokenSet_4() {
  long[] data = { 872480768L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
 private static final long[] mk_tokenSet_5() {
  long[] data = { 1006698496L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
 private static final long[] mk_tokenSet_6() {
  long[] data = { 1040252928L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
 private static final long[] mk_tokenSet_7() {
  long[] data = { 4261478400L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
 private static final long[] mk_tokenSet_8() {
  long[] data = { 133110497280L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
 private static final long[] mk_tokenSet_9() {
  long[] data = { 133135663104L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
 private static final long[] mk_tokenSet_10() {
  long[] data = { 133136056320L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
 
 }
