<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
import com.thalesgroup.ccm.codegenerator.container.cpp.Facet_hpp
%>

<%script type="idlmm.InterfaceDef" name="filePath" post="trim()"%>
<%generatedCOPIFacetServantClassname%>.hpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.InterfaceDef" name="COPIFacet_hpp" file="<%filePath%>"%>
<%copyrightHeader%>

<%openIfndefMacro(generatedCOPIFacetServantFullClassname)%>

<%genIncludeCdmwCifSkelFile%>
   
#include <Foundation/orbsupport/RefCountServantBase.hpp>
#include <Foundation/logging/CdmwLogging.stub.hpp>
#include <CCMContainer/ccmcif/LifeCycleObjectBase.hpp>
   
#include "<%generatedFacetServantClassname%>.hpp"
   
<%openNamespace(generatedPackage)%>

   // Forward declaration
   class CCMObject_impl;

<%closeNamespace(generatedPackage)%>

<%openNamespace(generatedCOPIFacetServantPackage)%>

    class <%generatedCOPIFacetServantClassname%> : virtual public <%generatedFacetServantClassname%>
    {
        public:
            <%generatedCOPIFacetServantClassname%>(
                Components::ExecutorLocator_ptr exec_locator, 
                const std::string& name,
                Context* ctx,
                CORBA::Object_ptr           comp_ref,
                PortableServer::Servant     component,
                CdmwLogging::Logger_ptr     logger,
                const std::string& comp_id
                );

            ~<%generatedCOPIFacetServantClassname%>() throw();

            <%--
                Create operation declarations for attributes.
                NOTA: This should also include inherited attributes.
            --%>
            <%allAttributes.genAttributeOperations.sep("\n\n")%>
             
            <%--
                Create operation declarations.
                NOTA: This should also include inherited operations.
            --%>
            <%allOperations.genOperationDef.sep("\n\n")%>


        private:
            <%generatedCOPIFacetServantClassname%>(const <%generatedCOPIFacetServantClassname%>&);
            void operator=(const <%generatedCOPIFacetServantClassname%>&);


            Context * m_context;
            const std::string m_component_identity;
        };

<%closeNamespace(generatedCOPIFacetServantPackage)%>

<%closeIfndefMacro(generatedCOPIFacetServantFullClassname)%>


