<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.java.Names
import com.thalesgroup.ccm.codegenerator.container.java.SessionContext
%>


<%script type="idlmm.ComponentDef" name="javaFilePath" post="trim()"%>
<%generatedContextPackage.replaceAll("\.", "/")%>/<%generatedExtensionContextClassname%>.java


<%--
  -- Generation template  
  --%>
<%script type="idlmm.ComponentDef" name="ExtensionContext" file="<%javaFilePath%>"%>
<%copyrightHeader%>

package <%generatedContextPackage%>;

import cdmw.orbsupport.ExceptionMinorCodes;
import cdmw.ccm.cif.ExtensionContextImpl;
import cdmw.ccm.common.CCMLoggers;
import static cdmw.logging.Logger.*;
import static cdmw.logging.FunctionLogger.*;

public class <%generatedExtensionContextClassname%> extends ExtensionContextImpl
    implements <%generatedExtensionContextInterface%> {

    /**
     * Component servant implementation
     */
    private <%generatedExtensionServantClassname%> component;
    
    /**
     * Logger for logging
     */
    com.thalesgroup.CdmwLogging.Logger logger;

    public <%generatedExtensionContextClassname%>(
        org.omg.Components.CCMContext ctx,
        <%generatedExtensionServantClassname%> component,
        com.thalesgroup.CdmwLogging.LoggerFactory loggerFactory) 
    {
        super(ctx, component.get_component_identity(), loggerFactory);
        this.logger = loggerFactory.get_logger(
            cdmw.ccm.common.CCMLoggers.CCMGENERATED_LOG_DOMAIN);
        
        CDMW_LOG_FUNCTION(logger, "");
            
        this.component = component;
    }

    <%--
        Uses ports.
    --%>

    <%allUsesPorts.genUsesCode%>
    

    <%--
        Emitters.
    --%>
    
    <%allEmitsPorts.genEventPortCode%>

    <%--
        Publishers.
    --%>
    
    <%allPublishesPorts.genEventPortCode%>

}

