<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.container.CommonServices

import com.thalesgroup.ccm.codegenerator.container.java.SessionHome
import com.thalesgroup.ccm.codegenerator.container.java.SessionComponent
import com.thalesgroup.ccm.codegenerator.container.java.SessionContext
import com.thalesgroup.ccm.codegenerator.container.java.ExtensionHome
import com.thalesgroup.ccm.codegenerator.container.java.ExtensionComponent
import com.thalesgroup.ccm.codegenerator.container.java.ExtensionContext
import com.thalesgroup.ccm.codegenerator.container.java.Facet
import com.thalesgroup.ccm.codegenerator.container.java.Consumer
import com.thalesgroup.ccm.codegenerator.container.java.COPIFacet
import com.thalesgroup.ccm.codegenerator.container.java.COPIReceptacle
%>

<%script type="idlmm.Repository" name="GenerateAll"%>
<%-- store Repository in context --%>
<%put("Repository")%>

<%-- get all homes from model and store in context --%>
<%eAllContents("idlmm.Home").put("AllHomes")%>

<%-- iterate over selected homes --%>
<%for (selectedHomes){%>
    
    <%-- store selected home --%>
    <%put("selectedHome")%>
    <%trace("selectedHome")%>
    
    <%-- Search in all homes the selected one and store it in context--%>
    <%for (get("AllHomes")){%>
        <%if (absoluteName == get("selectedHome")){%>
            <%push()%>
        <%}%>
    <%}%>
    
    <%peek.trace("foundHome")%>

    <%if (peek == ""){%>
        HOME NOT FOUND: <%get("selectedHome")%>
    
    <%}else{%>
        <%-- Always generate code for session container --%>
         <%-- generate home code --%>
            <%peek.trace("generate Session Home")%>
           <%peek.SessionHome%>
           <%-- generate component code --%>
            <%peek.managedComponent.trace("generate Session Component")%>
           <%peek.managedComponent.SessionComponent%>
           <%-- generate context code --%>
            <%peek.managedComponent.trace("generate Session Context")%>
           <%peek.managedComponent.SessionContext%>
    
        <%if (getContainerType == "EXTENSION"){%>
             <%-- generate home code --%>
                <%peek.trace("generate Extension Home")%>
               <%peek.ExtensionHome%>
               <%-- generate component code --%>
                <%peek.managedComponent.trace("generate Extension Component")%>
               <%peek.managedComponent.ExtensionComponent%>
               <%-- generate context code --%>
                <%peek.managedComponent.trace("generate Extension Context")%>
               <%peek.managedComponent.ExtensionContext%>
        <%}%>
    
        <%-- generate all facets code --%>
            <%peek.managedComponent.allProvidesPorts.interface_type.trace("generate Facets")%>
        <%peek.managedComponent.allProvidesPorts.interface_type.Facet%>
        <%-- generate all consumers code --%>
            <%peek.managedComponent.allConsumesPorts.event.trace("generate Consumers")%>
        <%peek.managedComponent.allConsumesPorts.event.Consumer%>
    
        <%-- generate all facets code (with interception) --%>
            <%peek.managedComponent.allProvidesPorts.interface_type.trace("generate COPIFacets")%>
        <%peek.managedComponent.allProvidesPorts.interface_type.COPIFacet%>
        <%-- generate all receptacle code (with interception) --%>
            <%peek.managedComponent.allUsesPorts.interface_type.trace("generate COPIReceptacles")%>
        <%peek.managedComponent.allUsesPorts.interface_type.COPIReceptacle%>
    
        <%-- remove selected home from context --%>
        <%pop()%>
    <%}%>
    
<%}%>

