<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.container.Utils
%>

<%-- 
  -- Constants prefix for Cardamom specific generated types
  --%>
<%script type="idlmm.IRObject" name="generatedPrefix" post="trim()"%>
thalesgroup.com

<%script type="idlmm.IRObject" name="generatedPrefixPackage" post="trim()"%>
com.thalesgroup

<%script type="idlmm.IRObject" name="generatedPackage" post="trim()"%>
Cdmw.CCM.CIF


<%-- 
  -- Scripts for HomeDef
  --%>

<%-- equivalent IDL2 external interface --%>
<%script type="idlmm.HomeDef" name="equivalentInterface" post="trim()"%>
    <%javaFullClassname%>
    
<%-- equivalent IDL2 local interface for executor --%>
<%script type="idlmm.HomeDef" name="equivalentLocalInterface" post="trim()"%>
    <%javaPackage%>.CCM_<%name%>
    
<%-- generated IDL2 container interface --%>
<%script type="idlmm.HomeDef" name="generatedContainerInterface" post="trim()"%>
    <%generatedPrefixPackage%>.Cdmw_<%javaPackageNoPrefix%>.<%name%>

<%-- generated servant package --%>
<%script type="idlmm.HomeDef" name="generatedServantPackage" post="trim()"%>
    <%generatedPackage%>.Cdmw<%javaPackageNoPrefix%>
    
<%-- generated servant classname (SESSION) --%>
<%script type="idlmm.HomeDef" name="generatedSessionServantClassname" post="trim()"%>
    Session<%name%>_impl

<%-- generated servant classname (EXTENSION) --%>
<%script type="idlmm.HomeDef" name="generatedExtensionServantClassname" post="trim()"%>
    Extension<%name%>_impl



<%-- 
  -- Scripts for ComponentDef
  --%>

<%-- equivalent IDL2 external interface --%>
<%script type="idlmm.ComponentDef" name="equivalentInterface" post="trim()"%>
    <%javaFullClassname%>
    
<%-- equivalent IDL2 local interface for executor --%>
<%script type="idlmm.ComponentDef" name="equivalentLocalInterface" post="trim()"%>
    <%javaPackage%>.CCM_<%name%>
    
<%-- generated servant package --%>
<%script type="idlmm.ComponentDef" name="generatedServantPackage" post="trim()"%>
    <%generatedPackage%>.Cdmw<%javaPackageNoPrefix%>
    
<%-- generated servant classname (SESSION) --%>
<%script type="idlmm.ComponentDef" name="generatedSessionServantClassname" post="trim()"%>
    Session<%name%>Impl

<%-- generated servant full classname (SESSION) --%>
<%script type="idlmm.ComponentDef" name="generatedSessionServantFullClassname" post="trim()"%>
    <%generatedServantPackage%>.<%generatedSessionServantClassname%>

<%-- generated servant classname (EXTENSION) --%>
<%script type="idlmm.ComponentDef" name="generatedExtensionServantClassname" post="trim()"%>
    Extension<%name%>Impl

<%-- generated servant full classname (EXTENSION) --%>
<%script type="idlmm.ComponentDef" name="generatedExtensionServantFullClassname" post="trim()"%>
    <%generatedServantPackage%>.<%generatedExtensionServantClassname%>


<%-- 
  -- Scripts for Component Context
  --%>
  
<%-- generated IDL2 local interface for session context --%>
<%script type="idlmm.ComponentDef" name="generatedSessionContextInterface" post="trim()"%>
    <%generatedPrefixPackage%>.Cdmw_<%javaPackageNoPrefix%>.CCM_<%name%>_SessionContext
    
<%-- generated IDL2 local interface for extension context --%>
<%script type="idlmm.ComponentDef" name="generatedExtensionContextInterface" post="trim()"%>
    <%generatedPrefixPackage%>.Cdmw_<%javaPackageNoPrefix%>.CCM_<%name%>_ExtensionContext
    
<%-- generated context package --%>
<%script type="idlmm.ComponentDef" name="generatedContextPackage" post="trim()"%>
    <%generatedPackage%>.Cdmw<%javaPackageNoPrefix%>
    
<%-- generated context classname (SESSION) --%>
<%script type="idlmm.ComponentDef" name="generatedSessionContextClassname" post="trim()"%>
    CCM_<%name%>_SessionContextImpl

<%-- generated context classname (EXTENSION) --%>
<%script type="idlmm.ComponentDef" name="generatedExtensionContextClassname" post="trim()"%>
    CCM_<%name%>_ExtensionContextImpl



<%-- 
  -- Scripts for Provides ports
  --%>

<%-- equivalent IDL2 local interface for executor --%>
<%script type="idlmm.Interface" name="equivalentLocalInterface" post="trim()"%>
    <%javaPackage%>.CCM_<%name%>
    
<%-- generated IDL2 container interface --%>
<%script type="idlmm.Interface" name="generatedContainerInterface" post="trim()"%>
    <%generatedPrefixPackage%>.Cdmw_<%javaPackageNoPrefix%>.<%name%>

<%-- generated servant package --%>
<%script type="idlmm.Interface" name="generatedFacetServantPackage" post="trim()"%>
    <%generatedPackage%>.<%javaPackage%>
    
<%-- generated servant classname --%>
<%script type="idlmm.Interface" name="generatedFacetServantClassname" post="trim()"%>
    <%name%>Impl

<%-- generated servant full classname --%>
<%script type="idlmm.Interface" name="generatedFacetServantFullClassname" post="trim()"%>
    <%generatedFacetServantPackage%>.<%generatedFacetServantClassname%>

<%-- generated servant (with interception) package --%>
<%script type="idlmm.Interface" name="generatedCOPIFacetServantPackage" post="trim()"%>
    <%generatedPackage%>.<%javaPackage%>
    
<%-- generated servant (with interception) classname --%>
<%script type="idlmm.Interface" name="generatedCOPIFacetServantClassname" post="trim()"%>
    Facet<%name%>Impl

<%-- generated servant (with interception) full classname --%>
<%script type="idlmm.Interface" name="generatedCOPIFacetServantFullClassname" post="trim()"%>
    <%generatedCOPIFacetServantPackage%>.<%generatedCOPIFacetServantClassname%>


<%-- 
  -- Scripts for Receptacle ports
  --%>

<%-- generated receptacle object (with interception) package --%>
<%script type="idlmm.Interface" name="generatedCOPIReceptaclePackage" post="trim()"%>
    <%generatedPackage%>.<%javaPackage%>
    
<%-- generated receptacle object (with interception) classname --%>
<%script type="idlmm.Interface" name="generatedCOPIReceptacleClassname" post="trim()"%>
    Receptacle<%name%>Impl

<%-- generated receptacle object (with interception) full classname --%>
<%script type="idlmm.Interface" name="generatedCOPIReceptacleFullClassname" post="trim()"%>
    <%generatedCOPIReceptaclePackage%>.<%generatedCOPIReceptacleClassname%>



<%-- 
  -- Scripts for Consumers
  --%>

<%-- equivalent IDL2 external consumer interface --%>
<%script type="idlmm.Event" name="equivalentConsumer" post="trim()"%>
    <%javaFullClassname%>Consumer
    
<%-- equivalent IDL2 local consumer interface --%>
<%script type="idlmm.Event" name="equivalentLocalConsumer" post="trim()"%>
    <%javaPackage%>.CCM_<%name%>Consumer

<%-- generated IDL2 interface for consumer --%>
<%script type="idlmm.Event" name="generatedConsumerInterface" post="trim()"%>
    <%generatedPrefixPackage%>.Cdmw_<%javaPackageNoPrefix%>.<%name%>Consumer
    
<%-- generated consumer servant package --%>    
<%script type="idlmm.Event" name="generatedConsumerPackage" post="trim()"%>
    <%generatedPackage%>.Cdmw<%javaPackageNoPrefix%>
    
<%-- generated consumer servant classname --%>  
<%script type="idlmm.Event" name="generatedConsumerClassname" post="trim()"%>
    <%name%>ConsumerImpl
    
<%script type="idlmm.Event" name="generatedConsumerFullClassname" post="trim()"%>
    <%generatedConsumerPackage%>.<%generatedConsumerClassname%>

<%--
  -- Scripts for COPI
  --%>
<%script type="idlmm.OperationDef" name="generatedCOPIRequestClassname" post="trim()"%>
   <%name%>Request
   
 
