<%
metamodel http://www.prismtech.com/idlmm
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
%>


<%-- Scripts for operations generation --%> 
<%script type="idlmm.OperationDef" name="genOperationSignature" post="trim()"%>
<%type.asReturnParameterDef%> <%name%>(<%parameters.genParameterDef.sep(", ")%>)
    <%if (exceptions.nSize > 0){%>
    throws <%exceptions.javaFullClassname.sep(", ")%>
    <%}%>

<%script type="idlmm.ParameterDef" name="genParameterType" post="trim()"%>
<%if (mode == "PARAM_IN"){%>
    <%type.asInParameterDef%>
<%}else if (mode == "PARAM_INOUT"){%>
    <%type.asInoutParameterDef%>
<%}else if (mode == "PARAM_OUT"){%>
    <%type.asOutParameterDef%>
<%}%>

<%script type="idlmm.ParameterDef" name="genParameterDef" post="trim()"%>
    <%genParameterType%> <%name%>

<%script type="idlmm.InitializerParameterDef" name="genParameterDef" post="trim()"%>
    <%type.asInParameterDef%> <%name%>


    