<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.lifecycle.LifeCycleServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.ModelServices
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.container.Utils
%>


<%script type="idlmm.Repository" name="javaFilePath" post="trim()"%>
<%if (servantProviderClassnameScope.length() > 0){%>
<%directoryPrefix%><%servantProviderClassnameScope.replaceAll("\.", "/")%>/<%servantProviderClassname%>.java
<%}else{%>
<%directoryPrefix%><%servantProviderClassname%>.java
<%}%>



<%--
  -- If directory attribute is specified for the <program>,
  -- this script returns the directory +"/"
  --%>
<%script type="idlmm.Repository" name="directoryPrefix" post="trim()"%>
<%if (servantProviderDirectory.length > 0){%>
<%servantProviderDirectory%>/
<%}%>



<%--
  -- Generation template  
  -- This template is not model-based (idlmm.Repository is just specified
  -- to access InterfaceDef data)
  -- All is based on LifeCycleServices which provides access to loaded data
  -- from XML file.
  --%>
<%script type="idlmm.Repository" name="ServantProvider" file="<%javaFilePath%>"%>
<%copyrightHeader%>

<%if (servantProviderClassnameScope.length() > 0){%>
package <%servantProviderClassnameScope%>;
<%}%>

public abstract class <%servantProviderClassname%>
    extends cdmw.lifecycle.ServantProviderBase {


    /**
     * IDs
     */
    private final static String[] ids = {
        "<%idlInterface.getAllReturnedInterfaces.ID.sep("\",\n        \"")%>"
    };


    <%--
        Create the operations definitions.
    --%>
    <%for (idlInterface.findAllFactoryOperations){%>
    <%generateOperation%>
    
    <%}%>

    /**
     * Returns the list of IDs
     *
     * @return The list of IDs as a string table
     */
    protected String[] getIds() {
        return ids;
    }

    /**
     * Returns the number of IDs
     *
     * @return The number of IDs
     */
    protected int getNumberOfIds() {
        return ids.length;
    }

}



<%script type="idlmm.OperationDef" name="generateOperation"%>
public abstract byte[] <%name%>(<%parameters[mode == "PARAM_IN"].genParameterDef.sep(", ")%>)
    throws 
        <%for (exceptions){%>
        <%javaFullClassname%>,
        <%}%>
        org.omg.CORBA.SystemException;
     
