/*
 * Copyright (c) 2005-2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.eval.imports.services;

import org.acceleo.engine.context.EvalContext;

/**
 * A service that needs the current evaluation context to work should implement
 * this interface. WARRNING NEVER USE WITH IThreadSafeService.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public interface IContextService {
	/**
	 * Setter for the evaluation context.
	 * 
	 * @param evalContext
	 *            the current evaluation context
	 */
	public void setEvalContext(EvalContext evalContext);
}
