/*
 * Copyright (c) 2005-2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.eval.imports.services;

/**
 * This Interface can be *implemented* by a class that is thread safe. It means
 * that the services can be run in multi-threaded environment, typically the
 * class has no fields or fields have there own locks, and there are no static
 * references. It allows performance improvement. WARRNING NEVER USE WITH
 * IContextService.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public interface IThreadSafeService {
	// nothing to declare
}
